2005-12-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fset_window_configuration): Don't accidentally copy the
	window-point of one window to another.

2005-11-30  L$,1 q(Brentey K,Aa(Broly  <lorentey@elte.hu>

	* buffer.c (Fpop_to_buffer): Remove superfluous call to record_buffer.

2005-11-30  Kim F. Storm  <storm@cua.dk>

	* alloc.c: Include fcntl.h.  Define O_WRONLY if not defined.
	(valid_lisp_object_p) [!GC_MARK_STACK]: Validate pointer by
	passing it to `emacs_write'.

2005-11-29  Ari Roponen  <arjuropo@cc.jyu.fi>  (tiny change)

	* atimer.c (stop_other_atimers): Fix loop to correctly compute `prev'.

2005-11-27  Richard M. Stallman  <rms@gnu.org>

	* window.c (adjust_window_trailing_edge): New function.
	(Fadjust_window_trailing_edge): New function.
	(syms_of_window): Defsubr it.
	(window_deletion_count): New variable.
	(delete_window): Update window_deletion_count.

2005-11-26  Eli Zaretskii  <eliz@gnu.org>

	* minibuf.c (syms_of_minibuf): Mention the extension of
	`completion-auto-help's meaning by complete.el.

2005-11-26  Henrik Enberg  <henrik.enberg@telia.com>

	* xfaces.c (Finternal_set_lisp_face_attribute_from_resource):
	Handle :inherit property as a lisp expression.

2005-11-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (Qcontrol): Rename from Qctrl.  All uses changed.
	(syms_of_macterm): Staticpro Qcontrol, Qmeta, Qalt, Qhyper,
	Qsuper, and Qmodifier_value.
	(Vmac_control_modifier, Vmac_option_modifier)
	(Vmac_command_modifier, Vmac_function_modifier)
	(Vmac_emulate_three_button_mouse, Vmac_wheel_button_is_mouse_2)
	(Vmac_pass_command_to_system, Vmac_pass_control_to_system)
	(Vmac_charset_info_alist): Doc fixes.

2005-11-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (main) [MAC_OSX]: Change working directory to home
	directory if `-psn_*' option is specified.

	* mac.c (DECODE_UTF_8): Remove macro.
	[TARGET_API_MAC_CARBON] (cfstring_to_lisp_nodecode): New function
	created from cfstring_to_lisp.
	[TARGET_API_MAC_CARBON] (cfstring_to_lisp): Use it.
	(xrm_get_preference_database) [TARGET_API_MAC_CARBON]: Likewise.

	* macterm.h (cfstring_to_lisp_nodecode) [TARGET_API_MAC_CARBON]:
	Add prototype.

2005-11-21  Ken Raeburn  <raeburn@mit.edu>

	* keymap.c (shadow_lookup): Use make_number to pass a number to
	Fsubstring.

2005-11-21  Juri Linkov  <juri@jurta.org>

	* puresize.h (BASE_PURESIZE): Increment to 1180000.

2005-11-20  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (Finternal_set_lisp_face_attribute):
	Use :ignore-defface for new frame defaults when `unspecified' is
	supplied.
	(Finternal_get_lisp_face_attribute): Hide :ignore-defface.
	(merge_face_vectors): Don't do :ignore-defface overwriting here.
	(Finternal_merge_in_global_face): Do it here.

2005-11-20  Juri Linkov  <juri@jurta.org>

	* charset.c (invalid_character): Use Lisp-readable syntax
	for octal and hex.  Reorder decimal, octal and hex values.

2005-11-20  Nick Roberts  <nickrob@snap.net.nz>

	* lisp.h: Use typedef when Lisp_Object is EMACS_INT so that
	this type is recognised when debugging.

2005-11-19  Andreas Schwab  <schwab@suse.de>

	* .gdbinit (nextcons, xcdr, xfloat): Update for changes in
	Lisp_Cons and Lisp_Float.

2005-11-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [USE_CG_TEXT_DRAWING] (cg_text_anti_aliasing_threshold):
	New variable.
	[USE_CG_TEXT_DRAWING] (init_cg_text_anti_aliasing_threshold): New fun.
	(init_font_name_table) [USE_ATSUI && USE_CG_TEXT_DRAWING]: Use it.
	[USE_CG_TEXT_DRAWING] (mac_draw_string_cg): Don't do antialiasing if
	font size is smaller than or equal to cg_text_anti_aliasing_threshold.

2005-11-17  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (x_create_bitmap_from_xpm_data): Free attributes on fail.

	* xfaces.c (Qignore_defface): New variable.
	(syms_of_xfaces): Provide `:ignore-defface'.
	(IGNORE_DEFFACE_P): New macro.
	(check_lface_attrs, lface_fully_specified_p)
	(Finternal_set_lisp_face_attribute)
	(Fface_attribute_relative_p, Fmerge_face_attribute):
	Handle Qignore_defface as a possible value.
	(merge_face_vectors): The merged face is `unspecified' if the
	mergee specifies `:ignore-defface'.

2005-11-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (readevalloop): Add missing GCPROs.

2005-11-16  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (xg_set_icon_from_xpm_data): New function.

	* gnu.h (gnu_xpm_bits): Rename from gnu_bits.
	(gnu_xbm_bits): Rename from gnu_bits (xbm version).

	* xterm.c (x_bitmap_icon): Use the xpm if available.

	* image.c (x_create_bitmap_from_xpm_data): New function.
	(x_create_bitmap_from_xpm_data): Initialize XpmAttributes.

2005-11-15  Luc Teirlinck  <teirllm@auburn.edu>

	* Makefile.in (lisp, shortlisp): Add rfn-eshadow.

2005-11-16  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit: Make SIGTSTP work like SIGINT normally does.

2005-11-15  Andreas Schwab  <schwab@suse.de>

	* lisp.h (struct Lisp_Cons): Make cdr a union.
	(XCDR_AS_LVALUE): Adjust.
	(struct Lisp_Float): Make data a union.
	(XFLOAT_DATA): Adjust.

	* alloc.c (free_float): Make free list chaining aliasing-safe.
	(make_float): Likewise.
	(free_cons): Likewise.
	(Fcons): Likewise.
	(check_cons_list): Likewise.
	(Fmake_symbol): Likewise.
	(allocate_misc): Likewise.
	(free_misc): Likewise.
	(gc_sweep): Likewise.

2005-11-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (HASHKEY_QUERY_CACHE): New define.
	(xrm_create_database, xrm_q_put_resource): Empty query cache.
	(xrm_get_resource): Use query cache.

	* image.c (init_image) [MAC_OS]: Don't call EnterMovies if
	inhibit_window_system is set.

2005-11-13  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (USE_CG_TEXT_DRAWING): New define.
	(struct MacFontStruct) [USE_CG_TEXT_DRAWING]: New members cg_font
	and cg_glyphs.

	* macterm.c [USE_CG_TEXT_DRAWING] (mac_draw_string_cg): New function.
	(x_draw_glyph_string_foreground) [USE_CG_TEXT_DRAWING]: Use it.
	(XLoadQueryFont) [USE_CG_TEXT_DRAWING]: Set members cg_font and
	cg_glyphs in struct MacFontStruct if synthesized bold or italic is
	not used and font substitution never occurs for ASCII and Latin-1
	characters.
	(XLoadQueryFont): Maximum and minimum metrics are now those among
	ASCII characters.
	(XLoadQueryFont) [!MAC_OS8 || USE_ATSUI]: Apply WebKit-style
	height adjustments for Courier, Helvetica, and Times.

	* s/darwin.h (LIBS_CARBON) [!HAVE_CARBON]: Remove `-framework Carbon'.

2005-11-11  David Reitter <david.reitter@gmail.com>

	* macterm.c (syms_of_macterm): Remove macCtrlKey, macShiftKey,
	macMetaKey, macAltKey. Introduce Qctrl, Qmeta,
	Vmac_control_modifier / mac-control-modifier,
	Vmac_option_modifier / mac-option-modifier,
	Vmac_command_modifier / mac-command-modifier.
	(mac_to_emacs_modifiers): Use the new style modifier
	variables.  Return UInt32 (modifiers are longs now.)
	(backtranslate_modified_keycode): New function (refactoring).
	(XTread_socket): Use new modifier variables and refactored function.
	(mac_determine_quit_char_modifiers): Remove macMetaKey (there is
	no dedicated meta key.  Not in use anyway.)
	(convert_fn_keycode): Map Fn-keys to their original keycode
	using a table (english keyboard only).

2005-11-11  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (pitx): Fix output format if n_overlay_strings > 0.
	Add post hook to "backtrace" to always dump lisp call stack to
	increase chance of people sending it to us when reporting bugs.

	* doc.c (Fsubstitute_command_keys): Doc fix.

	* dispextern.h (struct it): New member ignore_overlay_strings_at_pos_p.

	* xdisp.c (handle_stop): Skip overlay string handling if
	ignore_overlay_strings_at_pos_p is set.
	(set_iterator_to_next): At end of display vector, set
	ignore_overlay_strings_at_pos_p if dpvec came from an overlay
	string, so we skip those overlay strings at current pos.

2005-11-10  Lars Hansen <larsh@soem.dk>

	* fileio.c (file-regular-p): Doc fix.

2005-11-10  Kim F. Storm  <storm@cua.dk>

	* alloc.c (valid_lisp_object_p): New function to validate that
	an object is really a valid Lisp_Object.

	* lisp.h (valid_lisp_object_p): Add prototype.

	* print.c (safe_debug_print): New function to be called from gdb
	to print Lisp objects; use valid_lisp_object_p to avoid crashing
	if user tries to print something which is not a Lisp object.

	* .gdbinit (pp, pp1): Use safe_debug_print.
	(pv, pv1): New commands to print value of a lisp variable.

2005-11-10  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit (pp1): New user-defined function.

2005-11-09  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OSX] (image_load_quartz2d): Fix memory leak.

	* mac.c [MAC_OSX] (init_mac_osx_environment): Reinitialize locale
	related variables for dumped executable.

	* unexmacosx.c (unexec_write_zero): New function.
	(copy_data_segment): Clear uninitialized local variables in
	statically linked libraries.

	* s/darwin.h (C_SWITCH_SYSTEM): Remove -fno-common.

2005-11-09  Juri Linkov  <juri@jurta.org>

	* keymap.c (shadow_lookup): If Flookup_key returns a number,
	call it again with a sub-key-sequence, and if its return value
	is non-nil (sub-key is bound), return nil.

2005-11-08  Kim F. Storm  <storm@cua.dk>

	* process.c (Fsignal_process): Recognize signal names with and
	without SIG prefix, e.g. SIGHUP and HUP.

	* search.c (search_buffer): No need to initialize base_pat.

2005-11-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fget_lru_window, Fget_largest_window, window_loop):
	Don't abuse the `mini' arg.  Use the `obj' arg instead.

2005-11-04  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (show_mouse_face): Clear mouse face to eol.

2005-11-03  Dan Nicolaescu  <dann@ics.uci.edu>

	* Makefile.in (lisp, shortlisp): Add emacs-lisp/syntax.elc,
	font-lock.elc and jit-lock.elc.

2005-11-03  Richard M. Stallman  <rms@gnu.org>

	* window.c (Fenlarge_window): Rename SIDE to HORIZONTAL.
	(enlarge_window): Rename WIDTHFLAG to HORIZ_FLAG.
	(CURBEG, CURSIZE): Use HORIZ_FLAG instead of WIDTHFLAG.

	* sheap.c (STATIC_HEAP_SIZE): Increment both definitions.

	* alloc.c (refill_memory_reserve): Move decl out of conditionals.

2005-11-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fdisplay_buffer): Fix last change to not use
	a dedicated window.

2005-11-01  Kim F. Storm  <storm@cua.dk>

	* fringe.c (update_window_fringes): Undo 2005-10-27 change.
	Instead, rotate the bottom angle bitmap 180 degrees to indicate
	that the bottom row does not end in a newline.

2005-11-01  Andreas Schwab  <schwab@suse.de>

	* unexelf.c (unexec): Handle .plt section in BSS segment.

2005-11-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (readevalloop): Yet another int/Lisp_Object mixup (YAILOM).

	* window.c (window_loop): For LRU and LARGEST, let the `mini' argument
	determine whether to consider dedicated windows as well.
	(Fget_lru_window, Fget_largest_window): Add `dedicated' argument.
	(Fdisplay_buffer): Do consider dedicated windows in those cases where
	we will split the window rather than reuse it.
	Don't try to use windows on other displays.

2005-10-31  Dan Nicolaescu  <dann@ics.uci.edu>

	* puresize.h (BASE_PURESIZE): Increment to 1170000.

2005-10-31  Romain Francoise  <romain@orebokech.com>

	* macfns.c: Update copyright year.
	* m/gould.h: Likewise.

2005-10-30  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_line): Restore it->current_x and call
	extend_face_to_end_of_line when last glyph doesn't fit on line.
	(set_glyph_string_background_width): Remove specific tests  here
	to see if face background should extend to end of line.  Simplify.

2005-10-30  Richard M. Stallman  <rms@gnu.org>

	* alloc.c (BYTES_USED): Use uordblks, not arena.
	(bytes_used_when_reconsidered): New variable.
	(emacs_blocked_free): Set that.

2005-10-29  Chong Yidong  <cyd@stupidchicken.com>

	* alloc.c (emacs_blocked_free): Fix typo.

2005-10-29  Richard M. Stallman  <rms@gnu.org>

	* data.c (Fmake_variable_frame_local): Doc fix.

	* xdisp.c (handle_fontified_prop): Do nothing if memory full.
	(format_mode_line_unwind_data): New arg SAVE_PROPTRANS
	controls whether to save and restore mode_line_proptrans_alist.
	Callers changed.
	(unwind_format_mode_line): Work with that feature.
	(redisplay_internal): Don't call prepare_menu_bars if memory full.
	(move_elt_to_front): New function.
	(display_mode_element): Use move_elt_to_front.
	Don't bother munging text props on a null string.
	Delete obsolete elts from mode_line_proptrans_alist.
	(decode_mode_spec): Test Vmemory_full, not spare_memory.
	(Fformat_mode_line): Clear mode_line_proptrans_alist after saving.

	* lisp.h (memory_full_cons_threshold): Declare.
	(internal_lisp_condition_case): Declare.

	* alloc.c (syms_of_alloc) <memory-full>: Doc fix.
	(Fmemory_full_p): Function deleted.
	(syms_of_alloc): Don't defsubr it.
	(memory_full_cons_threshold): New variable.
	(spare_memory): Now a vector of 7 elts.
	(buffer_memory_full): Don't set Vmemory_full here.
	(xfree): Don't try to refill here.
	(emacs_blocked_free): Record BYTES_USED in local var.
	(memory_full): Now free all the slots in spare_memory.
	(refill_memory_reserve): Allocate each slot in spare_memory.
	(init_alloc_once): Call refill_memory_reserve.

	* keyboard.c (command_loop_1): Don't set Vmemory_full here.

	* eval.c (internal_lisp_condition_case): New function.
	(Fcondition_case): Use internal_lisp_condition_case.
	(Feval): Test Vmemory_full and memory_full_cons_threshold.
	(Ffuncall): Likewise.

	* bytecode.c (Fbyte_code): Use internal_lisp_condition_case.

2005-10-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (Fparse_partial_sexp): Fix docstring.

2005-10-28  Romain Francoise  <romain@orebokech.com>

	* puresize.h (BASE_PURESIZE): Increment to 1130000.

2005-10-28  Richard M. Stallman  <rms@gnu.org>

	* xfns.c (syms_of_xfns): Provide `x' as feature.

	* xdisp.c (decode_mode_spec): Define %e to indicate memory full.

	* editfns.c (Fformat): Don't include string padding
	between info[n].start and info[n].end.

	* alloc.c (spare_memory): No longer static.
	(xfree) [!SYSTEM_MALLOC]: Call refill_memory_reserve.

	* puresize.h (BASE_PURESIZE): Increment to 1120000.

2005-10-27  Chong Yidong  <cyd@stupidchicken.com>

	* data.c (Fmake_variable_frame_local): Add clarification to docstring.

	* fringe.c (update_window_fringes): Handle case where buffer ends
	with a newline.

2005-10-27  Kenichi Handa  <handa@m17n.org>

	* coding.h (DECODE_SYSTEM): Fix argument name; name->str.

2005-10-24  Kenichi Handa  <handa@m17n.org>

	* charset.h (charset_mule_unicode_0100_24ff)
	(charset_mule_unicode_2500_33ff, charset_mule_unicode_e000_ffff):
	Extern them.

	* charset.c (charset_mule_unicode_0100_24ff)
	(charset_mule_unicode_2500_33ff, charset_mule_unicode_e000_ffff):
	New variables.
	(Fsetup_special_charsets): Initialize them.

	* xterm.c (handle_one_xevent): Handle keysyms directly mapped to
	supported Unicode characters.

2005-10-25  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (w32_to_x_font): Avoid forcing font widths.

2005-10-25  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OS] (image_load_qt_1): Check image size.
	Use GraphicsImportGetImageDescription instead of
	GraphicsImportGetNaturalBounds.
	[MAC_OSX] (image_load_quartz2d): Check image size.
	[MAC_OS] (xpm_load_image): Likewise.

	* macterm.c (last_mouse_glyph_frame): New var.
	(note_mouse_movement): Say mouse moved if current frame differs
	from last_mouse_glyph_frame, and update last_mouse_glyph_frame.
	(XTmouse_position): Set last_mouse_glyph_frame.
	(XTread_socket): Clear last_mouse_glyph_frame on mouse up/down event.
	(mac_draw_string_common) [USE_ATSUI && WORDS_BIG_ENDIAN]: Fix typo.
	Use EndianU16_BtoN.
	(mac_draw_string_common) [MAC_OSX]: Don't use ATSUClearLayoutControls.
	(x_per_char_metric, XLoadQueryFont)
	[MAC_OS_X_VERSION_MAX_ALLOWED < 1020]: Use device origins to get
	glyph bounds.
	(mac_to_x_fontname, mac_do_list_fonts)
	(mac_initialize_display_info): Change screen resolutions to 72dpi.

2005-10-25  Masatake YAMATO  <jet@gyve.org>

	* minibuf.c (Fdisplay_completion_list): Small doc fix.

2005-10-24  Kim F. Storm  <storm@cua.dk>

	* xterm.c: Undo 2005-10-23 change.
	(last_mouse_glyph_frame): New var.
	(note_mouse_movement): Say mouse moved if current frame differs
	from last_mouse_glyph_frame, and update last_mouse_glyph_frame.
	(XTmouse_position): Set last_mouse_glyph_frame.
	(handle_one_xevent): Clear last_mouse_glyph_frame [instead of
	last_mouse_glyph] on mouse up/down event.

	* editfns.c (Fcompare_buffer_substrings): Fix last change.

2005-10-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* editfns.c (Fcompare_buffer_substrings): Handle multibyte chars.

2005-10-23  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (note_mouse_movement): Always call note_mouse_highlight
	so tool tips don't interfere with press on tool bar button.

2005-10-23  Richard M. Stallman  <rms@gnu.org>

	* casetab.c (Fset_case_table): Doc fix.

	* lread.c (build_load_history): Replace STREAM arg with ENTIRE.
	(readevalloop): Compute ENTIRE properly.
	(syms_of_lread) <load-history>: Doc fix.

2005-10-21  Richard M. Stallman  <rms@gnu.org>

	* lread.c (Fload): Simplify gcpro structure.
	Gcpro FOUND as well as FILE, but not EFOUND.
	Unless preloading, record FOUND instead of FILE in Vload_history.
	Rename repeat local FILE to MSG_FILE.
	(syms_of_lread) <load-history>: Doc fix.

2005-10-21  Kenichi Handa  <handa@m17n.org>

	* search.c (boyer_moore): Add parens to fix and/or precedence bug.

2005-10-20  Kim F. Storm  <storm@cua.dk>

	* buffer.c (clone_per_buffer_values): Remove unused var tem.
	(init_buffer): Remove unused vars dotstat, pwdstat.

	* ccl.c (check_ccl_update): Remove unused var vp.

	* fileio.c (auto_save_error): Call SAFE_FREE.

	* fns.c (Fchar_table_range): Remove unused var i.

	* minibuf.c (display_completion_list_1): New wrapper function
	for Fdisplay_completion_list.
	(Fminibuffer_completion_help): Use it.

	* term.c (encode_terminal_code): Remove unused var src_start.

	* window.c (Fwindow_tree): Remove unused var alist.

	* xterm.c (x_calc_absolute_position): Remove unused vars win_x, win_y.

2005-10-20  Aubrey Jaffer  <agj@alum.mit.edu>  (tiny change)

	* unexelf.c (unexec): Fix calls to `fatal' with less than 3 arguments.

2005-10-20  Olli Savia  <ops@iki.fi>  (tiny change)

	* syssignal.h [__Lynx__]: Undef SIGPOLL along with SIGIO.

2005-10-20  Andreas Schwab  <schwab@suse.de>

	* minibuf.c (Fdisplay_completion_list): Doc fix.

2005-10-19  Kim F. Storm  <storm@cua.dk>

	* image.c (check_image_size): Handle integer Vmax_image_size value
	directly as max pixel value.  Use default frame size for null frame.
	(syms_of_image) <max-image-size>: Describe integer value.

2005-10-19  Romain Francoise  <romain@orebokech.com>

	* emacs.c (main): Update copyright year.

2005-10-18  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (Vmax_image_size): New variable.
	(check_image_size): New function.
	(xbm_read_bitmap_data, pbm_load, png_load, jpeg_load, tiff_load)
	(gif_load, gs_load): Use it.
	(lookup_image): Try loading again if previous load failed.
	(xbm_read_bitmap_data): Add a new argument, a pointer to the frame
	to display in, NULL if none.
	(xbm_load_image, xbm_file_p): Pass xbm_read_bitmap_data the new
	argument.

2005-10-18  Richard M. Stallman  <rms@gnu.org>

	* search.c (Fstring_match): Doc fix.

2005-10-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (note_mouse_movement): Use PtInRect.
	(XTread_socket): Also ignore mouse motion just before a button
	release event.  Don't process button release event when mouse is
	not grabbed.

2005-10-16  Masatake YAMATO  <jet@gyve.org>

	* minibuf.c (Fdisplay_completion_list): Add new optional
	argument COMMON_SUBSTRING.  Bind `completion-common-substring'
	to the optional argument during running `completion-setup-hook'.

2005-10-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [TARGET_API_MAC_CARBON] (get_cfstring_encoding_from_lisp):
	Allow nil as argument.
	 [TARGET_API_MAC_CARBON] (Fmac_code_convert_string): Regard nil
	for encoding arguments as UTF-16 in native byte order, no BOM.

	* macfns.c (Fx_create_frame): Add debugging code.
	(Fx_show_tip): Set frame pixel width and height.

	* macterm.c (MAC_WINDOW_NORMAL_GC): Remove macro.
	(FRAME_NORMAL_GC): New macro.
	(mac_draw_line, mac_clear_area, mac_clear_window)
	(mac_fill_rectangle, mac_draw_string, mac_draw_string_16)
	(mac_draw_image_string, mac_draw_image_string_16): Rename from
	XDrawLine, XClearArea, XClearWindow, XFillRectangle, XDrawString,
	XDrawString16, XDrawImageString, and XDrawImageString16, respectively.
	All uses changed.
	(mac_draw_line, mac_erase_rectangle, mac_clear_area)
	(mac_clear_window, mac_draw_bitmap, mac_draw_rectangle)
	(mac_invert_rectangle, mac_draw_string_common, mac_draw_string)
	(mac_draw_string_16, mac_draw_image_string)
	(mac_draw_image_string_16, mac_copy_area, mac_copy_area_with_mask)
	(mac_scroll_area): Drawing functions now take frame as destination.
	All uses changed.
	(mac_draw_string_common): Get port height with FRAME_PIXEL_HEIGHT.
	(x_draw_fringe_bitmap): Set clipping area in face->gc.

	* macterm.h (mac_clear_area): Add extern.

2005-10-14  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (note_mouse_movement, XTread_socket): Apply 2005-10-14
	changes for xterm.c.

	* w32term.c (note_mouse_movement, w32_read_socket): Likewise.

2005-10-14  Kenichi Handa  <handa@m17n.org>

	* search.c (search_buffer): Give up BM search on case-fold-search
	if one of a target character has a case-equivalence of different
	charset even if that target charcter is an ASCII.

	* casefiddle.c (casify_object): Fix for the case that case
	conversion change the byte length.

2005-10-14  Kim F. Storm  <storm@cua.dk>

	* xterm.c (note_mouse_movement): Return 1 if mouse moved; 0 otherwise.
	(handle_one_xevent): Only clear help_echo_string; restore it if
	note_mouse_movement didn't record any mouse movement.

	* xdisp.c (pos_visible_p): Convert w->hscroll to pixels before use.
	(remember_mouse_glyph): Clear RECT if mouse is over an image glyph.

	* keyboard.c (make_lispy_position): Adjust wx for left margin if ON_TEXT.
	(Fposn_at_x_y): Fix calculation of x coordinate.
	(Fposn_at_point): Return nil if point is hscrolled out of view.

2005-10-13  Andreas Schwab  <schwab@suse.de>

	* sysdep.c (request_sigio, unrequest_sigio): Do nothing in
	non-interactive mode.

2005-10-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xterm.c, w32term.c, macterm.c (note_mouse_movement): Undo last change.

2005-10-12  Kim F. Storm  <storm@cua.dk>

	* xterm.c (handle_one_xevent): Clear last_mouse_glyph on mouse up/down.

2005-10-12  Romain Francoise  <romain@orebokech.com>

	* buffer.c (init_buffer): Rename `rc' to `len' for clarity.

2005-10-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (remember_mouse_glyph): Use MATRIX_BOTTOM_TEXT_ROW to
	get end of text rows.  Obtain header-line/mode-line rows directly.

	* xterm.c, w32term.c, macterm.c (note_mouse_movement):
	Restore help_echo_string if mouse is moved inside last_mouse_glyph.

2005-10-12  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (remember_mouse_glyph): New generic version based on
	glyph_rect and remember_mouse_glyph from xterm.c enhanced to
	properly handle all different window areas.

	* dispextern.h (remember_mouse_glyph): Add prototype.

	* xterm.c (glyph_rect, remember_mouse_glyph): Remove X versions.
	(note_mouse_movement, XTmouse_position): Use generic
	remember_mouse_glyph, add last_mouse_glyph arg.

	* w32term.c (note_mouse_movement): Fix last_mouse_glyph check.
	(glyph_rect, remember_mouse_glyph): Remove w32 specific versions.
	(note_mouse_movement, w32_mouse_position): Use generic
	remember_mouse_glyph, add last_mouse_glyph arg.

	* macterm.c (note_mouse_movement): Add call to remember_mouse_glyph.
	(glyph_rect, remember_mouse_glyph): Remove mac specific versions.
	(XTmouse_position): Adapt to use generic remember_mouse_glyph
	instead of pixel_to_glyph_coords.

	* window.c (coordinates_in_window): Fix x position for ON_RIGHT_MARGIN.
	Fix x position for ON_TEXT when left margin width > 0.

2005-10-11  Kim F. Storm  <storm@cua.dk>

	* window.c (coordinates_in_window): Fix y position for ON_SCROLL_BAR.

	* keyboard.c (make_lispy_position): Fix buffer calculations for
	mouse click or movement in right fringe and the margins.

2005-10-11  Juanma Barranquero  <lekktu@gmail.com>

	* image.c (fn_jpeg_stdio_src): Don't define it.
	(init_jpeg_functions): Don't initialize `fn_jpeg_stdio_src'.
	(our_common_init_source): Rename from `our_init_source'.
	(our_common_term_source): Rename from `our_term_source'.
	(our_memory_fill_input_buffer): Rename from
	`our_fill_input_buffer'.
	(our_memory_skip_input_data): Rename from `our_skip_input_data'.
	(jpeg_memory_src): Use the new names.
	(struct jpeg_stdio_mgr): New struct.
	(JPEG_STDIO_BUFFER_SIZE): New constant.
	(our_stdio_fill_input_buffer, our_stdio_skip_input_data)
	(jpeg_file_src): New functions.
	(jpeg_load): Use `jpeg_file_src' instead of `fn_jpeg_stdio_src'.

2005-10-11  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (PER_CHAR_METRIC): Remove unused macro.
	(fm_font_family_alist): New variable.
	(syms_of_macterm): Initialize and staticpro it.
	(decode_mac_font_name): Replace '-' in family name with '_' if it
	occurs just once.  Lower family name.
	(parse_x_font_name): Rename from x_font_name_to_mac_font_name.
	All uses changed.  Remove argument MF and code conversion for it.
	Add argument SIZE.  Rename argument MF_DECODED to FAMILY, and CS
	to CHARSET.  Parse font size.  Lower family name.  Return integer
	value for status of parsing.
	(init_font_name_table) [USE_ATSUI]: Use decode_mac_font_name.
	Don't use Fdowncase because family name is already lowered by
	decode_mac_font_name.
	(init_font_name_table): Always call decode_mac_font_name.
	Add pair of family name and its reference to fm_font_family_alist.
	(mac_clear_font_name_table): Clear fm_font_family_alist.
	(XLoadQueryFont): Move font size parsing part to parse_x_font_name.
	Lookup fm_font_family_alist to get font family reference.
	(XLoadQueryFont) [USE_ATSUI]: Don't use Fdowncase because family
	name is already lowered by parse_x_font_name.

2005-10-11  Kim F. Storm  <storm@cua.dk>

	* xterm.c (glyph_rect): Return 0 if position is outside text area.

	* keyboard.c (make_lispy_position): Fix buffer position calculation for
	mouse click or movement in fringe.

2005-10-10  Jason Rumney  <jasonr@gnu.org>

	* xterm.c (remember_mouse_glyph): New function.
	(note_mouse_movement): Use it to remember the current glyph if changed.
	(XTmouse_position): Fix calculation of fake glyph under mouse.
	Move code to calculate glyph under mouse into remember_mouse_glyph.

2005-10-10  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* emacs.c (USAGE3, standard_args): -nb => -nbi.

2005-10-10  Juanma Barranquero  <lekktu@gmail.com>

	* frame.c (Fredirect_frame_focus): Fix typos in docstring.
	(next_frame, prev_frame, set_term_frame_name): Make static.

	* window.c (Fwindow_tree): Fix spelling.

2005-10-09  Romain Francoise  <romain@orebokech.com>

	* window.c (Fwindow_end): Don't try to redisplay if non-interactive.

2005-10-09  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* emacs.c (standard_args): Remove options -i, -itype, --icon-type.
	Add options -nb, --no-bitmap-icon.

	* xfns.c (Fx_create_frame): Make bitmapIcon have default on.

2005-10-08  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (MAX_CLIP_RECTS): New define.
	(struct _XGC): New member clip_region.
	(struct _XGC) [MAC_OSX && USE_ATSUI]: New members n_clip_rects and
	clip_rects.

	* macterm.c (GC_CLIP_REGION): New macro.
	(saved_port_clip_region): New variable.
	(mac_begin_clip, mac_end_clip): New functions.
	(XDrawLine, mac_erase_rectangle, mac_draw_bitmap, XFillRectangle)
	(mac_draw_rectangle, mac_draw_string_common, mac_copy_area)
	(mac_copy_area_with_mask, mac_scroll_area): Use them.
	(mac_set_clip_rectangle, mac_reset_clipping): Remove functions.
	[USE_ATSUI] (atsu_get_text_layout_with_text_ptr)
	[MAC_OS_X_VERSION_MAX_ALLOWED < 1020]: Specify kATSLineFractDisable.
	(mac_draw_string_common) [MAC_OSX && USE_ATSUI]: Clip to clipping
	rectangles stored in gc.
	(XFreeGC): Dispose of clipping region.
	(mac_set_clip_rectangles, mac_reset_clip_rectangles): New functions.
	(x_draw_fringe_bitmap, x_set_glyph_string_clipping)
	(x_draw_relief_rect, x_draw_box_rect, x_draw_stretch_glyph_string)
	(x_draw_glyph_string, x_clip_to_row, x_draw_hollow_cursor)
	(x_draw_bar_cursor): Use them.
	(x_set_glyph_string_clipping): Use get_glyph_string_clip_rects to
	get multiple clipping rectangles.

	* macterm.h (mac_term_init): Add types to extern.
	(struct mac_output): Remove members mWP and pending_menu_activation.
	Put members scroll_bar_foreground_pixel and
	scroll_bar_background_pixel in #if 0.
	(FRAME_MAC_WINDOW, FRAME_X_WINDOW): Use window_desc.

	* xfaces.c (x_create_gc, x_free_gc) [MAC_OS]: Add BLOCK_INPUT.
	Add debugging code.

2005-10-08  Kim F. Storm  <storm@cua.dk>

	* window.c (window_tree, Fwindow_tree): Rename fns added 2005-10-04.

2005-10-07  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (redraw_overlapped_rows, redraw_overlapping_rows)
	[!HAVE_WINDOW_SYSTEM]: Don't declare them...
	(update_window) [!HAVE_WINDOW_SYSTEM]: ...and don't call them.

2005-10-07  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispextern.h (struct glyph_string): Rename member for_overlaps_p
	to for_overlaps.  Now occupy 3 bits.
	(OVERLAPS_PRED, OVERLAPS_SUCC, OVERLAPS_BOTH)
	(OVERLAPS_ERASED_CURSOR): New defines.
	(struct redisplay_interface): Add new OVERLAPS arg to member
	fix_overlapping_area.
	(x_fix_overlapping_area): Add new OVERLAPS arg.
	(get_glyph_string_clip_rects): Add extern.

	* dispnew.c (redraw_overlapping_rows):
	Call rif->fix_overlapping_area with new OVERLAPS arg as redrawn part.

	* xdisp.c: Rename member for_overlaps_p in struct glyph_string to
	for_overlaps.
	(get_glyph_string_clip_rects): New function created from
	get_glyph_string_clip_rect.  Set clipping rectangles according to the
	value of for_overlaps.  Enable to store multiple clipping rectangles.
	(get_glyph_string_clip_rect): Use get_glyph_string_clip_rects.
	(fill_composite_glyph_string, fill_glyph_string, draw_glyphs):
	Rename argument OVERLAPS_P to OVERLAPS.  All uses in macros changed.
	(x_fix_overlapping_area): Add OVERLAPS arg.  Pass it to draw_glyphs.
	(draw_phys_cursor_glyph): Set width of erased cursor to use it for
	calculating clipping rectangles later.  Call x_fix_overlapping_area
	with new OVERLAPS arg to draw only erased cursor area.
	(expose_overlaps): Call x_fix_overlapping_area with new OVERLAPS arg
	to draw overlaps in both preceding and succeeding rows.

	* xterm.c, w32term.c, macterm.c: Rename member for_overlaps_p in
	struct glyph_string to for_overlaps.

2005-10-04  Richard M. Stallman  <rms@gnu.org>

	* alloc.c (refill_memory_reserve): Conditionalize the body,
	not the function's existence.

2005-10-04  Kim F. Storm  <storm@cua.dk>

	* window.c (window_split_tree): New function.
	(Fwindow_split_tree): New defun.
	(syms_of_window): Defsubr it.

2005-10-04  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_invert_rectangle): New function.
	(XTflash): Use it.

2005-10-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* regex.h (re_char): Don't expose it in the interface.
	(re_set_whitespace_regexp): Adjust the arg's type to not use it.

	* regex.c (re_char): Move it back here.
	(re_set_whitespace_regexp): Change the arg's type to not use it.

	* keyboard.c (make_lispy_event): If point has moved between down and up
	event, make it a drag, not a click, to mirror what
	mouse-drag-region expects.

2005-10-02  Dan Nicolaescu  <dann@ics.uci.edu>

	* lisp.h (fatal): Undo previous change.
	* term.c (fatal): Undo previous change.

2005-10-01  Richard M. Stallman  <rms@gnu.org>

	* xfaces.c (face_color_gray_p): Colors close to black count as gray.

2005-10-01  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (try_window): Skip scroll-margin check if ZV is visible.

2005-10-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c (init_keyboard) [MAC_OSX]: Don't install SIGINT handler.

	* macfns.c (start_hourglass): Apply 2005-05-07 change for xfns.c.
	(x_create_tip_frame) [GLYPH_DEBUG]: Uncomment debugging code.
	(Fx_create_frame, x_create_tip_frame) [USE_ATSUI]:
	Try ATSUI-compatible 12pt Monaco font first.

	* macgui.h (struct _XCharStruct): New member valid_p.
	(STORE_XCHARSTRUCT): Set valid_p.
	(struct MacFontStruct) [USE_ATSUI]: New member mac_style.

	* macterm.c (mac_draw_string_common, x_per_char_metric)
	(mac_compute_glyph_string_overhangs, init_font_name_table)
	(XLoadQueryFont, mac_unload_font) [USE_ATSUI]: Add ATSUI support.
	(atsu_get_text_layout_with_text_ptr) [USE_ATSUI]: New function.
	(x_draw_glyph_string_background)
	(x_draw_glyph_string_foreground) [MAC_OS8 && USE_ATSUI]: Don't use
	XDrawImageString.  Always draw background and foreground separately.
	(x_draw_glyph_string_foreground) [USE_ATSUI]: Don't use 8-bit
	functions for one-byte chars when using ATSUI-compatible fonts.
	(atsu_font_id_hash) [USE_ATSUI]: New variable.
	(syms_of_macterm) [USE_ATSUI]: Initialize and staticpro it.
	(XLoadQueryFont): Set min_byte1, max_byte1, min_char_or_byte2, and
	max_char_or_byte2 more in detail.
	(quit_char_comp, mac_check_for_quit_char) [MAC_OSX]: Remove functions.

2005-09-30  Dan Nicolaescu  <dann@ics.uci.edu>

	* image.c (slurp_file, xbm_read_bitmap_data): Cast to the correct type.
	* xterm.c (handle_one_xevent, handle_one_xevent): Likewise.

	* unexelf.c (fatal): Fix prototype.

	* term.c (fatal): Implement using varargs.

	* regex.c (re_char): Move typedef ...
	* regex.h (re_char): ... here.
	(re_iswctype, re_wctype, re_set_whitespace_regexp): New prototypes.

	* emacs.c (malloc_set_state): Fix return type.
	(endif): Fix type.

	* lisp.h (fatal): Add argument types.

	* dispextern.h (fatal): Delete prototype.

	* systime.h: (make_time): Prototype moved from ...
	* editfns.c (make_time): ... here.

	* editfns.c: Move systime.h include after lisp.h.
	* dired.c:
	* xsmfns.c:
	* process.c: Likewise.

	* alloc.c (old_malloc_hook, old_realloc_hook, old_realloc_hook):
	Add parameter types.
	(__malloc_hook, __realloc_hook, __free_hook): Fix prototypes.
	(emacs_blocked_free): Change definition to match __free_hook.
	(emacs_blocked_malloc): Change definition to match __malloc_hook.
	(emacs_blocked_realloc): Change definition to match __realloc_hook.

2005-09-30  Romain Francoise  <romain@orebokech.com>

	* minibuf.c (Fread_buffer): Follow convention for reading from the
	minibuffer with a default value.  Doc fix.

2005-09-29  Juri Linkov  <juri@jurta.org>

	* editfns.c (Fmessage, Fmessage_box, Fmessage_or_box):
	Rename argument name `string' to `format-string'.
	(Fformat): Doc fix.

2005-09-28  Kim F. Storm  <storm@cua.dk>

	* image.c (gif_load): Fix size of allocated image buffer
	for images where a sub-image may be larger than the image's
	total height/width specifications.

2005-09-28  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (struct _XCharStruct): Each member now takes short value.

2005-09-27  Dan Nicolaescu  <dann@ics.uci.edu>

	* xfaces.c (lookup_derived_face): Add parameter type.

	* xdisp.c (cursor_row_fully_visible_p): Add parameter type.

	* marker.c (verify_bytepos): Add parameter type.

	* process.c (get_operating_system_release): Move prototype ...

	* systime.h (get_operating_system_release): ... here.

	* xterm.c (handle_one_xevent): Refer to union field to match the
	type required by the function definition.
	(set_vertical_scroll_bar): Move prototype ...

	* xterm.h: ... here.

	* fns.c (internal_equal, seed_random): Fix prototypes.
	(internal_equal): Add missing parameter.

2005-09-25  Richard M. Stallman  <rms@gnu.org>

	* keyboard.c (update_menu_bindings): Variable deleted.
	(syms_of_keyboard): Don't defvar it.
	(parse_menu_item): Don't test it.

2005-09-23  Richard M. Stallman  <rms@gnu.org>

	* editfns.c (Fformat): Explicitly test for end of format string
	and don't use `index'.

2005-09-23  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/aix4-2.h (BROKEN_GET_CURRENT_DIR_NAME):
	Define BROKEN_GET_CURRENT_DIR_NAME.

	* sysdep.c (get_current_dir_name): Also define if
	BROKEN_GET_CURRENT_DIR_NAME.

	* m/ibmrs6000.h: Test for USG5, not USG5_4.

2005-09-22  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (message_dolog): Add warning about GC and Lisp strings.
	(message2): Fix commentary.  Ok to use alloca'ed memory.
	Still not ok to use Lisp string data (because of GC).
	(set_message): Add comment why GC cannot happen.

2005-09-22  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (xlfdpat_block_match_1): Fix assertion.
	(init_font_name_table) [TARGET_API_MAC_CARBON]: Don't add style
	variants for a scalable font multiple times.

2005-09-21  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* process.c (create_process) [RTU || UNIPLUS || DONT_REOPEN_PTY]:
	Setup slave tty options before forking.

2005-09-20  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_set_geometry): Do a gtk_window_move if program
	positions have been set for the frame (as is done for frames in
	special-display-buffer-names).

2005-09-19  Kim F. Storm  <storm@cua.dk>

	* editfns.c (Fformat): Don't scan past end of format string that
	ends in %.  Reported by: Johan Bockg,Ae(Brd.

2005-09-18  Andreas Schwab  <schwab@suse.de>

	* window.h (struct window): Remove height_fixed_p, no longer set.

	* window.c (make_window): Don't initialize height_fixed_p.
	(window_fixed_size_p): Don't use it.

2005-09-18  John Paul Wallington  <jpw@pobox.com>

	* data.c (Fdefalias): Signal an error if SYMBOL is not a symbol.

2005-09-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (SOME_MACHINE_OBJECTS): Undo previous change.

	* macfns.c (image_cache_refcount, dpyinfo_refcount) [GLYPH_DEBUG]:
	New variables.
	[TARGET_API_MAC_CARBON] (Fx_file_dialog): Don't allow multiple
	file selection.

	* sysdep.c [MAC_OS8]: Don't include stdlib.h.  Include sys/param.h.

2005-09-17  Eli Zaretskii  <eliz@gnu.org>

	* Makefile.in (XMENU_OBJ) [!HAVE_CARBON]: Reinstate variable.
	(obj): Use XMENU_OBJ, not a literal xmenu.o.

2005-09-16  Romain Francoise  <romain@orebokech.com>

	* fileio.c (syms_of_fileio) <write-region-inhibit-fsync>: Doc fix.

2005-09-15  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (overlay_arrow_at_row): Add HAVE_WINDOW_SYSTEM conditional.
	(display_mode_element): Instead of `lisp_string' and `this',
	record `offset' and increment that.
	`last_offset' replaces `last'.

	* Makefile.in (XMENU_OBJ): Variable deleted.
	(obj): Use xmenu.o unconditionally.
	(SOME_MACHINE_OBJECTS): Delete xmenu.o.

	* emacs.c (main): Don't conditionalize syms_of_xmenu on HAVE_XMENU.

2005-09-15  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (move_it_vertically): Don't try to fetch byte BEGV-1.
	(reseat_at_next_visible_line_start): Likewise (in xassert).

2005-09-14  Romain Francoise  <romain@orebokech.com>

	* fileio.c (write_region_inhibit_fsync): New variable.
	(Fwrite_region): Use it to skip call to fsync.
	(syms_of_fileio): Initialize it.

2005-09-14  Kenichi Handa  <handa@m17n.org>

	* coding.c (code_convert_region_unwind): Argument format changed.
	(run_pre_post_conversion_on_str): If pre-write-conversion function
	changed the current buffer, delete the new buffer.
	(run_pre_write_conversin_on_c_str): Likewise.

	* fileio.c (Fexpand_file_name): Check multibyteness of
	default_directory.

2005-09-13  Kenichi Handa  <handa@m17n.org>

	* composite.c (compose_chars_in_text): Delete it.

	* composite.h (compose_chars_in_text): Delete extern.

2005-09-13  Kim F. Storm  <storm@cua.dk>

	* print.c (print_error_message): Fix last change.

2005-09-12  Kim F. Storm  <storm@cua.dk>

	* composite.c (compose_chars_in_text): Fix setup of `pend'.
	Unconditionally reload `ptr' and `pend' after eval.

	* xdisp.c (message3): Pass copy of lisp string to message_dolog.

	* print.c (print_error_message): Pass copy of caller name to
	message_dolog.

	* fileio.c (auto_save_error): Pass copy of lisp string to message2.

2005-09-12  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (display_mode_element): Be sure to make variables THIS
	and LISP_STRING point into a string data of ELT.

2005-09-12  Kim F. Storm  <storm@cua.dk>

	* editfns.c (Ftranslate_region_internal): Reload `tt' after
	signal_after_change that may have GC'ed.
	(Fmessage, Fmessage_box, Fmessage_or_box): Doc fix.

	* keymap.c (Fdescribe_buffer_bindings): Reload `translate'
	after insert while runs signal_after_change.

	* minibuf.c (Fminibuffer_complete_word): Move `completion_string'
	declaration to where it is used.

	* w32.c (check_windows_init_file): Fix allocation of error buffer.

	* xfns.c (x_encode_text): Declare static.  Add FREEP arg.
	(x_set_name_internal): Call x_encode_text with new FREEP arg to
	know if xfree is needed instead of guessing.

	* xterm.h (x_encode_text): Remove prototype.

2005-09-11  Chris Prince  <cprince@gmail.com>  (tiny change)

	* w32term.c (x_bitmap_icon): Load small icons too.

2005-09-10  Romain Francoise  <romain@orebokech.com>

	* buffer.c (init_buffer): Grow buffer to add directory separator
	and terminal zero.  Fix typos.

2005-09-10  Eli Zaretskii  <eliz@gnu.org>

	* buffer.c (init_buffer): Fix error message for failed call to
	get_current_dir_name.
	(get_current_dir_name): Remove prototype.

	* xsmfns.c: (get_current_dir_name): Remove prototype.

	* lisp.h: (get_current_dir_name) [!HAVE_GET_CURRENT_DIR_NAME]:
	Add prototype.

	* sysdep.c [WINDOWSNT]: Add prototype for getwd.
	Don't #undef NULL after including blockinput.h.

	* config.in: Regenerated.

2005-09-10  Giuseppe Scrivano  <gscrivano@gmail.com>

	Remove the MAXPATHLEN limitations:

	* sysdep.c (get_current_dir_name) [!HAVE_GET_CURRENT_DIR_NAME]:
	New function.

	* buffer.c (init_buffer): Use it.

	* xsmfns.c (smc_save_yourself_CB): Ditto.

2005-09-09  Kim F. Storm  <storm@cua.dk>

	* doc.c (Fsubstitute_command_keys): Lookup key binding for
	commands that are remapped from some other command.

	* xdisp.c (try_window_reusing_current_matrix): Clear mode_line_p
	flag in disabled rows below the window.

	* frame.h (struct frame): New member updated_p.

	* xdisp.c (redisplay_internal): Mark updated frames in new updated_p
	member.  Remove local `updated' array and associated variables.

2005-09-07  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (handle_display_prop): Respect overlay window property.

	* xdisp.c (try_window): Remove superfluous cursor_height calculation.
	Fixes crash reported by YAMAMOTO Mitsuharu.

2005-09-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (struct xlfdpat_block, struct xlfdpat): New structs.
	(xlfdpat_destroy, xlfdpat_create, xlfdpat_exact_p)
	(xlfdpat_block_match_1, xlfdpat_match): New functions.
	(xlfdpat_block_match): New macro.
	(mac_to_x_fontname): Don't use tolower for non-ASCII characters.
	(x_font_name_to_mac_font_name): Set coding.dst_multibyte to 0.
	(add_font_name_table_entry): Increase font_name_table_size more
	rapidly.
	(mac_c_string_match): Remove function.
	(mac_do_list_fonts): Use XLFD pattern match instead of regular
	expression match.

	* xfaces.c (xstrlwr): Don't use tolower for non-ASCII characters.

2005-09-03  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (redisplay_internal): Make UPDATED as long as needed.
	(move_it_in_display_line_to): Stop after last char on line even
	on a windowing terminal, if that's the specified stop position.

	* fns.c (Fsort): Doc fix.

	* editfns.c (Fpropertize): Don't insist that properties be symbols.

2005-09-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dired.c (directory_files_internal_unwind, directory_files_internal)
	(file_name_completion): Use a Save_Value object rather than a cons of
	two 16bit ints to store the DIR*.
	(directory_files_internal, file_name_completion): Handle both EINTR and
	EAGAIN consistently after `readdir'.

2005-09-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* intervals.c (update_interval): Add position info in error.

	* dispnew.c (window_to_frame_hpos, update_window):
	Avoid gcc warning about unused variable `f'.

2005-08-31  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (add_menu_item): If unicode_append_menu returns an
	error, revert to using AppendMenu.

2005-08-31  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c (PIX_MASK_DRAW, PIX_MASK_RETAIN): Remove argument.
	All uses changed.
	[MAC_OS] (XPutPixel, XGetPixel): Add efficient versions for common
	cases.
	(x_create_x_image_and_pixmap) [MAC_OS]: Don't call x_destroy_x_image.
	[MAC_OS] (find_image_fsspec) [!MAC_OSX]: Don't use FSRef.
	Use posix_pathname_to_fsspec.
	[MAC_OS] (xpm_load_image): Fill in background_transparent field
	while we have mask.

	* macgui.h [!TARGET_API_MAC_CARBON] (GetPixDepth): New define.

	* macterm.h (PIX_MASK_DRAW, PIX_MASK_RETAIN): Move defines to image.c.

2005-08-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (update_syntax_table): Properly reproduce the special +1
	setting of e_property at the end of the buffer when bumping into the
	INTERVALS_AT_ONCE limit.

2005-08-27  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (USAGE1): Fix the description of the -Q option.

2005-08-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (pos_visible_p): Yet another int/Lisp_Object mixup (YAILOM).

2005-08-26  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (resize_mini_window): Fix 2005-08-20 change.
	Don't move PT to new window start.

2005-08-25  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c (kbd_buffer_get_event) [MAC_OS]: Make events for
	ICONIFY/DEICONIFY_EVENT.

	* macterm.c (mac_copy_area, mac_copy_area_with_mask):
	Restore background color.
	(mac_handle_visibility_change): New function.
	(x_make_frame_invisible, x_iconify_frame)
	(XTread_socket) [!USE_CARBON_EVENTS]: Use it.
	[USE_CARBON_EVENTS] (mac_handle_window_event)
	(install_window_handler): Handle visibility change events.
	(x_make_frame_visible): Don't reposition window if it is iconified
	or asked for visible before.  Select and uncollapse window when it
	is made visible.
	(x_make_frame_invisible): Don't reset x_highlight_frame.
	(x_iconify_frame): Likewise.  Make invisible frame visible before
	it is iconified.
	(read_socket_inev): Move variable outside #if USE_CARBON_EVENTS.
	(do_window_update): Don't change visibility of invisible frame.

2005-08-22  Juri Linkov  <juri@jurta.org>

	* term.c (turn_on_face): Check for TS_set_foreground and
	TS_set_background depending on standout_mode.  Simplify.

2005-08-21  Kim F. Storm  <storm@cua.dk>

	* fringe.c (update_window_fringes): Only put TOP and BOTTOM
	bitmaps on fully visible rows.

	* fringe.c (update_window_fringes): Replace FORCE_P arg with
	KEEP_CURRENT_P arg; if non-zero, don't update current row fringes,
	and return 0.

	* xdisp.c (redisplay_window): Call update_window_fringes with
	KEEP_CURRENT_P non-0 if we are going to refresh fringes later.

2005-08-20  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (display_echo_area_1): Get display start pos from w->start.
	(resize_mini_window): Set w->start, and PT, so as to display the tail
	end of the buffer, if it doesn't all fit.

2005-08-18  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (calc_pixel_width_or_height): Use actual display
	resolution when available instead of Vdisplay_pixels_per_inch.

2005-08-17  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (pos_visible_p): Adjust X value if window is hscrolled.

	* dispnew.c (buffer_posn_from_coords): Check that target row is
	within matrix.

2005-08-16  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (x_wm_set_icon_pixmap): Move GTK specific code to
	xg_set_frame_icon and call it.

	* gtkutil.c (xg_set_frame_icon): New function.

	* gtkutil.h (xg_set_frame_icon): Declare it.

2005-08-16  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (increment_row_positions): Skip non-enabled rows.

	* window.c (SAVED_WINDOW_VECTOR_SIZE): Remove dangerous define.
	(Fcurrent_window_configuration): Use VECSIZE macro instead.

2005-08-15  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (message3_nolog): Clear echo_message_buffer.

2005-08-15  Kim F. Storm  <storm@cua.dk>

	* lisp.h (QUIT) [!SYNC_INPUT]: Throw t to Vthrow_on_input.

	* process.c (deactivate_process, status_notify, read_process_output)
	(update_status, status_convert, decode_status, allocate_pty)
	(make_process, remove_process, list_processes_1)
	(create_process_1, unwind_request_sigio, read_process_output)
	(send_process, keyboard_bit_set): Declare static.
	(Fdelete_process): Simplify.  Pass process to status_notify, so we
	don't try to read output from it.
	(status_notify): New arg deleting_process--don't try to read
	output from that process.

	* lisp.h (deactivate_process, status_notify, read_process_output):
	Remove prototypes.

2005-08-14  Richard M. Stallman  <rms@gnu.org>

	* image.c (syms_of_image): Init Qxbm, Qpbm before calling
	define_image_type.

2005-08-13  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_pixbuf_from_pix_and_mask): New function.
	(xg_get_image_for_pixmap): Move some code to
	xg_get_pixbuf_from_pix_and_mask, and call it.

	* gtkutil.h (xg_get_pixbuf_from_pix_and_mask): Declare.

	* xterm.c (x_wm_set_icon_pixmap): Call xg_get_pixbuf_from_pix_and_mask
	to get an GTK icon and set it with GTK functions to avoid having GTK
	override an icon set with just X functions.

2005-08-11  Richard M. Stallman  <rms@gnu.org>

	* image.c (syms_of_image): Init image_types here, and call
	define_image_type.
	(init_image): Not here.

2005-08-09  Richard M. Stallman  <rms@gnu.org>

	* bytecode.c (BYTE_CODE_QUIT): Throw t to Vthrow_on_input.

	* lisp.h (QUIT): Throw t to Vthrow_on_input.

2005-08-09  Thien-Thi Nguyen  <ttn@gnu.org>

	* floatfns.c (Fexpt): Use floats for negative exponent.

2005-08-08  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_modify_menubar_widgets): Remove semicolon that
	should not be there, causing menu display errors with GTK 2.6.9.

2005-08-07  Richard M. Stallman  <rms@gnu.org>

	* floatfns.c (Fexpt): Undo previous change.

	* dispnew.c (Fframe_or_buffer_changed_p): Take an arg
	so it can be used with various state vectors.

	* emacs.c (endif): Convert -script into -scriptload.
	(standard_args): Add -scriptload.  Allow -basic-display with one dash.

	* fns.c (syms_of_fns): Add `emacs' to features.

	* term.c (set_terminal_modes): If no TS_termcap_modes string,
	output newlines to scroll the old screen contents off the screen.

2005-08-06  Thien-Thi Nguyen  <ttn@gnu.org>

	* floatfns.c (Fexpt): Use floats for negative exponent.
	Reported by D Goel.

2005-08-02  Richard M. Stallman  <rms@gnu.org>

	* frame.c (Fframe_char_width): Doc fix.

2005-07-30  Juanma Barranquero  <lekktu@gmail.com>

	* xdisp.c (syms_of_xdisp) <redisplay-end-trigger-functions>:
	Defvar it.

2005-07-28  Juanma Barranquero  <lekktu@gmail.com>

	* w32fns.c (my_set_window_pos, my_show_window): Don't declare.
	(my_create_window, my_create_tip_window): Make static.

	* w32term.c (my_show_window, my_set_window_pos, my_set_focus)
	(my_set_foreground_window, my_destroy_window): Make static.

2005-07-26  Paul Eggert  <eggert@cs.ucla.edu>

	Merge gnulib getopt implementation into Emacs.

	* s/cygwin.h (C_SWITCH_SYSTEM): Remove, since gettext.h is
	now part of lib-src.

2005-07-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* eval.c (Fdefvar): Allow (defvar enable-multibyte-characters).

2005-07-25  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (w32_menu_display_help): Suppress tooltip when
	navigating menus with the keyboard.

2005-07-23  Richard M. Stallman  <rms@gnu.org>

	* insdel.c (syms_of_insdel): staticpro combine_after_change_buffer.

	* bytecode.c (MAYBE_GC): Test gc_cons_threshold and
	gc_relative_threshold, one by one.

	* keyboard.c (read_char): Test gc_cons_threshold.
	(syms_of_keyboard): staticpro Qecho_area_clear_hook.

	* eval.c (Feval, Ffuncall): Test gc_cons_threshold and
	gc_relative_threshold, one by one.

	* alloc.c (gc_cons_threshold): Not static.
	(gc_cons_combined_threshold): Var deleted.
	(gc_relative_threshold): New variable.
	(Fgarbage_collect, init_alloc_once): Compute gc_relative_threshold
	instead of gc_cons_combined_threshold.

	* lisp.h (gc_cons_threshold, gc_relative_threshold): Declare.
	(gc_cons_combined_threshold): Declaration deleted.

2005-07-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c: Don't include stdlib.h or string.h.
	(Fdo_applescript, Fmac_file_name_to_posix)
	(Fmac_file_name_to_posix): Doc fixes.
	[TARGET_API_MAC_CARBON] (Fmac_get_preference)
	(Fmac_code_convert_string): Likewise.
	[MAC_OSX] (init_mac_osx_environment): Fall back on terminal mode
	if the executable is not contained in a bundle.

	* macfns.c: Don't include stdlib.h or string.h.  Include atimer.h.
	(gray_width, gray_height): Remove defines.
	(gray_bits, gray_bitmap_width, gray_bitmap_height)
	(gray_bitmap_bits): Remove variables.
	(lispy_function_keys): Remove extern.
	(free_frame_menubar): Add extern.
	(x_window_to_frame): Remove function.
	(unwind_create_tip_frame): Add declaration.
	(x_set_name_internal): New function.
	(x_set_name, x_set_title): Use it.
	(Fx_create_frame, Fx_display_grayscale_p, Fx_display_pixel_width)
	(Fx_display_pixel_height, Fx_display_planes)
	(Fx_display_color_cells, Fx_server_max_request_size)
	(Fx_server_vendor, Fx_server_version, Fx_display_screens)
	(Fx_display_mm_height, Fx_display_mm_width)
	(Fx_display_backing_store, Fx_display_visual_class)
	(Fx_display_save_under, Fx_synchronize, Fx_show_tip): Doc fixes.

	* macmenu.c (Fx_popup_menu, Fx_popup_dialog): Doc fixes.

	* macselect.c (Fx_own_selection_internal): Follow error conventions.
	(Fx_get_selection_internal, Fx_selection_owner_p)
	(Fx_selection_exists_p): Doc fixes.
	(syms_of_macselect) <selection-converter-alist>: Likewise.

2005-07-21  Juanma Barranquero  <lekktu@gmail.com>

	* buffer.c (syms_of_buffer) <cursor-type>: Doc fix.

	* ccl.c (Fregister_ccl_program): Fix typos in docstring.
	(Fccl_execute_on_string): Likewise; add usage info.

	* composite.c (Fcompose_region_internal)
	(Fcompose_string_internal):
	Improve argument/docstring consistency.

	* minibuf.c (Fminibuffer_prompt_end, Feval_minibuffer):
	Fix typos in docstrings.

	* textprop.c (Fnext_char_property_change)
	(Fprevious_char_property_change): Doc fixes.

	* window.c (Fset_window_margins, Fset_window_fringes):
	Improve argument/docstring consistency.

	* xfaces.c (Finternal_lisp_face_p): Doc fix.

2005-07-21  Andreas Schwab  <schwab@suse.de>

	* eval.c (restore_stack_limits): Return a value.

2005-07-20  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (Fdefvar): Doc fix.

2005-07-20  Kim F. Storm  <storm@cua.dk>

	* fileio.c (Fdo_auto_save, do_auto_save_unwind):
	Use make_save_value to unwind protect stream.

	* lread.c (Fload, load_unwind):
	Use make_save_value to unwind protect stream.

2005-07-19  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (Fprog2, Fcalled_interactively_p),
	(syms_of_eval) <debug-on-quit>: Doc fixes.
	(syms_of_eval) <max-specpdl-size>:
	(Finteractive_p): Fix typos in docstrings.

2005-07-19  Kim F. Storm  <storm@cua.dk>

	* w32fns.c (Vx_hand_shape): Variable removed.
	(syms_of_w32fns): Intern and staticpro Qw32_charset_default.

2005-07-19  Kenichi Handa  <handa@m17n.org>

	* fns.c (Fstring_as_multibyte): Escape backslashes in the docstring.

2005-07-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.h (Fgenerate_new_buffer_name): Declare (for use in coding.c).

2005-07-18  Kim F. Storm  <storm@cua.dk>

	* frame.h (struct frame): New member already_hscrolled_p.

	* xdisp.c (redisplay_internal): Only try to hscroll each frame once
	to avoid redisplay looping hscrolling back and forth ad infinitum.

2005-07-18  Juri Linkov  <juri@jurta.org>

	* buffer.c (scroll-up-aggressively, scroll-down-aggressively):
	* keymap.c (Fminor_mode_key_binding):
	* macterm.c (mac-emulate-three-button-mouse):
	Delete duplicate duplicate words.

2005-07-18  Ken Raeburn  <raeburn@gnu.org>

	* minibuf.c (Ftest_completion): Fix odd syntax in test.

2005-07-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (x_set_cursor_color): Use XSetBackground and XSetForeground.

	* macgui.h (struct _XGC): New struct.
	(GC): Use it.
	(GCForeground, GCBackground, GCFont): Use X11 mask values.
	(XCreateGC, XParseGeometry): Move externs to macterm.h.

	* macterm.c (x_bitmap_icon, x_make_frame_visible): Remove declarations.
	(XSetFont): Add declaration.
	(mac_set_forecolor, mac_set_backcolor, mac_set_colors):
	Remove functions.
	(GC_FORE_COLOR, GC_BACK_COLOR, GC_FONT, MAC_WINDOW_NORMAL_GC):
	New defines.
	(XDrawLine, mac_draw_line_to_pixmap, XClearWindow)
	(mac_draw_bitmap, XCreatePixmapFromBitmapData, XFillRectangle)
	(mac_draw_rectangle, mac_draw_string_common, mac_scroll_area):
	Use them.
	(mac_erase_rectangle): New function.
	(XClearArea, x_draw_fringe_bitmap, x_clear_glyph_string_rect)
	(x_draw_stretch_glyph_string): Use it.
	(XChangeGC, XCreateGC, XGetGCValues, XSetForeground)
	(XSetBackground, XSetFont): Adjust for new GC implementation.
	(x_draw_fringe_bitmap, x_draw_box_rect): Use GC to set colors.
	(XTset_vertical_scroll_bar): Clear area under scroll bar.

	* macterm.h (struct mac_display_info): Change types of
	scratch_cursor_gc black_relief.gc, and white_relief.gc to GC.
	(XCreateGC, XParseGeometry): Move externs from macgui.h.

	* xfaces.c [MAC_OS] (XCreateGC): Remove extern.

2005-07-16  Richard M. Stallman  <rms@gnu.org>

	* buffer.c (Fmake_overlay): Doc fix.

2005-07-16  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (syms_of_ntproc): staticpro Qhigh, Qlow,
	Vw32_valid_locale_ids, and Vw32_valid_codepages.

2005-07-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [TARGET_API_MAC_CARBON] (Fmac_code_convert_string):
	Use Fstring_as_unibyte instead of string_make_unibyte.

2005-07-15  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (select_frame_for_redisplay): Use find_symbol_value.

2005-07-15  Kim F. Storm  <storm@cua.dk>

	* xdisp.c: Fix redisplay loop in last change.
	(IT_POS_VALID_AFTER_MOVE_P): New macro.
	(move_it_vertically_backward, move_it_by_lines): Use it.

2005-07-14  Jason Rumney  <jasonr@gnu.org>

	* w32.c (init_environment): Default HOME directory to user's
	appdata directory if possible.

2005-07-14  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (pitx): Fix output format.  Print string charpos.

	* lread.c (syms_of_lread): Initialize seen_list.

	* search.c (syms_of_search): Staticpro searchbuf.whitespace_regexp.

	* syntax.c (syms_of_syntax): Staticpro lisp objects in gl_state.
	Staticpro re_match_object.

2005-07-14  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macselect.c (get_scrap_target_type_list): Avoid NULL pointer
	dereference.

	* macterm.c (mac_window_to_frame): Remove duplicate define.

2005-07-14  Kenichi Handa  <handa@m17n.org>

	* coding.c (code_convert_region_unwind): ARG is changed to a cons.
	(code_convert_region): Adjust for the above change.
	(set_conversion_work_buffer): If the work buffer is already in
	use, generate a new buffer and return it.  Otherwise return Qnil.
	(run_pre_post_conversion_on_str): Adjust for the above change.
	(run_pre_write_conversin_on_c_str): Likewise.

2005-07-13  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (start_display): Don't reseat to next visible line start
	if current start position is in a string or image.
	(move_it_vertically_backward): Be sure to move out of strings and
	images when moving it2 forward.
	(move_it_by_lines): When moving forward, move to next buffer
	position if we end up in a string or image.  When moving backward,
	count rows moved over when moving to start of current row in case
	row starts in middle of a string or image.  Also move further
	backward if we end up in a string or image.
	(try_cursor_movement): If overlay string spans multiple lines,
	move backward to set cursor on start of an overlay string.
	(cursor_row_p): Row is ok if cursor is at newline from string, but
	string starts on this line (so we always position cursor at start
	of string).

	* indent.c (Fvertical_motion): If start position is on an image,
	don't move back if we move too far (that's almost certain to happen).

	* xdisp.c (cursor_row_fully_visible_p): Allow partially visible
	row in minibuffer windows.
	(try_window): Don't check margins in minibuffer windows.

2005-07-13  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c: Don't include stdlib.h or composite.h.
	(x_use_underline_position_properties, last_mouse_press_frame)
	(x_noop_count, Qvendor_specific_keysyms): Remove unused variables.
	(syms_of_macterm, mac_initialize): Don't initialize them.
	(waiting_for_input, initial_argv, initial_argc)
	(Vcommand_line_args, Vx_no_window_manager, errno, window_scroll)
	(set_frame_menubar, path_from_vol_dir_name): Remove externs.
	(extra_keyboard_modifiers): Fix type in extern.
	(x_window_to_frame, x_window_to_scroll_bar): Remove declarations.
	(x_scroll_bar_report_motion): Add argument types to declaration.
	(mac_compute_glyph_string_overhangs): Add declaration.
	(disable_mouse_highlight): Remove unused variable.
	[USE_TOOLKIT_SCROLL_BARS] (construct_scroll_bar_click)
	(x_scroll_bar_handle_press, x_scroll_bar_handle_release)
	(x_scroll_bar_handle_drag): Remove argument `timestamp'.
	All callers changed.
	[USE_TOOLKIT_SCROLL_BARS] (construct_scroll_bar_click): Don't set
	timestamp.
	[USE_CARBON_EVENTS] (mac_handle_mouse_event): Likewise.
	(x_scroll_bar_create, XTset_vertical_scroll_bar): Show scroll bar
	only when its width is less than the height.
	(XTredeem_scroll_bar): Sync with xterm.c.
	(font_name_table, font_name_table_size, font_name_count):
	Make static.
	(drag_and_drop_file_list): Remove variable.  Previous use is now
	local to function.
	(do_ae_open_documents): Move DRAG_N_DROP event construction part
	from XTread_socket.
	(XTread_socket): Consolidate setting of event timestamp.
	Move DRAG_N_DROP event construction part to do_ae_open_documents.
	Support extra_keyboard_modifiers.

	* xfaces.c (try_font_list) [MAC_OS]: Try font family name
	beginning with that for ASCII.

2005-07-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* alloc.c (gc_cons_combined_threshold, Vgc_cons_percentage): New vars.
	(Fgarbage_collect, init_alloc_once): Set gc_cons_combined_threshold.
	(syms_of_alloc): Declare gc-cons-percentage.

	* eval.c (Feval, Ffuncall):
	* keyboard.c (read_char):
	* bytecode.c (MAYBE_GC): Use gc_cons_combined_threshold.

	* lisp.h (gc_cons_combined_threshold): Declare.

2005-07-12  Kim F. Storm  <storm@cua.dk>

	* coding.c (Qprocess_argument):
	* coding.h (Qprocess_argument): Remove unused var.

	* xselect.c (intern): Remove dup. intern and staticpro for QTIMESTAMP.

2005-07-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [!TARGET_API_MAC_CARBON]: Include charset.h, coding.h, and
	Endian.h.
	[!MAC_OSX] (fchmod, fchown): New functions.
	(mac_get_code_from_arg): Don't accept Lisp integer as argument.
	Use SBYTES and EndianU32_BtoN.
	(mac_get_object_from_code): Return 4 byte string even if argument
	is 0.  Use make_unibyte_string and EndianU32_NtoB.
	(Fmac_get_file_creator, Fmac_get_file_type, Fmac_set_file_creator)
	(Fmac_set_file_type): Fix documents and argument declarations.
	Don't specify kFSCatInfoNodeFlags.  Support Mac OS Classic.

2005-07-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Frecenter): Yet another int/Lisp_Object mixup (YAILOM).

2005-07-11  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfaces.c (x_update_menu_appearance): Use fontSet resource for
	Lucid if X_I18N, font otherwise.

2005-07-10  Steven Tamm  <steventamm@mac.com>

	* mac.c (Fmac_get_file_type, Fmac_get_file_creator): Add.
	(Fmac_set_file_type, Fmac_set_file_creator): Add.
	(mac_get_object_from_code, mac_get_code_from_arg): Add.

2005-07-10  Richard M. Stallman  <rms@gnu.org>

	* lread.c (Qeval_buffer_list, Veval_buffer_list): New vars.
	(syms_of_lread): Set up eval-buffer-list.
	(Feval_buffer, Feval_region): Bind eval-buffer-list.

2005-07-08  Richard M. Stallman  <rms@gnu.org>

	* eval.c (Fdefvar): Allow defvaring a constant to itself quoted.

2005-07-08  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (menu_bar_items): Don't GCPRO menu_bar_items_vector here.
	(syms_of_keyboard): Initialize and staticpro menu_bar_items_vector.

2005-07-07  Kim F. Storm  <storm@cua.dk>

	* window.c (Frecenter): Fix last change (set iarg before use).

2005-07-06  Richard M. Stallman  <rms@gnu.org>

	* window.c (Frecenter): When arg is inside the scroll margin,
	move it out of the margin.

2005-07-06  Jason Rumney  <jasonr@gnu.org>

	* w32console.c (initialize_w32_display): Detect when the console
	dimensions are insane, and default to 80x25 instead.
	(w32_use_full_screen_buffer): Default to NIL.

2005-07-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_draw_vertical_window_border): Use foreground of
	VERTICAL_BORDER_FACE_ID for vertical border line.
	(mac_encode_char): Call check_ccl_update in advance.
	(mac_to_x_fontname, x_font_name_to_mac_font_name)
	(init_font_name_table, mac_do_list_fonts, XLoadQueryFont):
	Don't assume that font family length is less than 32.
	(x_compute_min_glyph_bounds): Make static.
	(x_load_font): Never set fonts_changed_p to zero.

2005-07-04  Lute Kamstra  <lute@gnu.org>

	* Update FSF's address in GPL notices.

2005-07-03  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (try_window): Fix previous change in how it handles
	a partially-visible line or one only partly past the margin.

	* window.c (window_scroll_pixel_based): Take account
	of this_scroll_margin when finding point when scrolling up.

2005-06-29  Ralf Angeli  <angeli@iwi.uni-sb.de>

	* window.c (window_scroll_pixel_based, window_scroll_line_based):
	Handle `scroll-preserve-screen-position' non-nil, non-t specially.
	(syms_of_window): <scroll-preserve-screen-position>: Doc fix.

2005-07-02  Juri Linkov  <juri@jurta.org>

	* w32term.c (w32_draw_vertical_window_border): Use foreground of
	VERTICAL_BORDER_FACE_ID for vertical border line.

2005-07-02  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (Fcopy_file): Rearrange the code that calls fchown and
	fchmod so that chmod doesn't get called on MSDOS before the file
	is closed.

2005-07-01  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (cleartype_active): New flag for enabling sub-pixel
	workaround.
	(w32_initialize): Initialize it.
	(w32_native_per_char_metric): Allow a couple of extra pixels when
	Cleartype is active.

	* w32term.c (w32_initialize): Move check for screen reader here
	from syms_of_w32term.

2005-06-30  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): bzero compose_status when nbytes
	is not zero.

2005-07-01  Masatake YAMATO  <jet@gyve.org>

	* emacs.c (main): Passing ADD_NO_RANDOMIZE to `personality'.

2005-06-30  Juri Linkov  <juri@jurta.org>

	* xdisp.c (x_draw_vertical_border): If left fringe is not present
	decrease x coord of vertical border by 1 pixel to not occupy text
	area of the right window.

	* xterm.c (x_draw_vertical_window_border): Use foreground of
	VERTICAL_BORDER_FACE_ID for vertical border line.

	* term.c (turn_on_face): In standout mode apply specified
	fg to bg, and specified bg to fg (this makes the logic of
	inversion on terminal consistent with X).

2005-06-29  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (user_variable_p_eh): New function.
	(Fuser_variable_p): Use it.  Clarify docstring.
	Return t for aliases of user options, nil for alias loops.

2005-06-27  Richard M. Stallman  <rms@gnu.org>

	* eval.c (Fdefvar): Improve error message.

2005-06-27  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [USE_CARBON_EVENTS] (mac_convert_event_ref): Fix last
	change.

2005-06-27  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (Fdefvar): Don't try to set constant symbols.

2005-06-25  Richard M. Stallman  <rms@gnu.org>

	* macfns.c (Fx_show_tip): Pass new arg to try_window.

	* w32fns.c (Fx_show_tip): Pass new arg to try_window.

	* xfns.c (Fx_show_tip): Pass new arg to try_window.

	* xdisp.c (try_window): New arg CHECK_MARGINS.  Calls changed.
	(redisplay_window): Handle try_window reporting point in scroll margin.

	* dispextern.h (try_window): Declare new arg.

	* fileio.c (Fcopy_file): New arg PRESERVE_UID_GID.
	Use fchmod to copy the file modes.
	(Frename_file): Don't copy UID and GID here;
	instead, specify t for PRESERVE_UID_GID when calling Fcopy_file.

	* eval.c (call_debugger): Take full care of extending stack limits
	to make space for the debugger, and restore the change afterward.
	Bind debug-on-error to nil.
	(restore_stack_limits): New subroutine.
	(Fsignal): Extend specpdl bound along with eval depth bound,
	for calling edebug.  Don't do either one, for calling debugger.
	(find_handler_clause): Don't bind debug-on-error here.
	Don't unbind anything either.
	Temporarily advance max_specpdl_size for calling
	internal_with_output_to_temp_buffer.
	(grow_specpdl): Don't alter max_specpdl_size before signaling
	an error.
	(syms_of_eval) <max-specpdl-size>: Doc fix.

	* lread.c (read1): 0.0e+NaN should make a "positive" NaN.

2005-06-24  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (Frename_file): Undo last change: no need to ifdef away
	chown on DOS_NT platforms.

	* w32.c (sys_chown): New function.

	* s/ms-w32.h (chown): New; define to sys_chown.

2005-06-24  Juanma Barranquero  <lekktu@gmail.com>

	* xdisp.c (syms_of_xdisp) <nobreak-char-display>: Doc fix.
	(syms_of_xdisp) <void-text-area-pointer>: Doc fix.

	* fileio.c (Frename_file)[!DOS_NT]: Don't call chown on MSDOS/Windows.

2005-06-23  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (get_next_display_element): Finish reversing the tests of
	Vnobreak_char_display.

	* xdisp.c (Vnobreak_char_display): Rename from Vshow_nonbreak_escape.
	All uses changed.
	(Qnobreak_space): Rename from Qno_break_space.  All uses changed.
	(syms_of_xdisp): Define nobreak-char-display and nobreak-space.

	* fileio.c (Frename_file): Preserve owner and group, if possible,
	when copying.

2005-06-23  Juanma Barranquero  <lekktu@gmail.com>

	* abbrev.c (Funexpand_abbrev):
	* category.c (Fmake_category_set):
	* dispnew.c (Fsleep_for, Fsit_for):
	* editfns.c (Fsubst_char_in_region):
	* eval.c (Fdefvar, Fdefconst, Feval, Ffuncall):
	* frame.c (make_frame_without_minibuffer):
	* lread.c (read_vector):
	* macfns.c (check_x_frame):
	* process.c (Fstop_process, Fcontinue_process):
	* search.c (Freplace_match):
	* syntax.c (Fstring_to_syntax):
	* w32fns.c (check_x_frame, check_x_display_info):
	* xfaces.c (x_supports_face_attributes_p):
	* xselect.c (Fx_own_selection_internal): Follow error conventions.

	* image.c (fn_png_init_io): Don't define it.
	(init_png_functions) [HAVE_NTGUI]: Don't initialize fn_png_init_io.
	(png_read_from_file): New function, based on png_read_from_memory.
	(png_load): Use it, instead of fn_png_init_io.

2005-06-23  Kim F. Storm  <storm@cua.dk>

	* search.c (Fmatch_data): Remove evaporate option.
	(Fset_match_data): Do not mention evaporate option in doc string.
	Add commentary explaining evaporate arg (for internal use only).
	(unwind_set_match_data): Add comment on evaporate use.

2005-06-22  Miles Bader  <miles@gnu.org>

	* xfaces.c (Qvertical_border): Rename from `Qvertical_divider'.
	(realize_basic_faces, syms_of_xfaces): Update references to it.
	* dispextern.h (enum face_id): Rename `VERTICAL_DIVIDER_FACE_ID'
	to `VERTICAL_BORDER_FACE_ID'.
	* dispnew.c (build_frame_matrix_from_leaf_window): Update references.

2005-06-21  Juri Linkov  <juri@jurta.org>

	* dispextern.h: Add extern Qframe_set_background_mode.

	* xfaces.c: Rename obsolete function Qframe_update_face_colors to
	Qframe_set_background_mode.

	* frame.c (Fmodify_frame_parameters):
	Call frame-set-background-mode after changing the background color
	on non-window non-dos branch.

2005-06-21  Juanma Barranquero  <lekktu@gmail.com>

	* fns.c (Fchar_table_range):
	* process.c (Fmake_network_process): Fix spellings.

2005-06-20  Kim F. Storm  <storm@cua.dk>

	* fns.c (Fsort): Doc fix.

2005-06-20  Miles Bader  <miles@gnu.org>

	* xfaces.c (Qvertical_divider): New variable.
	(realize_basic_faces): Realize its face.
	(syms_of_xfaces): Initialize it.

	* dispextern.h (enum face_id): Add `VERTICAL_DIVIDER_FACE_ID'.

	* dispnew.c (build_frame_matrix_from_leaf_window): Display vertical
	window-separator on ttys using `vertical-divider' face by default.

2005-06-17  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (get_next_display_element):
	Reverse test of Vshow_nonbreak_escape.

	* term.c (produce_special_glyphs): Use spec_glyph_lookup_face.
	(Ftty_no_underline): New function.
	(syms_of_term): defsubr it.

	* keyboard.c (read_char): Call restore_getcjmp after jump occurs.

	* dispnew.c (spec_glyph_lookup_face): New function.
	(build_frame_matrix_from_leaf_window): Use it.

	* dispextern.h (spec_glyph_lookup_face): Add declaration.

	* buffer.c (syms_of_buffer) <cursor-type>: Doc fix.

2005-06-12  Richard M. Stallman  <rms@gnu.org>

	* keyboard.c (read_char): After catching a longjmp,
	call restore_getcjmp.

2005-06-17  Juanma Barranquero  <lekktu@gmail.com>

	* xselect.c (lisp_data_to_selection_data): Fix spelling.

2005-06-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_compute_glyph_string_overhangs): Don't set
	overhangs unless the given glyph type is noncomposite CHAR_GLYPH.
	[USE_CARBON_EVENTS] (mac_convert_event_ref): Convert dead key down
	events.
	(XTread_socket): Don't pass keyboard events with the option
	modifier to the system when Vmac_command_key_is_meta is nil or
	Vmac_option_modifier is non-nil.
	[USE_CARBON_EVENTS] (read_socket_inev): New variable.
	[USE_CARBON_EVENTS] (init_command_handler): Fix argument.
	[USE_CARBON_EVENTS] (mac_handle_mouse_event): New Carbon event
	handler function.
	(install_window_handler) [USE_CARBON_EVENTS]: Install it.
	(XTread_socket) [USE_CARBON_EVENTS]: Move mouse wheel event
	handler part to mac_handle_mouse_event.

2005-06-14  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (Fdefvaralias): Rename arguments SYMBOL and ALIASED to
	NEW-ALIAS and BASE-VARIABLE, respectively.

2005-06-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (note_mode_line_or_margin_highlight): Lisp_Object/int mixup.
	(get_phys_cursor_geometry, format_mode_line_unwind_data)
	(get_line_height_property, x_produce_glyphs): Remove unused vars.

	* coding.c (run_pre_post_conversion_on_str): Remove unused var `buf'.

2005-06-13  Eli Zaretskii  <eliz@gnu.org>

	* w32term.c (x_use_underline_position_properties): New variable.
	(x_draw_glyph_string): Remind in a comment to change doc string of
	x-use-underline-position-properties if/when underline positioning
	is implemented.
	(syms_of_w32term): DEFVAR_BOOL x-use-underline-position-properties,
	and initialize it to nil.

2005-06-12  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (NEWOPENFILENAME): New struct.
	(Fx_file_dialog): Use it to trick the system into giving us up to
	date dialogs on systems that are documented to support it.
	Do not set OFN_FILEMUSTEXIST flag if looking for a directory.

2005-06-12  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_abort): Use the MB_YESNO dialog instead of
	MB_ABORTRETRYIGNORE.  Never return, even if DebugBreak does.

2005-06-11  Eli Zaretskii  <eliz@gnu.org>

	* image.c (x_create_x_image_and_pixmap) [HAVE_NTGUI]: Cast 4th arg
	to CreateDIBSection to avoid a compiler warning.
	(pbm_load): Cast 3rd arg to IMAGE_BACKGROUND to avoid a compiler
	warning.
	(png_load): Cast return values of fn_png_create_read_struct and
	fn_png_create_info_struct, to avoid compiler warnings on W32.
	Cast 3rd arg to IMAGE_BACKGROUND and image_background_transparent
	to avoid compiler warnings.
	(jpeg_load): Cast return value of fn_jpeg_std_error to avoid a
	compiler warning on W32.  Cast 3rd arg to IMAGE_BACKGROUND to
	avoid a compiler warning.
	(tiff_load): Cast return values of fn_TIFFOpen and
	fn_TIFFClientOpen to avoid compiler warning on W32.  Cast 3rd arg
	to IMAGE_BACKGROUND to avoid a compiler warning.
	(gif_load): Cast return values of fn_DGifOpenFileName and
	fn_DGifOpen to avoid compiler warnings on W32.  Cast 3rd arg to
	IMAGE_BACKGROUND to avoid a compiler warning.
	(DrawText) [HAVE_NTGUI || MAC_OS]: If already defined, undef
	before redefining.

	* w32bdf.c (create_offscreen_bitmap): Cast `bitsp' to `void **' in
	the call to CreateDIBSection, to avoid a compiler warning.

2005-06-11  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fx_file_dialog): Unblock input before falling back to
	minibuffer.
	* macfns.c (Fx_file_dialog): Likewise.

2005-06-10  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in ($(TEMACS)): Depend on addsection.exe.

2005-06-10  Juanma Barranquero  <lekktu@gmail.com>

	* process.c (syms_of_process) [ADAPTIVE_READ_BUFFERING]:
	* w32fns.c (syms_of_w32fns): Fix spellings.

2005-06-10  Eli Zaretskii  <eliz@gnu.org>

	* unexw32.c (COPY_CHUNK, COPY_PROC_CHUNK): Add a new argument
	`verbose'; print diagnostic messages only if it is non-zero.
	All callers changed to pass a zero value unless DEBUG_DUMP is defined
	in the environment.
	(copy_executable_and_dump_data): Print section names with %.8s.

2005-06-10  Masatake YAMATO  <jet@gyve.org>

	* xdisp.c (note_mode_line_or_margin_highlight): Call clear_mouse_face
	when mouse_face is not given.

2005-06-09  Luc Teirlinck  <teirllm@auburn.edu>

	* window.c (Fselect_window): Adapt call to Fselect_frame.

	* lisp.h: Update EXFUN of Fselect_frame.

	* keyboard.c (command_loop_1): Adapt call to Fselect_frame.

	* frame.c (Fhandle_switch_frame, Fselect_frame): Delete unused arg
	no_enter.
	(Fset_mouse_position, Fset_mouse_pixel_position, Ficonify_frame):
	Adapt to above change.

2005-06-10  Juanma Barranquero  <lekktu@gmail.com>

	* fns.c (Fmemq, Fmaphash): Doc fixes.

2005-06-09  Juanma Barranquero  <lekktu@gmail.com>

	* xfaces.c (Fdisplay_supports_face_attributes_p):
	Fix typo in docstring.

2005-06-08  Steven Tamm  <steventamm@mac.com>

	* unexmacosx.c (copy_data_segment): Copy __la_sym_ptr2 section
	used by gcc4 on intel mac.

2005-06-09  Kim F. Storm  <storm@cua.dk>

	* search.c (Fmatch_data): Add optional RESEAT arg.  Unchain markers
	in REUSE list if non-nil; free them if equal to evaporate.
	(Fset_match_data): Add optional RESEAT arg.  Unchain markers in	LIST
	if non-nil; free them if equal to evaporate.  Use XCAR/XCDR.
	(restore_search_regs): Rename from restore_match_data.  Uses changed.
	(unwind_set_match_data): New function.
	(record_unwind_save_match_data): New function like save-match-data.

	* lisp.h (Fmatch_data, Fset_match_data): Fix EXFUN.
	(record_unwind_save_match_data): Add prototype.
	(restore_search_regs): Rename from restore_match_data.

	* composite.c (compose_chars_in_text):
	* eval.c (do_autoload):
	* macmenu.c (set_frame_menubar):
	* process.c (read_process_output, exec_sentinel):
	* xmenu.c (set_frame_menubar):
	* xdisp.c (prepare_menu_bars, update_menu_bar, update_tool_bar):
	* w32menu.c (set_frame_menubar):
	Use record_unwind_save_match_data.

2005-06-08  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (get_next_display_element): Alter previous change:
	Distinguish Vshow_nonbreak_escape = t or not t.
	For t, use escape_glyph once again, as before previous change.
	Use space or hyphen for display, instead of the non-ASCII char.
	(syms_of_xdisp) <show-nonbreak-escape>: Doc fix.

	* process.c (Fstart_process): Don't touch command_channel_p slot.

	* process.h (struct process): Delete command_channel_p.

2005-06-07  Masatake YAMATO  <jet@gyve.org>

	* xdisp.c (note_mode_line_or_margin_highlight):
	Check the overlapping of re-rendering area to avoid flickering.
	(note_mouse_highlight): Call clear_mouse_face if PART
	is not ON_MODE_LINE nor ON_HEADER_LINE.

2005-06-07  Kim F. Storm  <storm@cua.dk>

	* process.c: Improve commentary for adaptive read buffering.

2005-06-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c (x_create_toolkit_scroll_bar): Use XtNarrowScrollbars
	if available.

2005-06-06  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* macmenu.c (menu_quit_handler, install_menu_quit_handler):
	New functions for popping down menus on C-g.
	(set_frame_menubar, mac_menu_show): Call install_menu_quit_handler.

	* macterm.c: Make mac_quit_char_modifiers and mac_quit_char_keycode
	non-static.

	* config.in: Add HAVE_CANCELMENUTRACKING.

2005-06-06  Eli Zaretskii  <eliz@gnu.org>

	* w32heap.h (OFFSET_TO_RVA, RVA_TO_OFFSET, RVA_TO_PTR): Remove macros.

	* unexw32.c (RVA_TO_PTR): Move here from w32heap.h.

	* w32proc.c (RVA_TO_PTR): New macro.

	* w32heap.c (RVA_TO_PTR): No need to #undef now.

	* makefile.w32-in ($(BLD)/emacs.$(O), $(BLD)/w32select.$(O)):
	Depend on w32heap.h.

2005-06-06  Luc Teirlinck  <teirllm@auburn.edu>

	* keyboard.c (command_loop_1): Update Vthis_original_command.

2005-06-06  Richard M. Stallman  <rms@gnu.org>

	* xmenu.c (popup_get_selection): Undo previous change.

2005-06-06  Juri Linkov  <juri@jurta.org>

	* xdisp.c (Qno_break_space): New variable.
	(syms_of_xdisp): Initialize it.
	(get_next_display_element): Add no-break space and soft hypen
	codes for iso8859-2 and iso8859-5.  Don't add `\' for them.
	Use `no-break-space' face for no-break spaces.

2005-06-06  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* window.c (delete_window): Handle the case where a h/vchild has
	a h/vchild.

2005-06-05  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (sys_setsockopt): Change arg 4 to `const void *'.  In the
	call to pfn_setsockopt, cast optval to `const char *'.

2005-06-04  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (gettimeofday): Use struct _timeb, not struct timeb.
	(open_unc_volume): Cast return value of map_w32_filename, to avoid
	compiler warnings.

	* s/ms-w32.h (fileno): Don't define if already defined.

	* emacs.c: Include w32heap.h, to avoid compiler warning about sbrk.

	* makefile.w32-in (DOC): Define to point to the generated DOC-X.

2005-06-04  Richard M. Stallman  <rms@gnu.org>

	* xmenu.c (popup_get_selection): Click not in menu deactivates menu.

2005-06-04  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* macmenu.c (cleanup_popup_menu): New function.
	(Fx_popup_menu): Unwind protect cleanup_popup_menu in case
	mac_menu_show Quit:s.
	(mac_menu_show): Quit on cancel if not popped up on click (i.e.
	a dialog).

2005-06-04  Kim F. Storm  <storm@cua.dk>

	* coding.c (decode_coding_string): Handle CODING_FINISH_INTERRUPT.

	* callproc.c (Fcall_process): Don't use alloca to gradually
	increase size of buf, as it effectively uses twice the necessary
	space on the stack.  Instead, pre-allocate buf of full size, and
	gradually increase the read size.

	* bytecode.c (BYTE_CODE_QUIT): Check Vthrow_on_input.

	* eval.c (unbind_to): Preserve value of Vquit_flag.

	* xterm.c (handle_one_xevent): Also ignore mouse motion just
	before a button release event.

2005-06-03  Juanma Barranquero  <lekktu@gmail.com>

	* xfaces.c (Finternal_lisp_face_equal_p): Really report
	on faces in a frame, if the argument FRAME is non-nil.
	Improve argument/docstring consistency.

2005-06-02  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (MODE_LINE_NOPROP_LEN): New macro.
	(x_consider_frame_title, Fformat_mode_line): Save offset into
	mode_line_noprop_buf rather than pointer, in case buffer is relocated.

2005-06-01  Kim F. Storm  <storm@cua.dk>

	* fns.c (mapcar1): Maybe exit loop if original sequence was modified.

2005-06-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_to_x_fontname, mac_do_list_fonts): Set XLFD
	resolution fields for scalable fonts to 0.

	* xfaces.c (build_scalable_font_name): Round pixel size to the
	nearest integer.

2005-06-01  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_mode_line): Support nested calls to redisplay
	and format-mode-line.  Set mode_line_target to MODE_LINE_DISPLAY.

2005-05-31  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Finsert_file_contents):
	* xdisp.c (note_mode_line_or_margin_highlight): Lisp_Object/int mixup.

2005-05-31  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (mode_line_noprop_buf, mode_line_noprop_buf_end)
	(mode_line_noprop_ptr): Rename from frame_title_*.
	(store_mode_line_noprop_char): Rename from store_frame_title_char.
	(store_mode_line_noprop): Rename from store_frame_title.
	(mode_line_target): New enum to specify current output target
	for mode line formatting.
	(display_mode_element): Test it rather than frame_title_ptr and
	mode_line_string_list to determine where output should go.
	(mode_line_proptrans_alist, mode_line_string_alist): Make static.
	(Vmode_line_unwind_vector): New variable.
	(format_mode_line_unwind_data, unwind_format_mode_line):
	New functions for unwind protection in mode line formatting.
	(x_consider_frame_title): Use them and new local var 'title_start'
	to support nested calls to format-mode-line and redisplay.
	Set mode_line_target to MODE_LINE_TITLE.
	(Fformat_mode_line): Use them and new local var 'string_start' to
	support nested calls to format-mode-line and redisplay.
	Set mode_line_target to MODE_LINE_NOPROP or MODE_LINE_STRING.
	Don't trim trailing dashes.
	(decode_mode_spec): Don't make infinite number of trailing dashes
	for MODE_LINE_NOPROP and MODE_LINE_STRING targets.
	(syms_of_xdisp): Initialize and staticpro mode_line_string_face,
	mode_line_string_face_prop, and Vmode_line_unwind_vector.
	(init_xdisp): Initialize mode_line_noprop_ptr to start of _buf.
	Initialize mode_line_target to MODE_LINE_DISPLAY.

2005-05-29  Richard M. Stallman  <rms@gnu.org>

	* buffer.c (Fbuffer_local_value): Call indirect_variable.

2005-05-28  Masatake YAMATO  <jet@gyve.org>

	* xdisp.c (note_mode_line_or_margin_highlight): Change the
	pointer to a hand cursor when hoovering over a mouse-face.

2005-05-27  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_encode_char): Call check_ccl_update in advance.

	* ccl.c: Now an element of Vccl_program_table is a vector of
	length 4, not 3.
	(ccl_get_compiled_code): New arg idx.  Caller changed.
	Adjust for the change of Vccl_program_table.
	(setup_ccl_program): Adjust for the change of Vccl_program_table.
	(check_ccl_update): New function.
	(Fregister_ccl_program): Use ASET to set an element of a vector.
	Adjusted for the change of Vccl_program_table.

	* ccl.h (struct ccl_program): New member idx.
	(check_ccl_update): Extern it.

2005-05-27  Juanma Barranquero  <lekktu@gmail.com>

	* image.c (Vimage_library_alist): Move from image.el.
	(syms_of_image): Defvar it.
	(lookup_image_type): Use it.

	* buffer.c (Fbuffer_local_value): Make argument name match its use
	in docstring.

2005-05-26  Juanma Barranquero  <lekktu@gmail.com>

	* keyboard.c (Frecursive_edit): Fix typo in docstring.
	(Fposn_at_x_y): Make argument name match its use in docstring.

2005-05-26  Lute Kamstra  <lute@gnu.org>

	* eval.c (Frun_hooks): Mention run-mode-hooks in docstring.

2005-05-24  Masatake YAMATO  <jet@gyve.org>

	* xdisp.c (note_mode_line_or_margin_highlight): Use b and e
	as loop sentinels.

2005-05-24  Nick Roberts  <nickrob@snap.net.nz>

	* xmenu.c (Fx_popup_dialog): Add a third boolean argument to
	select frame title ("Question"/"Information").
	(xdialog_show): Use it.

	* macmenu.c (Fx_popup_dialog, mac_dialog_show): As for xmenu.c.

	* w32menu.c (Fx_popup_dialog, w32_dialog_show): As for xmenu.c.

	* fns.c (Fyes_or_no_p, Fy_or_n_p): Call Fx_popup_dialog with
	a third argument (Qnil).

	* lisp.h: x-popup-dialog can have three arguments.

	* editfns.c (Fmessage_box): Use "Information" for frame title.

2005-05-23  Thien-Thi Nguyen  <ttn@gnu.org>

	* termcap.c [VMS]: Include <starlet.h>.

2005-05-23  Masatake YAMATO  <jet@gyve.org>

	* xdisp.c (note_mode_line_or_margin_highlight): Add code
	for mouse-face.  Change the type of the first argument from `window'
	to `Lisp_Object'.
	(note_mouse_highlight): Call note_mode_line_or_margin_highlight with
	window instead of w.

2005-05-22  Andreas Schwab  <schwab@suse.de>

	* process.c (send_process): Move misplaced volatile.

2005-05-21  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (display_mode_element): If we're processing a list and
	padding is specified, put it after the last element.

2005-05-21  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (Fexpand_file_name) [DOS_NT]: Don't try to support
	"superroot" on DOS_NT systems.

2005-05-21  David Hunter  <hunterd42@comcast.net>  (tiny change)

	* process.c (send_process): Restore the SIGPIPE handler if we
	catch a SIGPIPE.

2005-05-20  Juanma Barranquero  <lekktu@gmail.com>

	* image.c (lookup_image, png_read_from_memory): Remove hacks (and
	misleading comments).
	(DEF_IMGLIB_FN): Use C calling convention for image libraries.

2005-05-20  KOBAYASHI Yasuhiro  <kobayays@otsukakj.co.jp>

	* window.c (Fwindow_inside_edges, Fwindow_inside_pixel_edges):
	Correct the right value.

2005-05-19  Nick Roberts  <nickrob@snap.net.nz>

	* keyboard.c (syms_of_keyboard): Remove Lisp variables
	post-command-idle-hook and post-command-idle-delay.
	(command_loop_1): Don't try to execute post-command-idle-hook.

2005-05-16  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (handle_display_prop): Handle empty replacement.
	(handle_single_display_spec): Return -1 for empty replacement.

	* keyboard.c (adjust_point_for_property): Skip empty overlay string.

	* .gdbinit (pitx): Print more info about iterator.

2005-05-16  Andreas Schwab  <schwab@suse.de>

	* unexmacosx.c (unexec_realloc): Move declarations before statements.

2005-05-14  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (message3): Call cancel_echoing.

	* alloc.c (Fmemory_full_p): New function.
	(syms_of_alloc): defsubr it.

	* process.c (send_process_trap): Unblock SIGPIPE.
	(send_process): Reset SIGPIPE handler before reporting error.

2005-05-14  Nick Roberts  <nickrob@snap.net.nz>

	* emacs.c (syms_of_emacs): Fix doc string for system-type.

2005-05-13  Richard M. Stallman  <rms@gnu.org>

	* fileio.c (Ffind_file_name_handler): Handle lambda-exp as handler.
	(Finsert_file_contents): If we read 0 bytes from a special file,
	unlock the visited file if we locked it.
	(Fmake_symbolic_link, Frecent_auto_save_p): Doc fixes.
	(Ffile_exists_p, Ffile_symlink_p): Doc fixes.

2005-05-13  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (main) [MAC_OS8]: Call init_atimer before mac_term_init.

	* keyboard.c (readable_events) [USE_TOOLKIT_SCROLL_BARS]:
	Regard toolkit scroll bar thumb drag events as squeezable and prevent
	redisplay from being paused by them.

	* mac.c [!MAC_OSX]: Include keyboard.h and syssignal.h.
	[!MAC_OSX] (target_ticks): Remove variable.
	[!MAC_OSX] (check_alarm, pause, index): Remove functions.
	[!MAC_OSX && __MRC__] (sys_strftime): Likewise.
	[!MAC_OSX] (select): If fd 0 is not set in rfds and some input
	event occurs before timeout, behave as if the function were interrupted.
	[!MAC_OSX] (sigblock, sigsetmask, alarm): Simulate SIGALRM
	handling using Time Manager routines.
	[!MAC_OSX] (mac_atimer_task, mac_atimer_qlink, signal_mask):
	New variables.
	[!MAC_OSX] (mac_atimer_handler, set_mac_atimer, remove_mac_atimer)
	(setitimer): New functions.

	* macfns.c, macmenu.c: Don't include signal.h.

	* macterm.c [USE_TOOLKIT_SCROLL_BARS] (get_control_part_bounds):
	Rename from get_control_part_bound.  All callers changed.
	(x_scroll_bar_clear): New function.
	(x_clear_frame): Use it.
	(XTset_vertical_scroll_bar): Don't call Draw1Control.
	(x_scroll_bar_handle_click): Change type of second argument from
	int to ControlPartCode.
	(check_alarm): Remove declaration.
	(XTread_socket) [!TARGET_API_MAC_CARBON]: Don't call it.
	(XTread_socket): Use ControlPartCode instead of SInt16.

2005-05-13  Nozomu Ando  <nand@mac.com>

	* unexmacosx.c: Include assert.h.
	(MACOSX_MALLOC_MULT16): New define.
	[MACOSX_MALLOC_MULT16] (ptr_in_unexec_regions): Determine whether
	ptr is in unexec regions by checking it is multiple of 16.
	(unexec_malloc_header_t): New typedef.
	(unexec_malloc, unexec_realloc, unexec_free): Store and use
	allocated size information in unexec_malloc_header.

2005-05-10  Richard M. Stallman  <rms@gnu.org>

	* xterm.c (noinclude): Add #undef.

	* image.c, xfns.c, xmenu.c: Don't include signal.h.

2005-05-09  Juanma Barranquero  <lekktu@gmail.com>

	* fileio.c (Fexpand_file_name, Frename_file, Fadd_name_to_file)
	(Fmake_symbolic_link, Faccess_file, Frecent_auto_save_p):
	Doc fixes.

	* dired.c (Ffile_name_completion): Make argument name
	match its use in docstring.

2005-05-08  Luc Teirlinck  <teirllm@auburn.edu>

	* eval.c (Fdefvaralias): Remove any pre-existing
	variable-documentation property of the alias.

2005-05-07  Thien-Thi Nguyen  <ttn@gnu.org>

	* xfns.c (start_hourglass): Do nothing when running on a tty.

2005-05-07  Juanma Barranquero  <lekktu@gmail.com>

	* fns.c (Fchar_table_range): Fix typos in docstring.

2005-05-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fns.c (Fchar_table_range): Yet Another Int/Lisp_Object Mixup.

2005-05-06  Eli Zaretskii  <eliz@gnu.org>

	* lread.c (Flocate_file_internal): Doc fix.

	* Makefile.in (lisp, shortlisp): Add jka-cmpr-hook.elc.

2005-05-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macselect.c (x_own_selection): Accept Lisp string as result of
	selection converter function.
	(x_clear_frame_selections): Don't call x-lost-selection-functions
	if Emacs is not owner of the selection.
	(Vmac_services_selection): Put variable and initialization in
	#ifdef MAC_OSX.
	(syms_of_macselect) [MAC_OSX]: Set default value of
	Vmac_services_selection to PRIMARY.

	* macterm.c (toolkit_scroll_bar_interaction): Remove unused variable.
	(mac_handle_tool_bar_click): Remove unused function and declaration.
	[USE_TOOLKIT_SCROLL_BARS] (scroll_bar_timer_callback)
	(install_scroll_bar_timer, set_scroll_bar_timer)
	(control_part_code_to_scroll_bar_part, construct_scroll_bar_click)
	(get_control_part_bound, x_scroll_bar_handle_press)
	(x_scroll_bar_handle_release, x_scroll_bar_handle_drag)
	(x_set_toolkit_scroll_bar_thumb): New functions and declarations.
	[USE_TOOLKIT_SCROLL_BARS] (last_scroll_bar_part, scroll_bar_timer)
	(scroll_bar_timer_event_posted_p): New variables.
	[USE_TOOLKIT_SCROLL_BARS] (SCROLL_BAR_FIRST_DELAY)
	(SCROLL_BAR_CONTINUOUS_DELAY): New macros.
	(x_scroll_bar_create): Set control reference with NewControl.
	(x_scroll_bar_create) [USE_TOOLKIT_SCROLL_BARS]:
	Initialize track_top and track_height to nil.
	(x_scroll_bar_set_handle, x_scroll_bar_note_movement):
	Put functions in #ifndef USE_TOOLKIT_SCROLL_BARS.
	(XTset_vertical_scroll_bar): Don't make space between scroll bar
	and associated window.
	(XTset_vertical_scroll_bar) [MAC_OSX]: Get scroll bar area width
	from window config.
	(XTset_vertical_scroll_bar) [USE_TOOLKIT_SCROLL_BARS]:
	Set track_top and track_height to nil when scroll bar size is changed.
	Recalculate them if they are nil.
	(XTread_socket) [MAC_OSX]: Use control kind to determine if the
	clicked control is a scroll bar.
	(XTread_socket) [USE_TOOLKIT_SCROLL_BARS]: Use toolkit scroll bar
	event handler functions.  Don't add modifiers to scroll bar click
	events.  Call scroll bar release handler when window is deactivated.
	(mac_initialize): Remove unused code for X toolkit.
	(syms_of_macterm) [!USE_TOOLKIT_SCROLL_BARS]:
	Initialize Vx_toolkit_scroll_bars to nil.

	* macterm.h (struct scroll_bar) [USE_TOOLKIT_SCROLL_BARS]:
	New members track_top and track_height.

	* sysselect.h [DARWIN || MAC_OSX]: Temporarily undefine
	init_process when including sys/select.h.

2005-05-05  Luc Teirlinck  <teirllm@auburn.edu>

	* eval.c (Fdefvaralias): Doc fix.

	* xmenu.c (Fx_popup_menu, Fx_popup_dialog): Doc fixes.

2005-05-05  Kim F. Storm  <storm@cua.dk>

	* buffer.c (init_buffer_once): Set cursor_in_non_selected_windows
	default value.
	(syms_of_buffer): Add default-cursor-in-non-selected-windows.
	Fix type of cursor-in-non-selected-windows.

2005-05-03  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* mac.c: #undef init_process so not to conflict with system headers.

2005-05-02  Richard M. Stallman  <rms@gnu.org>

	* buffer.c (syms_of_buffer): Define cursor-in-non-selected-windows.

	* buffer.h (struct buffer): Add cursor_in_non_selected_windows slot.

	* xdisp.c (Vcursor_in_non_selected_windows)
	(Qcursor_in_non_selected_windows): Vars deleted.
	(syms_of_xdisp): Don't initialize them.
	(get_window_cursor_type): Use cursor_in_non_selected_windows
	buffer slot.

2005-05-02  Kim F. Storm  <storm@cua.dk>

	* macros.c (executing_kbd_macro_index): Rename from
	executing_macro_index.  All uses changed.
	(executing_kbd_macro_iterations): Rename from
	executing_macro_iterations.  All uses changed.
	(executing_kbd_macro): Rename from executing_macro.
	All uses changed.
	(syms_of_macros): Rename Lisp var executing-macro-index to
	executing-kbd-macro-index.

	* xdisp.c (move_it_in_display_line_to): Fix last change.

2005-05-01  Luc Teirlinck  <teirllm@auburn.edu>

	* xmenu.c (Fx_popup_menu): Doc fix.

	* charset.c (syms_of_charset): Delete defsubr for Schars_in_region.

2005-05-02  Jason Rumney  <jasonr@gnu.org>

	* emacs.c (USAGE3, USAGE4): Keep strings below 2048 bytes.

2005-05-02  Nozomu Ando  <nand@mac.com>

	* sysselect.h: Fix typo.

2005-05-02  Nick Roberts  <nickrob@snap.net.nz>

	* charset.c (Fchars_in_region): Remove as obsolete.

2005-05-01  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (move_it_in_display_line_to): Stop if we move beyond
	TO_CHARPOS.  This may happen if last glyphs was an image or stretch
	glyph.

2005-05-01  Luc Teirlinck  <teirllm@auburn.edu>

	* dispnew.c (sit_for): Vexecuting_macro -> Vexecuting_kbd_macro.

2005-05-01  Richard M. Stallman  <rms@gnu.org>

	* xmenu.c [not HAVE_X_TOOLKIT] (xmenu_show):
	If user cancels the menu, quit unless FOR_CLICK.

	* macros.c (Vexecuting_kbd_macro): Rename from Vexecuting_macro.
	All uses changed.
	(syms_of_macros): Define only executing-kbd-macro, not executing-macro.
	* keyboard.c: Change Vexecuting_macro to Vexecuting_kbd_macro.
	* macros.h (Vexecuting_kbd_macro): Declare instead of Vexecuting_macro.
	* commands.h (Vexecuting_kbd_macro): Likewise.

2005-05-01  Thien-Thi Nguyen  <ttn@gnu.org>

	* sysdep.c (get_frame_size) [VMS]: Use a fresh i/o channel.

2005-04-30  Richard M. Stallman  <rms@gnu.org>

	* fileio.c (Ffind_file_name_handler): Handle the `operations'
	property of the file name handler.
	(Qoperations): New variable.
	(syms_of_fileio): Initialize and staticpro it.

	* xdisp.c (set_message_1): Delete xassert.

2005-04-29  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c: Don't include time.h.  Include sysselect.h after systime.h.

	* macfns.c (Fx_server_version): Add BLOCK_INPUT around Gestalt.

	* macgui.h [HAVE_CARBON && MAC_OSX]: Don't undefine/define mktime
	before/after including Carbon.h if there is a working mktime.

2005-04-28  Kim F. Storm  <storm@cua.dk>

	* xfaces.c (resolve_face_name): Add arg SIGNAL_P.  Calls changed.
	Fix cyclic alias check.  If alias loop is detected, signal
	circular-list error if SIGNAL_P, and return Qdefault if !SIGNAL_P.

2005-04-28  Lute Kamstra  <lute@gnu.org>

	* eval.c (do_autoload): Record only autoloads in the autoload
	property of symbols.

2005-04-28  Nick Roberts  <nickrob@snap.net.nz>

	* emacs.c (USAGE1): Add --basic-display and --quick options.

2005-04-27  Kim F. Storm  <storm@cua.dk>

	* data.c (syms_of_data) Staticpro Qcyclic_variable_indirection.

2005-04-26  Richard M. Stallman  <rms@gnu.org>

	* window.c (Fsame_window_p, Fspecial_display_p): Doc fixes.
	(syms_of_window): Doc fixes.

	* indent.c (Fvertical_motion): Undo previous change.

2005-04-26  Kenichi Handa  <handa@m17n.org>

	* fns.c (char_table_range): New function.
	(Fchar_table_range): Signal an error if characters in the range
	have inconsistent values.  Don't check the parent.

2005-04-25  Kenichi Handa  <handa@m17n.org>

	* fontset.c (fontset_set): Fix previous change.

2005-04-24  Richard M. Stallman  <rms@gnu.org>

	* indent.c (Fvertical_motion): Bind fontification-functions to nil.

2005-04-24  Eli Zaretskii  <eliz@gnu.org>

	* regex.c (re_search_2, re_match_2_internal): Convert second arg
	of RE_TRANSLATE to int, to shut up GCC warnings.

	* fileio.c (Fcopy_file): Doc fix.
	[MSDOS]: Fix call to emacs_open: buffer_file_type not defined and
	not needed.

2005-04-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in [HAVE_CARBON] (MAC_OBJ): Add macselect.o.
	(SOME_MACHINE_OBJECTS): Likewise.
	(mac.o): Depend on ccl.h.
	(macselect.o): New target.

	* emacs.c (main) [MAC_OS8 || MAC_OSX && HAVE_CARBON]:
	Call syms_of_macselect.

	* frame.c (Fdelete_frame) [MAC_OS]: Call x_clear_frame_selections.

	* mac.c [!TARGET_API_MAC_CARBON]: Don't include charset.h or coding.h.
	(QCLIPBOARD): Remove variable.
	(syms_of_mac): Don't initialize it.
	(Fmac_paste_function, Fmac_cut_function, Fx_selection_exists_p):
	Remove functions.
	(syms_of_mac): Don't defsubr them.
	[TARGET_API_MAC_CARBON] (Qmime_charset, QNFD, QNFKD, QNFC, QNFKC)
	(QHFS_plus_D, QHFS_plus_C): New variables.
	(syms_of_mac) [TARGET_API_MAC_CARBON]: Initialize them.
	[TARGET_API_MAC_CARBON] (get_cfstring_encoding_from_lisp)
	(cfstring_create_normalized): New functions.
	[TARGET_API_MAC_CARBON] (Fmac_code_convert_string): Likewise.
	(syms_of_mac) [TARGET_API_MAC_CARBON]: Defsubr it.

	* macterm.c (handling_window_update, terminate_flag):
	Remove variables.
	(do_window_update, do_ae_quit_application, XTread_socket):
	Don't use them.
	(WNE_SLEEP_AT_SUSPEND, WNE_SLEEP_AT_RESUME): Don't define.
	[USE_CARBON_EVENTS && MAC_OSX] (mac_handle_service_event)
	(init_service_handler): Move to macselect.c.  Remove declarations.
	[USE_CARBON_EVENTS && MAC_OSX] (init_service_handler): Add extern.
	(Qapplication, Qabout): New variables.
	(syms_of_mac): Initialize them.
	[USE_CARBON_EVENTS && MAC_OSX] (Qpreferences, Qservices, Qpaste)
	(Qperform): New variables.
	(syms_of_mac) [USE_CARBON_EVENTS && MAC_OSX]: Initialize them.
	(do_get_menus) [TARGET_API_MAC_CARBON]: Don't call AppendResMenu.
	(do_menu_choice): Unhighlight menu bar also when menu_id is 0.
	(mac_store_application_menu_event, init_menu_bar): New functions.
	[USE_CARBON_EVENTS] (mac_handle_command_event)
	(init_command_handler): New functions.
	(mac_handle_window_event): Return noErr on window update event.
	(do_ae_quit_application): Call mac_store_application_menu_event.
	(mac_initialize) [USE_CARBON_EVENTS]: Call init_command_handler
	and init_menu_bar.

	* macterm.h (x_clear_frame_selections): Add extern.

	* macselect.c: New file for selection processing on Mac OS.

2005-04-23  Richard M. Stallman  <rms@gnu.org>

	* fileio.c (Fcopy_file): New arg MUSTBENEW.
	(Frename_file): Pass new arg to Fcopy_file.

	* window.c (window_size_fixed): Variable deleted.
	(syms_of_window): Initialize window-size-fixed to nil.
	But don't DEFVAR window_size_fixed.

2005-04-23  Andreas Schwab  <schwab@suse.de>

	* m/macppc.h (LD_SWITCH_MACHINE) [LINUX]: Don't define.
	(START_FILES, LIB_STANDARD) [LINUX && _ARCH_PPC64]: Override to
	use lib64 instead of lib.
	(_LP64) [_ARCH_PPC64]: Define if not defined.

2005-04-23  David Hunter  <hunterd42@comcast.net>  (tiny change)

	* s/ms-w32.h (HAVE_PWD_H): Define.

2005-04-22  Kenichi Handa  <handa@m17n.org>

	* fns.c (copy_sub_char_table): Explicitly copy the default value
	of the sub-chartable.

	* fontset.c (fontset_set): When a sub-chartable is created,
	explicitly sets the defalt value.

2005-04-22  Kim F. Storm  <storm@cua.dk>

	* fns.c (Fplist_get): Replace by Fsafe_plist_get.
	(Fsafe_plist_get): Rename to Fplist_get.
	(Fsafe_get): Remove, as Fget now uses safe Fplist_get.
	(defsubr): Remove defsubr for Fsafe_plist_get and Fsafe_get.

	* lisp.h (Fsafe_plist_get, Fsafe_get): Remove EXFUN.

	* xdisp.c (store_mode_line_string, produce_stretch_glyph)
	(note_mode_line_or_margin_highlight, note_mouse_highlight):
	Use Fplist_get instead of Fsafe_plist_get.

	* xfaces.c (resolve_face_name): Use Fget instead of Fsafe_get.

2005-04-21  Miles Bader  <miles@gnu.org>

	* xdisp.c (dump_glyph_row): Don't display overlay_arrow_p field.

2005-04-20  Thien-Thi Nguyen  <ttn@gnu.org>

	* sysdep.c: Remove reference to defunct vms-pwd.h.
	* dired.c: Likewise.  Also, for pwd.h, use HAVE_PWD_H, not !VMS.
	* editfns.c, fileio.c, filelock.c, sysdep.c, xrdb.c: Likewise.

	* config.in: Regenerate.

2005-04-20  Kenichi Handa  <handa@m17n.org>

	* lisp.h (CHAR_TABLE_DEFAULT_SLOT_ASCII): New macro.
	(CHAR_TABLE_DEFAULT_SLOT_8_BIT_CONTROL): New macro.
	(CHAR_TABLE_DEFAULT_SLOT_8_BIT_GRAPHIC): New macro.

	* alloc.c (make_sub_char_table): Argument changed to initial
	value of the slots.

	* data.c (Faref): Handle special slots used as default values of
	ascii, eight-bit-control, eight-bit-control.  Don't ignore a
	default value set for a group of characters.
	(Faset): Signal an error if IDXVAL is not a valid character code.
	Make a sub-chartable with correct initial value.

	* fns.c (Fset_char_table_range): Don't set slots used as default
	values for ascii, eight-bit-control, eight-bit-graphic.
	Don't call Faref with charset-id.
	(Fset_char_table_default): Document how to treat normal character
	argument.  Handle special slots used as default values of ascii,
	eight-bit-control, eight-bit-control.  Make a sub chartable if
	necessary.

2005-04-20  Kenichi Handa  <handa@m17n.org>

	* search.c (boyer_moore): Fix previous change.

2005-04-19  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (setup_for_ellipsis): Reset saved_face_id to use default
	face unless last visible char and first invisible char have the
	same face.  Also use default face if saved_face_id is undefined.

2005-04-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (MacFontStruct): Remove member `fontname'.  Add member
	`full_name'.
	[TARGET_API_MAC_CARBON] (MacFontStruct): Use type int for
	mac_scriptcode member.

	* macterm.c (Qbig5, Qcn_gb, Qsjis, Qeuc_kr): Remove variables.
	(syms_of_mac): Don't initialize them.
	(Vmac_charset_info_alist): New variable.
	(syms_of_mac): Defvar it.
	(create_text_encoding_info_alist): New function.
	(decode_mac_font_name, mac_to_x_fontname)
	(x_font_name_to_mac_font_name, init_font_name_table): Don't hard
	code the correspondence among XLFD charsets, Mac script codes, and
	Emacs coding systems.  Use Vmac_charset_info_alist and result of
	create_text_encoding_info_alist instead.
	(init_font_name_table) [TARGET_API_MAC_CARBON]: Use Font Manager
	routines also on Mac OS Classic.
	(init_font_name_table) [!TARGET_API_MAC_CARBON]:
	Use add_font_name_table_entry.
	(mac_do_list_fonts): Regard 0 in XLFD scaleble fields as
	specified.  Derive unspecified scalable fields from specified one.
	(x_list_fonts): Consider Valternate_fontname_alist.
	(kDefaultFontSize): Change value from 9 to 12.
	(XLoadQueryFont): Get decoded font family, font face, and charset
	from x_font_name_to_mac_font_name.  Set full name of loaded font.
	(mac_unload_font): Free `full_name' member.
	(x_load_font): Don't try XLoadQueryFont if x_list_fonts returns
	NULL.  Copy full_name member of struct MacFontStruct to that of
	struct font_info.

2005-04-19  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (handle_stop): Set saved_face_id to current face if
	selective_display_ellipsis_p so ellipsis will be shown in same
	face as preceding text.
	(setup_for_ellipsis): Don't set saved_face_id here.
	(next_element_from_display_vector): Default to saved_face_id.

	* fns.c (Fsafe_get): New function.
	(syms_of_fns): Defsubr it.

	* lisp.h (Fsafe_get): EXFUN it.

	* xfaces.c (resolve_face_name): Use Fsafe_get to avoid redisplay
	loops in case of bad face property lists.  Limit number of face
	alias lookups to 10 (in case of face alias loops).

2005-04-18  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (struct glyph_row): New member overlay_arrow_bitmap.
	It replaces the corresponding member from struct window, as a
	window may now show multiple overlay arrows.
	Remove member overlay_arrow_p, superseeded by overlay_arrow_bitmap.

	* dispnew.c (row_equal_p, update_window_line, scrolling_window):
	Compare overlay_arrow_bitmap than overlay_arrow_p members.

	* fringe.c (draw_fringe_bitmap): Use overlay_arrow_bitmap from row
	rather than from window.
	(update_window_fringes): Compare overlay_arrow_bitmap rather than
	overlay_arrow_p members.
	(Ffringe_bitmaps_at_pos): Return fringe overlay_arrow_bitmap name
	if not default.

	* window.h (struct window): Remove member overlay_arrow_bitmap.

	* window.c (make_window): Don't initialize overlay_arrow_bitmap.

	* xdisp.c (overlay_arrow_string_or_property): Remove PBITMAP arg.
	Calls changed.  Don't check for overlay-arrow-bitmap property here.
	(overlay_arrow_at_row): Remove PBITMAP arg.  Instead, if left
	fringe is present, return Lisp integer for bitmap (or -1 for default).
	Fix value of overlay-arrow-bitmap property to be a symbol, use
	lookup_fringe_bitmap to parse it.
	(display_line): Change call to overlay_arrow_at_row.  Store integer
	return value as overlay bitmap in row rather than window.
	Only show overlay arrow if row displays text, or if no other overlay
	arrow is seen in window (if overlay marker is at point-max).

2005-04-18  Thien-Thi Nguyen  <ttn@gnu.org>

	* xfaces.c (realize_x_face) [!HAVE_WINDOW_SYSTEM]: Return NULL.

2005-04-18  Lute Kamstra  <lute@gnu.org>

	* lread.c (Vloads_in_progress): Static.
	* fns.c (Vloads_in_progress): Remove extern.
	(load_in_progress): Add extern.
	(Frequire): Use load_in_progress instead of Vloads_in_progress.

2005-04-18  Thien-Thi Nguyen  <ttn@gnu.org>

	* xmenu.c (Fx_popup_menu): Initialize error_name to NULL.

2005-04-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (XTread_socket): Don't beep on keyboard input even if
	no frame is visible.

2005-04-16  Dan Nicolaescu  <dann@ics.uci.edu>

	* term.c (struct keys): Add support for shifted keys.

2005-04-16  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (with_echo_area_buffer): Delete WHICH < 0 case.
	(set_message): Call with_echo_area_buffer with WHICH = 0.
	(set_message_1): Erase the echo area buffer first thing.
	(echo_area_display): Don't clear echo_message_buffer.

2005-04-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (mac.o): Depend on charset.h and coding.h.

	* mac.c: Include charset.h and coding.h.
	[TARGET_API_MAC_CARBON] (Qutf_8): Remove extern.
	[TARGET_API_MAC_CARBON] (cfstring_create_with_string): New function.
	[TARGET_API_MAC_CARBON] (Fmac_get_preference): Use it.

	* macfns.c [TARGET_API_MAC_CARBON] (Fx_file_dialog): Likewise.

	* image.c [MAC_OSX] (image_load_quartz2d): Likewise.

	* macterm.c (x_autoselect_window_p): Remove variable.
	(last_window): New variable.
	(XTreassert_line_highlight, x_change_line_highlight):
	Remove declarations.
	(mac_focus_changed, x_detect_focus_change): New functions and
	declarations.
	(XTextExtents16, front_emacs_window): Remove function.
	(mac_focus_frame): New function.
	(XTmouse_position, do_menu_choice, do_zoom_window, XTread_socket)
	(mac_check_for_quit_char): Use it instead of front_emacs_window.
	(x_scroll_bar_report_motion): Obtain window from control owner.
	(x_make_frame_invisible): Set window manager size hint.
	(do_mouse_moved): Remove function.
	(XTread_socket): Move its contents here.  Generate select-window
	event on mouse movement if needed.  Use x_detect_focus_change on
	activate/deactivate events.  Don't deiconify frame or invalidate
	window rectangle when dnd items are dropped.
	Don't activate/deactivate root control.
	(frame_highlight, frame_unhighlight): Activate/deactivate root
	control here.
	(syms_of_macterm): Delete DEFVAR_BOOL for x_autoselect_window_p.

	* macterm.h (cfstring_create_with_string) [TARGET_API_MAC_CARBON]:
	New extern.

2005-04-15  Luc Teirlinck  <teirllm@auburn.edu>

	* Makefile.in: Define new macro TOOLTIP_SUPPORT.
	(lisp): Use it.
	(SOME_MACHINE_LISP): Add tooltip.

2005-04-14  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [!TARGET_API_MAC_CARBON]: Include MacLocales.h.
	Don't include TextEncodingConverter.h.
	(mac_system_script_code, Vmac_system_locale): New variables.
	(syms_of_mac): Defvar them.
	(mac_get_system_locale): New function.

	* macfns.c (x_set_name, x_set_title) [!TARGET_API_MAC_CARBON]:
	Use ENCODE_SYSTEM to encode title bar string.
	(x_create_tip_frame): Apply 2005-03-18 change for xfns.c.
	(Fx_file_dialog) [TARGET_API_MAC_CARBON && !MAC_OSX]:
	Use CFStringGetSystemEncoding to get system default string encoding.

	* macterm.c [!TARGET_API_MAC_CARBON]: Don't include
	TextEncodingConverter.h.

2005-04-13  Steven Tamm  <steventamm@mac.com>

	* macterm.c (syms_of_macterm): Remove redundant definition of
	mac-pass-control-to-system.

2005-04-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fset_window_configuration): Be careful when you choose
	among several possible points for the new_current_buffer.

2005-04-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c (poll_for_input) [SYNC_INPUT]: Don't call
	poll_for_input_1.  Set interrupt_input_pending to 1 instead.
	(Qlanguage_change) [MAC_OS]: New variable.
	(syms_of_keyboard) [MAC_OS]: Intern and staticpro it.
	(kbd_buffer_get_event) [MAC_OS]: Make event for LANGUAGE_CHANGE_EVENT.

	* macterm.c (mac_keyboard_text_encoding)
	(current_mac_keyboard_text_encoding): Remove variables.
	(XTread_socket): Store language-change event if keyboard script	change
	is detected.  Don't convert input to `mac_keyboard_text_encoding'.
	(syms_of_macterm): Delete DEFVAR_INT for mac-keyboard-text-encoding.

	* termhooks.h (enum event_kind) [MAC_OS]: Add LANGUAGE_CHANGE_EVENT.

2005-04-10  Richard M. Stallman  <rms@gnu.org>

	* emacs.c (standard_args): Rename --bare-bones to --quick.
	Add -D aka --basic-display.

	* buffer.c (Fmake_indirect_buffer): Clear out some local variables.

2005-04-09  Richard M. Stallman  <rms@gnu.org>

	* keymap.c (where_is_internal): Convert a string used as event type
	into "(any string)".

	* lread.c (Vloads_in_progress): Not static.
	* fns.c (Vloads_in_progress): Add extern.
	(Frequire): Don't do LOADHIST_ATTACH if Vloads_in_progress is nil.

2005-04-09  Thien-Thi Nguyen  <ttn@surf.glug.org>

	* dispnew.c (mirror_line_dance): Avoid crash if W2 is null.

2005-04-09  Lute Kamstra  <lute@gnu.org>

	* print.c (PRINTPREPARE): Check if the marker PRINTCHARFUN is
	within the accessible part of the buffer.

2005-04-09  Kim F. Storm  <storm@cua.dk>

	* lread.c (readevalloop): Add args START and END as region in
	current buffer to read.  Callers changed.
	When specified, narrow to this region only when reading,
	not during eval.  Track next point to read from during eval.
	Also restore point to "real" buffer position before eval.
	(Feval_region): Don't save excursion and restriction here, and
	don't narrow to region.  Just pass region to readevalloop.
	Note: Point is now preserved even when PRINTFLAG is nil.

2005-04-08  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (syms_of_xdisp): Init overlay-arrow-string to "=>".

2005-04-06  Kim F. Storm  <storm@cua.dk>

	* emacs.c (standard_args): Add -Q, --bare-bones, -bare-bones.

2005-04-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (cfdate_to_lisp): Add `const' for variable `epoch_gdate'.
	(Fmac_get_preference): Doc fix.

	* macfns.c (Fx_create_frame, x_create_tip_frame):
	Add "fontset-mac" to fallback font/fontsets.

2005-04-04  Kim F. Storm  <storm@cua.dk>

	* alloc.c (Fgarbage_collect): Call CHECK_CONS_LIST before and after gc.

	* eval.c (Ffuncall): Always call CHECK_CONS_LIST on entry.
	Call it again after autoload.

2005-04-02  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* alloc.c (allocate_string_data): Call BLOCK_INPUT before calling
	mallopt.

	* ralloc.c (r_alloc_init): Ditto.

2005-04-01  Kenichi Handa  <handa@m17n.org>

	* lisp.h (Vascii_upcase_table, Vascii_canon_table)
	(Vascii_eqv_table): Extern them.

	* casetab.c (set_case_table): If standard is nonzero, setup
	Vascii_upcase_table, Vascii_canon_table, and Vascii_eqv_table.

	* search.c (looking_at_1): Use current_buffer->case_canon_table,
	not DOWNCASE_TABLE.
	(string_match_1): Likewise.
	(fast_c_string_match_ignore_case): Use Vascii_canon_table, not
	Vascii_downcase_table.
	(fast_string_match_ignore_case): Likewise.
	(search_buffer): Fix checking of boyer-moore usability.
	(boyer_moore): Calculate translate_prev_byte1/2/3 in advance.
	No need of tranlating characters in PAT.  Fix calculation of
	simple_translate.

2005-03-31  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c [HAVE_XAW3D]: Include ThreeD.h for XtNbeNiceToColormap.
	(x_create_toolkit_scroll_bar): Test XtNbeNiceToColormap before using it.
	Use XtNtopShadowPixel and XtNbottomShadowPixel.
	(x_set_toolkit_scroll_bar_thumb): Remove ugly old hack that didn't
	really work and that breaks with some versions of Xaw3d.

2005-03-31  Kenichi Handa  <handa@m17n.org>

	* coding.c (syms_of_coding): Fix previous change.

2005-03-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (search_embedded_absfilename): Fix last change.

2005-03-25  Kenichi Handa  <handa@m17n.org>

	* coding.c (syms_of_coding): Suggest to use set-coding-category in
	the docstring of coding-category-list.

2005-03-31  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (Qmouse_fixup_help_message): New var.
	(syms_of_keyboard): Intern and staticpro it.
	(show_help_echo): Apply mouse-fixup-help-message to help string.

2005-03-30  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_line): Allow multiple overlay arrows in window.

2005-03-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Fexpand_file_name): Use IS_DEVICE_SEP.
	(file_name_absolute_p): New fun, extracted from Ffile_name_absolute_p.
	(Ffile_name_absolute_p): Use it.
	(search_embedded_absfilename): New fun, extracted from
	Fsubstitute_in_file_name.  Use file_name_absolute_p.
	Free the pw data after use.
	(Fsubstitute_in_file_name): Use it.
	After cutting a prefix, re-check file-name-handler.

2005-03-26  Lennart Borgman  <lennart.borgman.073@student.lu.se>

	* w32term.h (x_output): Add focus_state.

	* w32term.c (x_focus_changed, w32_detect_focus_change): New functions.
	(w32_read_socket) [WM_SETFOCUS]: Call w32_detect_focus_change.

2005-03-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (Fminibuffer_complete_and_exit, Fself_insert_and_exit):
	Use Fexit_minibuffer.
	(Fexit_minibuffer): Mark it as no-return, deactivate the mark.

2005-03-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dired.c (Ffile_attributes): Add a missing gcpro.

	* alloc.c (make_number): The arg can be bigger than `int'.
	* lisp.h (make_number): Make prototype more precise.

	* process.c, dired.c (Vfile_name_coding_system)
	(Vdefault_file_name_coding_system):
	* callproc.c (Vdoc_file_name, Vfile_name_coding_system)
	(Vdefault_file_name_coding_system): Remove unused declarations.

2005-03-24  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xmenu.c (create_and_show_popup_menu): Just remove menu and return
	if it failed to pop up (Gnome "show pointer on ctrl" option makes
	menus fail to pop up).

2005-03-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (get_next_display_element): Also use `\ ' & `\-' for latin-9.
	Just prepend a backslash without replacing the NBSP by an SPC.

2005-03-22  Kim F. Storm  <storm@cua.dk>

	* xfaces.c (lookup_derived_face): Add arg SIGNAL_P.
	* dispextern.h (lookup_derived_face): Fix prototype.
	* msdos.c (XMenuActivate): Fix call to lookup_derived_face.

	* xdisp.c (handle_single_display_spec): Derive left-fringe and
	right-fringe face from fringe face.

	* fringe.c (draw_fringe_bitmap_1, Fset_fringe_bitmap_face):
	Derive face from fringe face.

2005-03-22  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xrdb.c (x_load_resources): Undo previous change (2005-03-18).

2005-03-22  David Kastrup  <dak@gnu.org>

	* textprop.c (Fnext_char_property_change)
	(Fprevious_char_property_change): Allow marker as limit.
	(Fnext_single_char_property_change)
	(Fprevious_single_char_property_change): Check that limit is a
	number in strings.
	(Fnext_single_char_property_change): Coerce position to integer.
	(Fprevious_single_char_property_change): Same here.

2005-03-21  Thien-Thi Nguyen  <ttn@gnu.org>

	* s/openbsd.h (LD_SWITCH_SYSTEM_tmp): Define if undefined.

2005-03-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* frame.c (Fignore_event): Remove.
	(syms_of_frame): Don't defsubr it.

	* keyboard.c (keys_of_keyboard): Just use `ignore' instead of the
	redundant `ignore-event'.

2005-03-19  Eli Zaretskii  <eliz@gnu.org>

	* unexec.c (write_segment, unexec): Move these functions to avoid
	forward references (which cause errors with "gcc -gcoff").

2005-03-18  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (x_create_tip_frame): Remove setting of Vx_resource_name so
	that it doesn't become "tooltip".  The specbind is enough.

	* xrdb.c (x_load_resources): Use different char *helv when I18N
	is present.

2005-03-17  Kenichi Handa  <handa@m17n.org>

	* coding.c (syms_of_coding): Docstring of coding-category-list fixed.

2005-03-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xfaces.c (x_update_menu_appearance) [HAVE_X_I18N]:
	Use xic_create_fontsetname even for non-Motif menus.
	Don't forget to free the fontsetname.

	* xfns.c (xic_create_fontsetname): Add a final catch-all font pattern.

2005-03-17  Richard M. Stallman  <rms@gnu.org>

	* dispnew.c (mirror_line_dance): Set W2 according to FRAME_FROM.

	* fileio.c (Fcopy_file, Frename_file, Fadd_name_to_file)
	(Fmake_symbolic_link): Use G to read the new file name.

	* callint.c (Finteractive): Document G option.
	(Fcall_interactively): Implement G option.

	* buffer.c (buffer_lisp_local_variables): New function,
	broken out from Fbuffer_local_variables.
	(clone_per_buffer_values): Use buffer_lisp_local_variables.

2005-03-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xfns.c (xic_create_fontsetname): Add `motif' argument.
	Always return a freshly allocated string.
	(xic_create_xfontset): Adjust call.

	* xfaces.c (x_update_menu_appearance) [USE_MOTIF]:
	Use xic_create_fontsetname to create a fontset so utf-8 locales work.
	(dump_realized_face): Fix warning.

	* emacs.c (Fkill_emacs): YAILOM.

	* frame.c (Fignore_event): Fix ancient obscure C-u handling bug.

2005-03-17  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (HASHKEY_TERMINAL): Remove.
	(HASHKEY_MAX_NID): New macro.
	(xrm_q_get_resource_1): Rename from xrm_q_get_resource.  Add extra
	argument.
	(xrm_q_get_resource): Call xrm_q_get_resource_1 with extra argument.
	(xrm_create_database, xrm_q_put_resource)
	(xrm_merge_string_database, xrm_q_get_resource_1)
	(xrm_q_get_resource): Change resource database representation so
	that it may not use multiple hash tables for a single database.
	[TARGET_API_MAC_CARBON] (xrm_cfproperty_list_to_value): YAILOM.

2005-03-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xmenu.c (ENCODE_MENU_STRING) [HAVE_X_I18N]: Use ENCODE_SYSTEM.

	* coding.h (ENCODE_SYSTEM, DECODE_SYSTEM) [!WINDOWSNT]: Use the
	locale-coding-system, as was already done for WINDOWSNT.

	* keyboard.c (read_char): Only do the 7-bit-meta -> 27-bit-meta
	translation for chars in the 0-255 range.

2005-03-16  Lute Kamstra  <lute@gnu.org>

	* floatfns.c (Ffloor): Doc fix.

2005-03-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c: Include macterm.h instead of directly including Carbon.h.
	[TARGET_API_MAC_CARBON] (Qstring, Qnumber, Qboolean, Qdate, Qdata)
	(Qarray, Qdictionary): New variables.
	(syms_of_mac) [TARGET_API_MAC_CARBON]: Initialize them.
	[TARGET_API_MAC_CARBON] (Qutf_8): Add extern.
	[TARGET_API_MAC_CARBON] (DECODE_UTF_8): New macro.
	[TARGET_API_MAC_CARBON] (struct cfdict_context): New struct used
	in callback for CFDictionaryApplyFunction.
	[TARGET_API_MAC_CARBON] (cfdata_to_lisp, cfstring_to_lisp)
	(cfnumber_to_lisp, cfdate_to_lisp, cfboolean_to_lisp)
	(cfobject_desc_to_lisp, cfdictionary_add_to_list)
	(cfdictionary_puthash, cfproperty_list_to_lisp): New functions.
	[TARGET_API_MAC_CARBON] (Fmac_get_preference): New function.
	(syms_of_mac) [TARGET_API_MAC_CARBON]: Defsubr it.
	(P, LOOSE_BINDING, SINGLE_COMPONENT, HASHKEY_TERMINAL): New macro.
	(skip_white_space, parse_comment, parse_include_file)
	(parse_binding, parse_component, parse_resource_name, parse_value)
	(parse_resource_line, xrm_create_database, xrm_q_put_resource)
	(xrm_merge_string_database, xrm_q_get_resource, xrm_get_resource)
	(xrm_cfproperty_list_to_value, xrm_get_preference_database):
	New functions.

	* macfns.c (mac_get_rdb_resource): Remove function.
	(x_get_string_resource): Use xrm_get_resource.

	* macgui.h (XrmDatabase): Typedef to Lisp_Object.

	* macterm.c (x_list_fonts): FONT-LIST-CACHE is now cadr part of
	name_list_element.
	(mac_make_rdb): Create resource database from preferences and
	argument string.
	(mac_term_init): Save resource database to cddr part of
	name_list_element.

	* macterm.h (xrm_merge_string_database, xrm_get_resource)
	(xrm_get_preference_database): Add externs.
	[TARGET_API_MAC_CARBON] (cfdata_to_lisp, cfstring_to_lisp)
	(cfnumber_to_lisp, cfdate_to_lisp, cfboolean_to_lisp)
	(cfobject_desc_to_lisp, cfproperty_list_to_lisp): Likewise.

	* process.c (init_process): Change `#ifdef DARWIN' to `#if
	defined (DARWIN) || defined (MAC_OSX)'

	* s/darwin.h (DARWIN): Don't define.

2005-03-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (Qhyper, Qsuper, Qmeta, Qalt, Qctrl, Qcontrol, Qshift):
	Remove unused variables.
	(syms_of_macfns): Don't initialize them.  Likewise for
	Qface_set_after_frame_default.  Defvar and initialize
	Vx_window_horizontal_drag_shape.
	(x_set_mouse_color): Change mouse pointer shape.
	(mac_window) [!MAC_OSX]: Create root control.
	(Fx_create_frame): Remove initializations of mouse pointer shapes.
	(hourglass_started): New function (from xfns.c).
	(start_hourglass, cancel_hourglass): Put function body in #ifdef
	MAC_OSX.
	(show_hourglass) [TARGET_API_MAC_CARBON]: Create progress
	indicator for each non-tooltip frame if needed, and show it.
	(hide_hourglass) [TARGET_API_MAC_CARBON]: Hide progress indicators.

	* macgui.h [!TARGET_API_MAC_CARBON]: Include Appearance.h and
	Controls.h.  Use ThemeCursor instead of CursHandle.

	* macterm.c (activate_scroll_bars, deactivate_scroll_bars):
	Remove functions and declarations.
	(mac_set_colors): Take argument for saving background color.
	All callers changed.
	(XDrawLine, XClearArea, mac_draw_bitmap, XFillRectangle)
	(mac_draw_rectangle, mac_draw_string_common): Save and Restore
	background color.
	(x_update_end, mac_do_track_drag): Don't reset background color.
	(mac_define_frame_cursor) [!TARGET_API_MAC_CARBON]:
	Use SetThemeCursor.
	(x_set_window_size) [TARGET_API_MAC_CARBON]: Move progress
	indicator control to the upper-right corner of the window.
	(arrow_cursor) [!TARGET_API_MAC_CARBON]: Remove variable.
	(do_init_managers) [!TARGET_API_MAC_CARBON]: Don't initialize it.
	(do_window_update): Update controls after updating content area.
	(mac_handle_window_event): Remove unused extern.
	(XTread_socket): Check both control handle and control part code
	to determine whether a scroll bar is clicked.  Activate/deactivate
	root control instead of contained scroll bar controls.
	(make_mac_terminal_frame): Use ThemeCursor constants.

	* macterm.h (struct mac_output) [TARGET_API_MAC_CARBON]:
	New member hourglass_control.
	(HOURGLASS_WIDTH, HOURGLASS_HEIGHT): New defines.
	(activate_scroll_bars, deactivate_scroll_bars): Remove declarations.

2005-03-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (keycode_to_xkeysym_table): Change mapping so that it
	coincides with that in Apple X11 except `clear', `enter' on
	laptops, and fn + `enter' on laptops.

2005-03-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xmenu.c (ENCODE_MENU_STRING): Explicitly use string_make_unibyte.
	(list_of_panes, list_of_items, Fx_popup_menu): Use XCAR/XCDR.
	(digest_single_submenu, xmenu_show): Use ENCODE_MENU_STRING.

	* xfns.c (xic_defaut_fontset): New constant.
	(xic_create_fontsetname): New function.
	Extracted from create_frame_xic.  Try to generate a slightly
	better fontset.
	(xic_create_xfontset): Use it.
	(create_frame_xic): Simplify.

2005-03-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Fmake_symbolic_link): Fix last change.

2005-03-11  Richard M. Stallman  <rms@gnu.org>

	* fileio.c (Frename_file, Fadd_name_to_file)
	(Fmake_symbolic_link): If NEWNAME or LINKNAME is a directory,
	expand the basename of FILE relative to it.

2005-03-11  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Finsert_file_contents): Call Fcheck_coding_system
	before calling setup_coding_system so that autoloading of a coding
	system work.

2005-03-10  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (hourglass_started): New function.

	* dispextern.h: Declare hourglass_started.

	* keyboard.c (Fexecute_extended_command): Restart hourglass
	after call to Fcompleting_read if already started.

	* gtkutil.c (xg_update_scrollbar_pos): Call x_sync so that the
	GTK main loop is entered in xterm.c, thus doing the redraw.

2005-03-10  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (pos_visible_p): Fix X value in last line of buffer.

2005-03-08  Kenichi Handa  <handa@m17n.org>

	* frame.c (x_set_font): Call set_default_ascii_font if an
	available font is found.

	* fontset.c (set_default_ascii_font): New function.
	(syms_of_fontset): Don't set FONTSET_ASCII (Vdefault_fontset) here.

	* fontset.h (set_default_ascii_font): Extern it.

2005-03-07  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (CLEAR_IMAGE_CACHE_COUNT): New const.
	(clear_image_cache_count): New var.
	(redisplay_internal): Don't clear face and image caches in the
	middle of redisplay; do it afterwards.

	* blockinput.h (TOTALLY_UNBLOCK_INPUT): Avoid dangling else.

	* xdisp.c (notice_overwritten_cursor): Check that phys_cursor.vpos
	is valid.  If not, clear phys_cursor_on_p and return.

2005-03-07  Andreas Schwab  <schwab@suse.de>

	* blockinput.h (UNBLOCK_INPUT_TO): Always call UNBLOCK_INPUT.

2005-03-06  Richard M. Stallman  <rms@gnu.org>

	* keyboard.c (Ftop_level): Let Fthrow deal with UNBLOCK_INPUT.

	* eval.c (unwind_to_catch): Use UNBLOCK_INPUT_TO.
	(Feval, Ffuncall): Use CHECK_CONS_LIST.

	* lisp.h (CHECK_CONS_LIST): New macro (two definitions).

	* blockinput.h (UNBLOCK_INPUT_TO): New macro.
	(TOTALLY_UNBLOCK_INPUT): Handle a pending signal if any.

2005-03-05  Juri Linkov  <juri@jurta.org>

	* emacs.c (USAGE1): Replace Info node name "command arguments"
	with "emacs invocation".
	(USAGE3): Fix usage of `--color=MODE' which actually doesn't
	allow arguments `--color' and `MODE' to be separated by space.
	Add --no-blinking-cursor, -nbc.
	(standard_args): Add -nbc, --no-blinking-cursor.

2005-03-04  Thien-Thi Nguyen  <ttn@gnu.org>

	* s/vms.h: Define NO_HYPHENS_IN_FILENAMES.
	* s/vms4-4.h, s/vms5-5.h: Undefine NO_HYPHENS_IN_FILENAMES.
	* fileio.c (Fexpand_file_name) [VMS]:
	Use NO_HYPHENS_IN_FILENAMES, not VMS4_4.
	* doc.c (munge_doc_file_name) [VMS]: Likewise.
	(Fsnarf_documentation): Call munge_doc_file_name.

2005-03-04  Thien-Thi Nguyen  <ttn@gnu.org>

	* s/vms.h (FILE_SYSTEM_CASE): New macro.
	* fileio.c (Fexpand_file_name) [VMS]: Don't upcase the name
	"manually"; this is now handled generally via FILE_SYSTEM_CASE.

2005-03-04  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (main): Change `#ifdef HAVE_CARBON' to `#if
	defined (MAC_OSX) && defined (HAVE_CARBON)'.

	* image.c [!MAC_OSX && TARGET_API_MAC_CARBON]: Include QuickTime.h.

	* mac.c [!MAC_OSX && HAVE_CARBON]: Include Carbon.h.
	[!MAC_OSX] (select) [TARGET_API_MAC_CARBON]: Use ReceiveNextEvent.
	(posix_pathname_to_fsspec, fsspec_to_posix_pathname): New functions.
	(mac_clear_font_name_table): Move extern to macterm.h.

	* macfns.c (install_window_handler): Move extern to macterm.h.
	(Fx_file_dialog): Check STRINGP (default_filename) to see it is
	valid.  Don't check !NILP (dir) because it is already checked with
	CHECK_STRING.
	(Fx_file_dialog) [!MAC_OSX]: Use FSSpec instead of FSRef for
	specifying the default location and obtaining the selected filename.

	* macgui.h [!MAC_OSX && HAVE_CARBON]: Include Carbon.h.

	* macmenu.c [TARGET_API_MAC_CARBON]: Don't include headers that
	are included via Carbon.h.

	* macterm.c [TARGET_API_MAC_CARBON && !MAC_OSX]:
	Define USE_CARBON_EVENTS to 1.
	(qd) [__MRC__ && TARGET_API_MAC_CARBON]: Don't declare.
	(x_free_frame_resources): Call remove_window_handler for
	non-tooltip windows.
	[TARGET_API_MAC_CARBON]: Don't include headers that are included
	via Carbon.h.
	[TARGET_API_MAC_CARBON] (mac_do_track_dragUPP)
	(mac_do_receive_dragUPP): New variables.
	(mac_handle_service_event, init_service_handler): Put declarations
	and definitions in #ifdef MAC_OSX.
	(install_window_handler) [TARGET_API_MAC_CARBON]: Create UPPs for
	drag-and-drop handler functions and register them.
	(remove_window_handler): New function.
	(do_ae_open_documents, mac_do_receive_drag) [!MAC_OSX]:
	Use fsspec_to_posix_pathname.
	(main): Change #if !TARGET_API_MAC_CARBON to #ifdef MAC_OS8.
	(XTread_socket) [!MAC_OSX]: Don't pass keyboard events to TSM.
	[MAC_OS8] (make_mac_terminal_frame) [TARGET_API_MAC_CARBON]:
	Set default cursors.
	(mac_initialize) [USE_CARBON_EVENTS && !MAC_OSX] : Don't call
	init_service_handler or init_quit_char_handler.
	(mac_initialize) [!MAC_OSX]: Don't call MakeMeTheFrontProcess.

	* macterm.h (install_window_handler, remove_window_handler)
	(posix_pathname_to_fsspec, fsspec_to_posix_pathname)
	(mac_clear_font_name_table): New externs.

2005-03-03  Thien-Thi Nguyen  <ttn@gnu.org>

	* fileio.c (FILE_SYSTEM_CASE): Define macro if not already defined.
	(Ffile_name_directory): Use FILE_SYSTEM_CASE unconditionally.
	(Fexpand_file_name): Likewise.

2005-03-03  Thien-Thi Nguyen  <ttn@gnu.org>

	* emacs.c (Fkill_emacs): Use EXIT_SUCCESS;
	no longer special-case VMS.  Add bogus return value.

2005-03-02  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (XASSERTS): Define to 0 if not already defined.
	(xassert) [!XASSERTS]: Define dummy version.

2005-03-02  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (redisplay_window): YABX (yet another bogus xassert).
	Reported by David Kastrup.

2005-03-01  Ehud Karni  <ehud@unix.mvs.co.il>

	* xdisp.c (get_next_display_element): Fix control and escape
	glyph from display vector.

2005-03-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (Fposn_at_x_y): Check integerness of X and Y.

2005-02-27  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (fast_find_position): Rename END to BEG.
	(syms_of_xdisp) <menu-bar-update-hook>: Doc fix.

2005-02-27  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_resize_outer_widget): Remove unneeded call to
	gtk_window_resize and x_wm_set_size_hint.

2005-02-25  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (OVERLAY_STRING_CHUNK_SIZE): Increase from 3 to 16.

	* xdisp.c (init_from_display_pos): Don't read past end of
	it->overlay_strings array.

2005-02-25  Stephan Stahl  <stahl@eos.franken.de>  (tiny change)

	* buffer.c (syms_of_buffer): Fix typo.

2005-02-23  Lute Kamstra  <lute@gnu.org>

	* buffer.c (Foverlay_buffer): Doc fix.

2005-02-22  Kim F. Storm  <storm@cua.dk>

	* minibuf.c (Ftry_completion, Fall_completions): Allow both string
	and symbol keys in alists and hash tables.

	* xdisp.c (fast_find_position): Fix search for start of overlay.

2005-02-21  Kim F. Storm  <storm@cua.dk>

	* window.c (window_scroll_pixel_based): When scrolling backwards,
	handle partial visible line at end of window even when we hit PT.

2005-02-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.h: Declare Fcurrent_active_maps, used in doc.c.

2005-02-21  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (move_it_vertically_backward): Eliminate two xasserts.
	I think those asserts are bogus if buffer contains invisible text
	or images.

2005-02-21  David Kastrup  <dak@gnu.org>

	* gtkutil.c (xg_create_frame_widgets): UNBLOCK_INPUT on error.

2005-02-20  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (pos_visible_p): Be sure to move to the specified
	position.  Always get the full ascent / descent of the
	corresponding row, to return reliable rtop and rbot values.
	(back_to_previous_visible_line_start): Fix 2005-01-18 change.
	Must look one character back, as back_to_previous_line_start
	returns position after the newline.
	(move_it_vertically_backward): Fix heuristic for when to move further
	back in case line_height * 2/3 is larger than window height.
	(cursor_row_fully_visible_p): Rename make_cursor_line_fully_visible_p
	as it does not do anything anymore.  Add arg current_matrix_p to
	use current matrix rather than desired matrix when set.
	(try_cursor_movement): Don't scroll to make cursor row fully
	visible if cursor didn't move.  This avoids unexpected recentering
	in case of blinking cursor or accepting process output.
	Use current matrix to check cursor row visibility.
	(redisplay_window): Fix whether to recenter or move to top in case
	cursor line is taller than window height.
	(find_first_unchanged_at_end_row): Stop search if we reach a row
	which not enabled (instead of abort).

2005-02-18  Kim F. Storm  <storm@cua.dk>

	* xfaces.c (Finternal_set_lisp_face_attribute): Allow :color property
	to be nil in a :box attribute value list; customize prints that
	as lisp value when no box color is specified.

	* .gdbinit (pitx, pit): Pretty print display iterator.
	(prowx, prow): Pretty print glyph row.
	(pcursorx, pcursor): Pretty print a window cursor.
	(pwinx, pwin): Pretty print struct window.

2005-02-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* alloc.c (BLOCK_BYTES): Harmless typo.

2005-02-17  Andreas Schwab  <schwab@suse.de>

	* xfns.c (hack_wm_protocols): Use correct type for last parameter
	of XGetWindowProperty to avoid aliasing issues.
	(Fx_window_property): Likewise.

	* xselect.c (Fx_disown_selection_internal): Use union of struct
	input_event and struct selection_input_event to avoid aliasing issues.

	* xterm.c (handle_one_xevent): Use union of struct input_event and
	struct selection_input_event to avoid aliasing issues.
	(SET_SAVED_MENU_EVENT): Adapt reference to inev.

2005-02-17  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (enum it_method): New enum.
	(GET_FROM_*): Its members.
	(struct it): Change member method from function pointer to enum.

	* xdisp.c (check_it, init_from_display_pos, handle_stop)
	(setup_for_ellipsis, handle_single_display_spec)
	(handle_composition_prop, next_overlay_string)
	(get_overlay_strings, reseat_1, reseat_to_string)
	(next_element_from_ellipsis, BUFFER_POS_REACHED_P)
	(in_display_vector_p, display_line, get_next_display_element):
	Change it->method from function pointer to enum.
	(get_next_element): New array to map it->method to function.
	(get_next_display_element): Use it.
	(set_iterator_to_next): Use switch instead of if/else chain.

2005-02-15  Benjamin Riefenstahl  <Benjamin.Riefenstahl@epost.de>

	* w32select.c: Summary: Thorough rework to implement Unicode
	clipboard operations and delayed rendering.

	Drop last_clipboard_text and related code, keep track of
	ownership via clipboard_owner instead.  Drop old #if0 sections.

	(DEFAULT_LCID, ANSICP, OEMCP, QUNICODE, QANSICP, QOEMCP)
	(clipboard_owner, modifying_clipboard, cfg_coding_system)
	(cfg_codepage, cfg_lcid, cfg_clipboard_type, current_text)
	(current_coding_system, current_requires_encoding)
	(current_num_nls, current_clipboard_type, current_lcid):
	New static variables.

	(convert_to_handle_as_ascii, convert_to_handle_as_coded)
	(render, render_all, run_protected, lisp_error_handler)
	(owner_callback, create_owner, setup_config)
	(enum_locale_callback, cp_from_locale, coding_from_cp):
	New local functions.

	(term_w32select, globals_of_w32select): New global functions.

	(Fw32_set_clipboard_data): Ignore parameter FRAME, use
	clipboard_owner instead.  Use delayed rendering and provide
	all text formats.  Provide CF_LOCALE if necessary.

	(Fw32_get_clipboard_data): Handle CF_UNICODETEXT and
	CF_LOCALE.  Fall back to CF_TEXT, if CF_UNICODETEXT is not
	available.  Force DOS line-ends for decoding.

	(Fx_selection_exists_p): Handle CF_UNICODETEXT.

	(syms_of_w32select): Init and register new variables.

	* w32.h: Add prototypes for globals_of_w32select and
	term_w32select.  Make the neighboring K&R declarations into
	prototypes, too.

	* emacs.c: Include w32.h to get function prototypes.
	(main): Call globals_of_w32select.

	* w32.c (term_ntproc): Call term_w32select.

	* s/ms-w32.h: Guard MSC-specific #pragmas with an #ifdef.

2005-02-16  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (BUFFER_POS_REACHED_P): Return true if pos reached and
	at end of display vector.

2005-02-15  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (get_next_display_element): Fix escape-glyph criterion
	for mode and header lines.

	* lread.c (syms_of_lread) <user-init-file>: Doc fix.

	* keymap.h (describe_map_tree): Change decl.

	* keyboard.c (command_loop_1): Always use safe_run_hooks
	to run Qdeferred_action_function.

	* keymap.c (describe_map_tree): New arg MENTION_SHADOW.  Calls changed.
	(describe_map, describe_vector): Likewise.  When it's 1,
	don't omit shadowed bindings, instead mark them as shadowed.

	* doc.c (Fsubstitute_command_keys): Compute list of shadowing maps
	for describe_map_tree.  Pass 1 for MENTION_SHADOW.

	* data.c (Fsetq_default): Allow no arg case.

2005-02-14  Kenichi Handa  <handa@m17n.org>

	* coding.c (encode_coding_string): Always return a unibyte string.
	If NOCOPY is nonzero and there's no need of encoding, make STR
	unibyte directly.

	* xselect.c (lisp_data_to_selection_data): If OBJ is a non-ASCII
	multibyte string, signal an error instead of aborting.

2005-02-12  Dan Nicolaescu  <dann@ics.uci.edu>

	* keyboard.c: If HAVE_FCNTL_H include fcntl.h.

2005-02-12  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (expose_window): Don't fix overlaps for mode lines.

2005-02-10  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (try_window_id): Set first_unchanged_at_end_row to NULL
	if it moves outside window or it doesn't display text.

2005-02-09  Kim F. Storm  <storm@cua.dk>

	* undo.c (Fprimitive_undo): Check that undo function does not
	switch buffer.

2005-02-08  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xselect.c (selection_data_to_lisp_data): For the special case
	type == XA_ATOM, data contains array of int, not array of Atom.
	(x_property_data_to_lisp, selection_data_to_lisp_data):
	Comment update: data must be array of int for format == 32.

2005-02-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* undo.c (Fprimitive_undo): Check veracity of delta,start,end.

2005-02-07  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (Fx_change_window_property): Use long array when format is 32.
	(Fx_window_property): If format is 32 and long is bigger than 32 bits,
	convert long array returned from XGetWindowProperty to an int array.
	(x_set_tool_bar_lines): Check that width and height is greater than
	zero before clearing area.

	* xselect.c (x_reply_selection_request): Pass long array to
	XChangeProperty so that 64 bit longs are handeled correctly.
	(x_get_window_property): If format is 32 and long is bigger than 32
	bits convert data from XGetWindowProperty from long array to int array.
	(lisp_data_to_selection_data): When the input is a vector and the
	format is 32, allocate a long array even if long is bigger than 32 bits.
	(x_fill_property_data): Use char, short and long as the man page
	for XChangeProperty specifies.  This way the data returned is OK for
	both 32 and 64 bit machines.
	(x_handle_dnd_message): Calculate size correctly even for 64 bit
	machines.
	(Fx_send_client_event): Undo change from 2005-02-05,
	x_fill_property_data now handles that case.

	* xfns.c (Fx_backspace_delete_keys_p): Add comment about the
	reason for the approach in the code.

2005-02-07  Kim F. Storm  <storm@cua.dk>

	* undo.c (Fprimitive_undo): Record max one dummmy apply element.

2005-02-06  Richard M. Stallman  <rms@gnu.org>

	* eval.c (Frun_hook_with_args)
	(Frun_hook_with_args_until_success)
	(Frun_hook_with_args_until_failure): Doc fixes.

2005-02-05  Andreas Schwab  <schwab@suse.de>

	* sysdep.c (sys_subshell): Properly terminate execlp argument list.

2005-02-05  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xselect.c (Fx_send_client_event, x_handle_dnd_message): Handle
	the longs in a XClientMessageEvent correctly when long is 64 bits.

2005-02-05  Eli Zaretskii  <eliz@gnu.org>

	* xfaces.c (face_color_supported_p): Use HAVE_WINDOW_SYSTEM
	instead of HAVE_X_WINDOWS, for non-X windowed sessions.

2005-02-03  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xmenu.c (menubar_selection_callback): Force out GTK buffered
	events so the menu event comes after them.  This is to prevent sit-for
	from exiting on buffered events directly after a menu selection,
	lisp code for Help => About Emacs uses sit-for.

	* gtkutil.c (create_menus): Connect selection-done event instead of
	the deactivate event to deactivate_cb.  This will make the last
	leave event come before the call to deactivate_cb, so the leave
	event does not make sit-for exit after a menu selection.

2005-02-03  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (build_frame_matrix_from_leaf_window)
	 [!GLYPH_DEBUG]: Fix xassert.

	* xfaces.c (x_free_gc) [!GLYPH_DEBUG]: Fix xassert.

	* xfns.c (unwind_create_frame) [!GLYPH_DEBUG]: Fix xassert.

2005-02-03  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c: Use MAC_OS_X_VERSION_MAX_ALLOWED to conditionalize by
	the compiling OS version.

	* macfns.c (x_create_tip_frame): Likewise.

	* macterm.c (mac_draw_string_common, x_make_frame_visible): Likewise.

2005-02-03  Richard M. Stallman  <rms@gnu.org>

	* xterm.c (x_error_quitter): On GCC 3 and up, specify noinline.

	* xdisp.c (echo_area_display): Clear echo_message_buffer.

	* buffer.c (Fbury_buffer): Doc fix.

2005-02-02  Steven Tamm  <steventamm@mac.com>

	* macfns.c (unwind_create_frame): Fix compile error due to
	xassert being uncondition, but predicate is.
	* dispnew.c (update_window): Fix compile error due to
	xassert being uncondition, but predicate is.

2005-02-02  Miles Bader  <miles@gnu.org>

	* dispextern.h (xassert): Enable unconditionally.

2005-02-02  Kim F. Storm  <storm@cua.dk>

	* undo.c (Fprimitive_undo): Fix dummy apply undo entry.

2005-02-02  Kenichi Handa  <handa@m17n.org>

	* casefiddle.c (casify_object): Enable changing characters of
	different byte length.
	(casify_region): Fix loop condition, args to replace_range_2, and
	update opoint_byte.

	* insdel.c (replace_range_2): Fix bugs in adjusting markers and point.

2005-02-01  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (back_to_previous_visible_line_start): Reset iterator
	stack before calling handle_display_prop.

2005-01-31  Kim F. Storm  <storm@cua.dk>

	* undo.c (Qapply): New lisp var.
	(syms_of_undo): Intern and staticpro it.
	(Fprimitive_undo): Support formats (apply FUNNAME . ARGS) and
	(apply DELTA BEG END FUNNAME . ARGS) instead of (FUNNAME . ARGS).

	* buffer.c (syms_of_buffer) <buffer-undo-list>: Doc fix.

2005-01-30  Jesper Harder  <harder@phys.au.dk>

	* macterm.c (syms_of_macterm) <mac-reverse-ctrl-meta>
	<mac-emulate-three-button-mouse>: Fix docstring indentation.

2005-01-29  Luc Teirlinck  <teirllm@auburn.edu>

	* undo.c (syms_of_undo) <undo-outer-limit>: Doc update.
	Increase value to 3 Meg.

2005-01-29  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (show_hourglass): Use FRAME_X_WINDOW as parent for GTK,
	button events are not received otherwise.

2005-01-29  Richard M. Stallman  <rms@gnu.org>

	* buffer.c (syms_of_buffer) <buffer-undo-list>: Doc fix.

	* undo.c (Fprimitive_undo): Handle (FUNNAME . ARGS) by calling FUNNAME.

2005-01-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (access_keymap): YAILOM.

2005-01-27  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (get_phys_cursor_geometry): New function to calculate
	phys cursor position and size for hollow cursor.  Position is
	aligned with get_glyph_string_clip_rect and ensures that a hollow
	cursor is shown, even when the actual glyph is not visible.

	* dispextern.h (get_phys_cursor_geometry): Add prototype.

	* xterm.c (x_clip_to_row): Ensure y >= 0.
	(x_draw_hollow_cursor): Use get_phys_cursor_geometry.

	* w32term.c (x_draw_hollow_cursor): Use get_phys_cursor_geometry.

	* macterm.c (x_draw_hollow_cursor): Use get_phys_cursor_geometry.

2005-01-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c (x_error_quitter): Add a prototype.  Make it static again.

2005-01-27  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (get_glyph_string_clip_rect): Always show a cursor
	glyph, even when row is only partially visible and actual cursor
	position is not visible.

2005-01-24  Richard M. Stallman  <rms@gnu.org>

	* xterm.c (x_error_quitter): No longer static, and moved after
	x_error_handler.

2005-01-24  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (move_it_by_lines): If we move forward after going too
	far back, cancel move if end position is same as start position.

2005-01-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispextern.h (struct glyph_string): New members clip_head and
	clip_tail.

	* xdisp.c (get_glyph_string_clip_rect): Restrict horizontal clip
	region to the area between clip_head and clip_tail.
	(draw_glyphs): Record the area that need to be actually redrawn to
	the new variables clip_head and clip_tail when there are
	overhangs.  Set values of these variables to the corresponding
	members in struct glyph_string.  Refine x coordinates for
	notice_overwritten_cursor using clip_head and clip_tail.

	* macgui.h (STORE_XCHARSETSTRUCT): New macro.

	* macterm.c (mac_compute_glyph_string_overhangs): Implement with
	QDTextBounds.
	(x_draw_glyph_string): Don't fill the background of the successor
	of a glyph with a right overhang if the successor will draw a cursor.
	(XLoadQueryFont): Obtain font metrics using QDTextBounds.
	(x_redisplay_interface): Add entry for compute_glyph_string_overhangs.

2005-01-24  Kim F. Storm  <storm@cua.dk>

	* window.c (window_scroll_pixel_based): Fix scrolling in the wrong
	direction if window height was smaller than next-screen-context-lines.
	Now always scroll at least one line in the requested direction.
	Ensure that we actually do scroll backwards when requested to do so.

	* xdisp.c (redisplay_window): Only try to make cursor line fully
	visible once (to avoid redisplay loop).

2005-01-23  Kim F. Storm  <storm@cua.dk>

	* window.c (Fpos_visible_in_window_p): Simplify return value for
	partially visible rows.
	(window_scroll_pixel_based): Adapt to that change.

	* window.c (window_scroll_pixel_based): Force moving to next line
	if scrolling doesn't move start point, e.g. if looking at tall image.

	* xdisp.c (pos_visible_p): Return 0 if non-interactive.
	Clear last_height before calling line_bottom_y to get real height.
	Fix calculation of y.

2005-01-22  Steven Tamm  <steventamm@mac.com>

	* s/darwin.h: Removed PTY_ITERATION from here.
	(DARWIN): Define.

	* process.c (init_process): Default process-connection-type to
	nil on darwin 6 or less, t if it is 7 or higher.  This way the
	broken pty behavior is still allowed on darwin 6 for interactive
	processes for people that know what they are doing.

2005-01-22  Kim F. Storm  <storm@cua.dk>

	* window.c (auto_window_vscroll_p): New boolean.
	(syms_of_window): DEFVAR_BOOL it.
	(Fpos_visible_in_window_p): Extend return value to include RTOP
	and RBOT values if FULLY is nil.
	(window_scroll_pixel_based): Adjust vscroll for partially visible
	rows if auto_window_vscroll_p is set.
	(Fset_window_vscroll): Do nothing if vscroll is not modified.

	* xdisp.c (pos_visible_p): Replace FULLY arg by RTOP and RBOT args
	to return number of partially invisible pixels at top and bottom
	of the dislay row at POS.

	* lisp.h (pos_visible_p): Fix prototype.

2005-01-21  Richard M. Stallman  <rms@gnu.org>

	* fileio.c (Fcopy_file): Doc fix.

2005-01-21  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_tool_bar_detach_callback): Remove unused variable bw.
	(xg_get_file_name): Move declaration ofx_use_old_gtk_file_dialog to
	start of function for older compilers.

2005-01-20  Richard M. Stallman  <rms@gnu.org>

	* editfns.c (Fmessage): If arg is "", return "" (as before).

	* keymap.c (access_keymap): Protect from bad value of meta_prefix_char.

	* .gdbinit (xgetptr, xgetint, xgettype): Copy $arg0 into a temp
	variable.

2005-01-20  Steven Tamm  <steventamm@mac.com>

	* editfns.c (Voperating_system_release): Add.
	(init_editfns): Assign new variable operating-system-release
	based on call to uname if available.
	(get_operating_system_release): Add function to
	allow c-level access to operating system release.

	* config.h: Regenerated.

	* s/darwin.h (PTY_ITERATION): Don't allow PTYs on darwin 6 or less.
	(MIN_PTY_KERNEL_VERSION): Define minimum kernel version for
	using ptys as '7'.

2005-01-20  Kim F. Storm  <storm@cua.dk>

	* alloc.c (STRING_MARKED_P, VECTOR_MARKED_P): Return boolean.

	* xterm.c (x_draw_glyph_string_box): Fix last_x for full width rows.
	Thanks to Chong Yidong <cyd@stupidchicken.com> for debugging this.

	* macterm.c (x_draw_glyph_string_box): Likewise.

	* w32term.c (x_draw_glyph_string_box): Likewise.

	* indent.c (Fvertical_motion): Temporarily disable selective display.

2005-01-19  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (note_mode_line_or_margin_highlight): Fix :pointer
	image property.

	* fns.c (sweep_weak_table): Advance prev pointer when we keep a pair.

2005-01-18  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (fast_find_position): Backtrack to find first row if
	charpos is inside a display overlay that spans multiple lines.

2005-01-18  Kenichi Handa  <handa@m17n.org>

	* coding.c (decode_coding_iso2022): Translate invalid codes if
	translation-table is specified.

2005-01-18  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (back_to_previous_visible_line_start): Undo 2004-12-28
	change.  If handle_display_prop indicates newline is replaced by
	image or text, move back to start of relevant overlay or interval
	and continue scan from there.  Simplify.

2005-01-17  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (mode_line_string, marginal_area_string):
	Fix off-by-one error in search for glyph.

2005-01-16  Kim F. Storm  <storm@cua.dk>

	* macterm.c (syms_of_macterm) <mac-allow-anti-aliasing>: Doc fix.

2005-01-16  Steven Tamm  <steventamm@mac.com>

	* macterm.c (mac_to_x_fontname): Remove spurious argument.

2005-01-16  Andreas Schwab  <schwab@suse.de>

	* macterm.c (mac_draw_string_common): Fix compilation on OSX 10.1.

2005-01-16  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* fringe.c (Fdefine_fringe_bitmap, init_fringe): When assigning
	fringe_faces, cast result from xmalloc/xrealloc to Lisp_Object *.

2005-01-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c (READABLE_EVENTS_DO_TIMERS_NOW)
	(READABLE_EVENTS_FILTER_EVENTS, READABLE_EVENTS_IGNORE_SQUEEZABLES):
	New flags for readable_events.
	(get_filtered_input_pending, readable_filtered_events): Remove.
	(tracking_off): Call readable_events and get_input_pending with
	flag READABLE_EVENTS_DO_TIMERS_NOW.
	(readable_events): Move code from old readable_filtered_events here,
	but check new READABLE_EVENTS_* in argument flags instead of previous
	two boolean arguments do_timers_now and filter_events.
	If we are doing mouse tracking and the mouse moved, return only if
	READABLE_EVENTS_IGNORE_SQUEEZABLES is not set in flags.
	(swallow_events): Call get_input_pending with flag
	READABLE_EVENTS_DO_TIMERS_NOW.
	(get_input_pending): Move code from old get_filtered_input_pending
	here.  Replace boolean arguments do_timers_now, filter_events with
	flags, and pass flags to readable_events.  Document new
	READABLE_EVENTS_* flags.
	(detect_input_pending_ignore_squeezables): New function.
	(detect_input_pending_run_timers): Call get_input_pending with flag
	READABLE_EVENTS_DO_TIMERS_NOW.
	(Finput_pending_p): Call get_input_pending with flags
	READABLE_EVENTS_DO_TIMERS_NOW and READABLE_EVENTS_FILTER_EVENTS.

	* dispnew.c (update_window, update_frame_1): Replace calls to
	detect_input_pending with detect_input_pending_ignore_squeezables
	so that redisplay is not paused if the event queue contains only
	mouse movements.

	* lisp.h: Declare detect_input_pending_ignore_squeezables.

2005-01-15  Steven Tamm  <steventamm@mac.com>

	* macterm.c (Vmac_use_core_graphics): Declare variable for
	mac-allow-anti-aliasing.
	(syms_of_macterm): DEFVAR_LISP and initialize it.
	(mac_draw_string_common): Use core graphics text rendering if
	mac-allow-anti-aliasing is enabled.

	* macfns.c (Fx_file_dialog): Save As dialog includes only the
	file name in the text box.

2005-01-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (x_set_foreground_color, x_set_background_color):
	Sync with xfns.c.
	(mac_window, x_create_tip_frame): Use XSetWindowBackground.
	* macterm.c (XSetBackground, XSetWindowBackground): New functions.
	* macterm.h (XSetBackground, XSetWindowBackground): Add externs.

2005-01-14  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (Fposn_at_x_y): Add optional arg WHOLE.

2005-01-13  Richard M. Stallman  <rms@gnu.org>

	* keymap.c (Fcurrent_active_maps): Ignore Voverriding_local_map
	if Voverriding_terminal_local_map is non-nil.

	* keyboard.c (syms_of_keyboard): Doc fix.

2005-01-13  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (Fformat_mode_line): Fix last change.  Remove NO_PROPS arg
	(specify 0 for FACE instead).  Reorder arg list.  Doc fix.

2005-01-12  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (Fformat_mode_line): New arg FACE specifies a default
	face property for characters that don't specify one.

	* fns.c (Frequire): Record in load-history unconditionally.

2005-01-10  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (merge_faces): Rename from merge_into_realized_face.

	* xfaces.c (merge_faces): Rename from merge_into_realized_face.
	Callers changed.
	Add support to merge with lisp face id too (if face_name is t).

	* xdisp.c (get_next_display_element, next_element_from_display_vector):
	Don't lookup lface_id from display table glyphs here; instead use
	merge_faces to merge the lisp face id into current face.

2005-01-09  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (struct it): New member dpvec_face_id.
	(merge_into_realized_face): Add prototype.

	* xfaces.c (merge_into_realized_face): New function.  Used to
	merge escape-glyph face or face from display table into current	face.

	* xdisp.c (Vshow_nonbreak_escape): New lisp var.
	(syms_of_xdisp): DEFVAR_LISP it.
	(escape_glyph_face): Remove var.
	(redisplay_window): Don't initialize it.
	(setup_for_ellipsis, get_next_display_element):
	Set it->dpvec_face_id to -1.
	(get_next_display_element): Test Vshow_nonbreak_escape.
	Do not setup escape_glyph_face.
	Properly merge escape-glyph face or face from display table with
	current face for escape and control characters.
	Set it->dpvec_face_id to relevant face id instead of adding it to each
	element of display vector.
	(next_element_from_display_vector): If it->dpvec_face_id is set,
	use that instead of lface_id from glyph itself.

2005-01-08  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.h (struct x_output): New member, toolbar_detached.

	* gtkutil.c (xg_create_frame_widgets): Set initial tool bar height to
	38.
	(xg_tool_bar_detach_callback): Set toolbar_detached to 1.
	(xg_tool_bar_attach_callback): Set toolbar_detached to 0.
	(xg_create_tool_bar): Initialize toolbar_detached.
	(update_frame_tool_bar): Only set FRAME_TOOLBAR_HEIGHT (f) if
	toolbar_detached is zero.

2005-01-07  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xmenu.c (create_and_show_popup_menu): Pass zero as button to
	gtk_menu_popup if not for_click, so callbacks for the menu are called.

	* gtkutil.c (xg_gtk_scroll_destroy, xg_create_scroll_bar)
	(xg_tool_bar_callback, xg_tool_bar_help_callback)
	(update_frame_tool_bar): Cast to EMACS_INT to avoid compiler warning.

	* xselect.c (x_get_foreign_selection, x_fill_property_data)
	(Fx_get_atom_name, Fx_send_client_event): Replace XFLOAT with
	XFLOAT_DATA to get extract number from Lisp object.

2005-01-07  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (set_iterator_to_next): Fix 2004-12-13 change.
	Set stop_charpos to current charpos instead of 0.

2005-01-06  Nick Roberts  <nickrob@snap.net.nz>

	* xdisp.c (Fformat_mode_line): First arg now required.

2005-01-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (XLoadQueryFont): Correctly handle 0 size
	font widths that are returned from some Japanese fonts.

2005-01-06  Kim F. Storm  <storm@cua.dk>

	* fringe.c (fringe_faces): Change to Lisp_Object pointer.
	(draw_fringe_bitmap_1): Lookup user defined fringe faces here.
	(destroy_fringe_bitmap): Set fringe_faces element to nil.
	(Fdefine_fringe_bitmap, init_fringe): Change allocation of
	fringe_faces array and init elements to nil.
	(Fset_fringe_bitmap_face): Set fringe_faces to face name instead of
	non-persistent face id.
	(mark_fringe_data): New function for GC.

	* alloc.c (mark_fringe_data): Declare extern.
	(Fgarbage_collect): Call mark_fringe_data.

	* alloc.c (overrun_check_free): Invalidate freed memory if
	XMALLOC_CLEAR_FREE_MEMORY is defined.

2005-01-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c: Include sys/param.h.
	[TARGET_API_MAC_CARBON] (mac_nav_event_callback): New declaration
	and function.
	[TARGET_API_MAC_CARBON] (Fx_file_dialog): Use MAXPATHLEN for size
	of filename string.  Set event callback function when creating
	dialog boxes.  Add code conversions for filenames.  Don't dispose
	of apple event descriptor record if failed to create it.

	* macterm.c: Include sys/param.h.
	[USE_CARBON_EVENTS] (mac_handle_window_event): Add handler for
	kEventWindowUpdate.
	(install_window_handler) [USE_CARBON_EVENTS]: Register it.
	(do_ae_open_documents) [TARGET_API_MAC_CARBON]: Get FSRef instead
	of FSSpec from apple event descriptor record.
	(do_ae_open_documents) [TARGET_API_MAC_CARBON]: Use MAXPATHLEN for
	size of filename string.
	[TARGET_API_MAC_CARBON] (mac_do_receive_drag): Likewise.
	[TARGET_API_MAC_CARBON] (mac_do_receive_drag): Return error when a
	file dialog is in action.
	[TARGET_API_MAC_CARBON] (mac_do_track_drag): Likewise.
	Reject only when there are no filename items.  Set background color
	before (un)highlighting the window below the dragged items.
	(XTread_socket) [USE_CARBON_EVENTS]: Don't call do_window_update.

2005-01-05  Romain Francoise  <romain@orebokech.com>

	* term.c (encode_terminal_code): Fix buffer size computation.

2005-01-04  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (Fformat_mode_line): Doc fix.

2005-01-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* alloc.c (refill_memory_reserve): Move.
	(emacs_blocked_free, emacs_blocked_malloc, emacs_blocked_realloc)
	(reset_malloc_hooks, uninterrupt_malloc) [SYNC_INPUT]: Don't define.

2005-01-03  Richard M. Stallman  <rms@gnu.org>

	* window.c (window_scroll_pixel_based): Don't correct preserve_y
	for CURRENT_HEADER_LINE_HEIGHT when moving backwards.

2005-01-03  Jason Rumney  <jasonr@gnu.org>

	* w32bdf.c (w32_load_bdf_font): Set fontp->average_width and
	fontp->space_width to FONT_WIDTH so they are valid.

	* w32fns.c (w32_load_system_font): Set FONT_WIDTH to maximum, not
	average width.  Set fontp->average_width and fontp->space_width to
	their appropriate values.

	* w32term.c (x_new_font): Set FRAME_COLUMN_WIDTH to
	fontp->average_width, not FONT_WIDTH.  Set FRAME_SPACE_WIDTH to
	fontp->space_width.

2005-01-03  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (x_new_font): Set FRAME_SPACE_WIDTH.
	(x_font_min_bounds, XLoadQueryFont): Use the correct font width
	metrics for max and min bounds.
	(x_load_font): Correctly calculate average font width metrics.

2005-01-02  Richard M. Stallman  <rms@gnu.org>

	* alloc.c (Fgarbage_collect): Don't truncate_undo_list on dead buffers.

2004-12-31  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): Clear area in expose event for GTK.

2004-12-31  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (setup_for_ellipsis, get_next_display_element):
	Set it->ellipsis_p to 1 or 0.
	(display_line): Record whether row ends in mid-ellipsis.
	(set_cursor_from_row): If ends in ellipsis, find start of it.
	(cursor_row_p): If PT's at the end of the ellipsis the row
	ends within, don't display cursor on this row.

	* dispextern.h (struct it): New element ellipsis_p.
	(struct glyph_row): New element ends_in_ellipsis_p.

	* xdisp.c (BUFFER_POS_REACHED_P): We haven't reached the specified
	position if we're reading from something other than the buffer.

	* window.c (window_scroll_pixel_based): Only look at
	Vscroll_preserve_screen_position if the old PT can't be kept.
	(syms_of_window) <scroll-preserve-screen-position>: Doc fix.

2004-12-30  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (get_line_height_property): New function extracted from
	original calc_line_height_property.
	(calc_line_height_property): Rework.  Handle t and (nil . ratio).
	(x_produce_glyphs): Use them to handle line-height and
	line-spacing according to new height spec.
	(Qtotal): Remove.
	(syms_of_xdisp): Remove intern and staticpro for Qtotal.

2004-12-30  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Finsert_file_contents): Don't use
	current_buffer->buffer_file_coding_system even if REPLACE is
	non-nil.  Call Qafter_insert_file_set_coding with the second arg VISIT.

	* fontset.h (struct font_info): New members space_width and
	average_width.

	* frame.h (struct frame): New member space_width.
	(FRAME_SPACE_WIDTH): New macro.

	* xterm.h (struct x_display_info): New member Xatom_AVERAGE_WIDTH.

	* xterm.c (x_new_font): Set FRAME_COLUMN_WIDTH to
	fontp->average_width, not FONT_WIDTH.  Set FRAME_SPACE_WIDTH to
	fontp->space_width.
	(x_load_font): Calculate fontp->space_width and fontp->average_width.
	(x_term_init): Initialize dpyinfo->Xatom_AVERAGE_WIDTH.

	* xdisp.c (x_produce_glyphs): Calculate tab width by
	FRAME_SPACE_WIDTH, not FRAME_COLUMN_WIDTH.

2004-12-29  Sanghyuk Suh  <han9kin@mac.com>

	* macterm.c (SelectionRange): Add Xcode position apple event struct.
	(do_ae_open_documents): Handle Xcode-style file position open events.

2004-12-29  Luc Teirlinck  <teirllm@auburn.edu>

	* buffer.c (syms_of_buffer) <vertical-scroll-bar>: Correct typo.

2004-12-29  Richard M. Stallman  <rms@gnu.org>

	* buffer.c (syms_of_buffer) <vertical-scroll-bar>: Doc fix.

2004-12-29  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (install_window_handler): Modify extern to return OSErr
	value.
	(mac_window): Handle return value of install_window_handler.

	* macterm.c (reflect_byte): Remove function.
	(mac_create_bitmap_from_bitmap_data): Don't call reflect_byte.
	Lookup table instead.
	(mac_do_font_lists): Simplify calculation of the longest
	nonspecial string.
	(init_mac_drag_n_drop): Remove function	and declaration.
	(mac_initialize) [TARGET_API_MAC_CARBON]: Don't call
	init_mac_drag_n_drop.
	(mac_do_track_drag): New function and declaration.
	(install_window_handler): Return OSErr value.
	(install_window_handler) [TARGET_API_MAC_CARBON]:
	Register handlers for tracking/receiving drag-and-drop items.
	(do_ae_open_documents): Generate unibyte strings for filenames.
	(mac_do_receive_drag) [TARGET_API_MAC_CARBON] : Likewise.
	Reject only non-filename items.  Set event modifiers, and return value.

2004-12-28  Dan Nicolaescu  <dann@ics.uci.edu>

	* coding.c (decode_coding): Fix previous change.

2004-12-28  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (back_to_previous_visible_line_start):
	Don't call handle_display_prop.

2004-12-28  Dan Nicolaescu  <dann@ics.uci.edu>

	* coding.c (decode_coding_XXX, decode_composition_emacs_mule)
	(decode_coding_emacs_mule, encode_coding_emacs_mule)
	(decode_coding_iso2022, encode_designation_at_bol)
	(encode_coding_iso2022, decode_coding_sjis_big5, decode_eol)
	(decode_coding): Constify arguments and local vars.

2004-12-27  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xmenu.c (popup_get_selection): Only pop down dialogs
	on C-g and Escape.
	(popup_get_selection): Remove parameter down_on_keypress.
	(create_and_show_popup_menu, create_and_show_dialog):
	Remove parameter down_on_keypress to popup_get_selection.

2004-12-27  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispextern.h: Change HAVE_CARBON to MAC_OS.
	(struct glyph_string): Likewise.

	* emacs.c (main) [MAC_OS8]: Call mac_term_init instead of
	mac_initialize.

	* fileio.c (Fnext_read_file_uses_dialog_p, Fread_file_name):
	Change TARGET_API_MAC_CARBON to HAVE_CARBON.

	* fns.c (vector): Change MAC_OSX to MAC_OS.

	* frame.c (x_set_frame_parameters, x_report_frame_params)
	(x_set_fullscreen): Remove #ifndef HAVE_CARBON.
	(x_set_border_width, Vdefault_frame_scroll_bars):
	Change HAVE_CARBON to MAC_OS.

	* image.c [MAC_OS]: Include sys/stat.h.
	[MAC_OS && !MAC_OSX]: Include sys/param.h, ImageCompression.h, and
	QuickTimeComponents.h.

	* mac.c [!MAC_OSX] (mac_wait_next_event): Add extern.
	[!MAC_OSX] (select): Use mac_wait_next_event.
	[!MAC_OSX] (run_mac_command): Change EXEC_SUFFIXES to Vexec_suffixes.
	[!MAC_OSX] (select, run_mac_command): Change `#ifdef
	TARGET_API_MAC_CARBON' to `#if TARGET_API_MAC_CARBON'.
	(mac_clear_font_name_table): Add extern.
	(Fmac_clear_font_name_table): New defun.
	(syms_of_mac): Defsubr it.
	[MAC_OSX] (SELECT_POLLING_PERIOD_USEC): New define.
	[MAC_OSX] (select_and_poll_event): New function.
	[MAC_OSX] (sys_select): Use it.
	[MAC_OSX && SELECT_USE_CFSOCKET] (socket_callback): New function.
	[MAC_OSX && SELECT_USE_CFSOCKET]
	(SELECT_TIMEOUT_THRESHOLD_RUNLOOP, EVENT_CLASS_SOCK): New defines.
	[MAC_OSX] (sys_select) [SELECT_USE_CFSOCKET]: Use CFSocket and
	RunLoop for simultaneously monitoring two kinds of inputs, window
	events and process outputs, without periodically polling.

	* macfns.c (mac_initialized): Remove extern.
	(stricmp): Put in #if 0.  All callers changed to use xstricmp in
	xfaces.c.
	(strnicmp): Decrement `n' at the end of each loop, not the beginning.
	(check_mac): Use the term "Mac native windows" instead of "Mac OS".
	(check_x_display_info, x_display_info_for_name): Sync with xfns.c.
	(mac_get_rdb_resource): New function (from w32reg.c).
	(x_get_string_resource): Use it.
	(install_window_handler): Add extern.
	(mac_window): New function.
	(Fx_create_frame): Use it instead of make_mac_frame.
	Set parameter for Qfullscreen.  Call x_wm_set_size_hint.
	(Fx_open_connection, Fx_close_connection): New defuns.
	(syms_of_macfns): Defsubr them.
	(x_create_tip_frame) [TARGET_API_MAC_CARBON]:
	Add kWindowNoUpdatesAttribute to the window attribute.
	(x_create_tip_frame) [!TARGET_API_MAC_CARBON]: Use NewCWindow.
	(x_create_tip_frame): Don't call ShowWindow.
	(Fx_show_tip): Call ShowWindow.
	(Fx_file_dialog): Change `#ifdef TARGET_API_MAC_CARBON' to `#if
	TARGET_API_MAC_CARBON'.
	(mac_frame_parm_handlers): Set handlers for Qfullscreen.
	(syms_of_macfns) [MAC_OSX]: Initialize mac_in_use to 0.

	* macgui.h [!MAC_OSX]: Don't include Controls.h.  Include Windows.h.
	(Window): Typedef to WindowPtr and move outside `#if
	TARGET_API_MAC_CARBON'.
	(XSizeHints): New struct.

	* macterm.c (x_update_begin, x_update_end)
	[TARGET_API_MAC_CARBON]: Disable screen updates during update of a
	frame.
	(x_draw_glyph_string_background, x_draw_glyph_string_foreground)
	[MAC_OS8]: Use XDrawImageString/XDrawImageString16.
	(construct_mouse_click): Put in #if 0.
	(x_check_fullscreen, x_check_fullscreen_move): Remove decls.
	(x_scroll_bar_create, x_scroll_bar_handle_click): Change `#ifdef
	TARGET_API_MAC_CARBON' to `#if TARGET_API_MAC_CARBON'.
	(activate_scroll_bars, deactivate_scroll_bars)
	[!TARGET_API_MAC_CARBON]: Use ActivateControl/DeactivateControl.
	(x_make_frame_visible) [TARGET_API_MAC_CARBON]: Reposition window
	if the position is neither user-specified nor program-specified.
	(x_free_frame_resources): Free size_hints.
	(x_wm_set_size_hint): Allocate size_hints if needed.  Set size_hints.
	(mac_clear_font_name_table): New function.
	(mac_do_list_fonts): Initialize font_name_table if needed.
	(x_list_fonts): Don't initialize font_name_table.  Add BLOCK_INPUT
	around mac_do_list_fonts.
	(mac_unload_font): New function.
	(x_load_font): Add BLOCK_INPUT around XLoadQueryFont.
	(init_mac_drag_n_drop, mac_do_receive_drag): Enclose declarations
	and definitions with #if TARGET_API_MAC_CARBON.
	[USE_CARBON_EVENTS] (mac_handle_window_event): Add decl.
	(install_window_handler): Add decl.
	(do_window_update): Add BeginUpdate/EndUpdate for the tooltip
	window.  Use UpdateControls.  Get the rectangle that should be
	updated and restrict the target of expose_frame to it.
	(do_grow_window): Set minimum height/width according to size_hints.
	(do_grow_window) [TARGET_API_MAC_CARBON]: Use ResizeWindow.
	(do_zoom_window): Don't use x_set_window_size.
	[USE_CARBON_EVENTS] (mac_handle_window_event): New function.
	(install_window_handler): New function.
	[!USE_CARBON_EVENTS] (mouse_region): New variable.
	[!USE_CARBON_EVENTS] (mac_wait_next_event): New function.
	(XTread_socket) [USE_CARBON_EVENTS]: Move call to
	GetEventDispatcherTarget inside BLOCK_INPUT.
	(XTread_socket) [!USE_CARBON_EVENTS]: Use mac_wait_next_event.
	Update mouse_region when mouse is moved.
	(make_mac_frame): Remove.
	(make_mac_terminal_frame): Put in #ifdef MAC_OS8.
	Initialize mouse pointer shapes.  Change values of f->left_pos and
	f->top_pos.  Don't use make_mac_frame.  Use NewCWindow.
	Don't call ShowWindow.
	(mac_initialize_display_info) [MAC_OSX]: Create mac_id_name from
	Vinvocation_name and Vsystem_name.
	(mac_make_rdb): New function (from w32term.c).
	(mac_term_init): Use it.  Add BLOCK_INPUT.  Error if display has
	already been opened.  Don't pass argument to
	mac_initialize_display_info.  Don't set dpyinfo->height/width.
	Add entries to x_display_list and x_display_name_list.
	(x_delete_display): New function.
	(mac_initialize): Don't call mac_initialize_display_info.
	(syms_of_macterm) [!MAC_OSX]: Don't call Fprovide.

	* macterm.h (check_mac): Add extern.
	(struct mac_output): New member size_hints.
	(FRAME_SIZE_HINTS): New macro.
	(mac_unload_font): Add extern.

	* xdisp.c (expose_window, expose_frame): Remove kludges for Mac.

	* xfaces.c (clear_font_table) [MAC_OS]: Call mac_unload_font.

2004-12-27  Richard M. Stallman  <rms@gnu.org>

	* buffer.c (Fbuffer_disable_undo): Delete (move to simple.el).
	(syms_of_buffer): Don't defsubr it.

	* process.c (list_processes_1): Set undo_list instead
	of calling Fbuffer_disable_undo.

	* xdisp.c (single_display_spec_string_p): Rename from
	single_display_prop_string_p.
	(single_display_spec_intangible_p): Rename from
	single_display_prop_intangible_p.
	(handle_single_display_spec): Rename from handle_single_display_prop.
	Rewritten to be easier to understand.

	Change in load-history format.  Functions now get (defun . NAME),
	and variables get just NAME.

	* data.c (Fdefalias): Use (defun . FN_NAME) in LOADHIST_ATTACH.

	* eval.c (Fdefun, Fdefmacro): Use (defun . FN_NAME) in LOADHIST_ATTACH.
	(Fdefvaralias, Fdefvar, Fdefconst): Use just SYM in LOADHIST_ATTACH.
	(Qdefvar): Var deleted.
	(syms_of_eval): Don't initialze it.

	* lread.c (syms_of_lread) <load-history>: Doc fix.

2004-12-27  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xmenu.c (popup_get_selection): Pop down on C-g.
	(set_frame_menubar): Install translations for Lucid/Motif/Lesstif that
	pops down menu on C-g.
	(xdialog_show): If dialog popped down and no button in the dialog was
	pushed, call Fsignal to quit.
	(xmenu_show): In no toolkit version, if menu returns NO_SELECT call
	Fsignal to quit.

	* xfns.c (Fx_file_dialog): Motif/Lesstif version: Pop down on C-g.

	* gtkutil.c (xg_initialize): Install bindings for C-g so that
	dialogs and menus pop down.

2004-12-27  Kenichi Handa  <handa@m17n.org>

	* coding.c (code_convert_region): Fix calculation of `ratio'.

2004-12-25  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (update_frame_tool_bar): Make the value of
	tool-bar-button-margin control margins of images in tool bar.

	* alloc.c (check_depth): New variable.
	(overrun_check_malloc, overrun_check_realloc): Only add
	overhead and write check pattern if check_depth is 1 (to handle
	recursive calls).  Increase/decrease check_depth in entry/exit.
	(overrun_check_free): Only check for overhead if check_depth is 1.
	Increase/decrease check_depth in entry/exit.

2004-12-23  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* keyboard.c (input_available_signal): Call SIGNAL_THREAD_CHECK
	before touching input_available_clear_time, to avoid accessing it
	from multiple threads.

2004-12-23  Jason Rumney  <jasonr@gnu.org>

	* image.c (__WIN32__) [HAVE_NTGUI]: Define for correct behaviour
	of JPEG library.

2004-12-22  Richard M. Stallman  <rms@gnu.org>

	* emacs.c (main): If batch mode, set Vundo_outer_limit to nil.

	* lisp.h (Vundo_outer_limit): Fix decl.

	* undo.c (Vundo_outer_limit): Replaces undo_outer_limit.
	Uses changed.
	(syms_of_undo): Initialize appropriately.
	(truncate_undo_list): If it's nil, there's no limit.

2004-12-22  Kenichi Handa  <handa@m17n.org>

	* xselect.c (Fx_get_cut_buffer_internal): Return a unibyte string.

2004-12-21  Richard M. Stallman  <rms@gnu.org>

	* eval.c (unwind_to_catch): Clear immediate_quit.

	* xdisp.c (get_next_display_element): Display codes 8a0 and 8ad
	specially as `\ ' and `\-'.

	* keyboard.c (kbd_buffer_store_event_hold):
	In the code for while-no-input, handle immediate_quit.

	* alloc.c (Fgarbage_collect): Update call to truncate_undo_list.
	Call that at the very start.
	(undo_limit, undo_strong_limit, undo_outer_limit): Move to undo.c.
	(syms_of_alloc): Don't define undo-limit,
	undo-strong-limit and undo-outer-limit here.

	* undo.c (truncate_undo_list): Return void.
	Take just one argument, the buffer.
	Make it current, and inhibit recursive GC.
	Access and update the undo list directly; return void.
	Refer to the undo...limit variables directly.
	Test undo_outer_limit only after counting the whole current command.
	When it's exceeded, call the function in undo-outer-limit-function.
	(undo_limit, undo_strong_limit, undo_outer_limit): From alloc.c.
	(Vundo_outer_limit_function): New variable.
	(syms_of_undo): Define undo-limit, undo-strong-limit
	and undo-outer-limit here, and undo-outer-limit-function.
	Doc fixes.

	* lisp.h (truncate_undo_list): Update decl.

2004-12-21  Piet van Oostrum  <piet@cs.uu.nl>

	* fileio.c (Fread_file_name): Delete duplicates in
	file-name-history when history_delete_duplicates is true.

2004-12-20  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_do_list_fonts): Fix memory leak

2004-12-20  Richard M. Stallman  <rms@gnu.org>

	* regex.c (re_match_2_internal) <symend, wordend>:
	Fix calls to UPDATE_SYNTAX_TABLE_FORWARD.

2004-12-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (endif, x_font_name_to_mac_font_name):
	Use maccentraleurroman instead of maccentraleuropean
	(mac_c_string_match, mac_do_list_fonts): Speed up font search by
	quickly finding a specific font without needing regexps.

2004-12-15  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* syssignal.h: Declare main_thread.
	(SIGNAL_THREAD_CHECK): New macro.

	* keyboard.c (input_available_signal): Move thread checking code
	to macro SIGNAL_THREAD_CHECK and call that macro.
	(interrupt_signal): Call SIGNAL_THREAD_CHECK.

	* alloc.c (uninterrupt_malloc): Move main_thread to emacs.c.

	* emacs.c: Define main_thread.
	(main): Initialize main_thread.
	(handle_USR1_signal, handle_USR2_signal, fatal_error_signal)
	(memory_warning_signal): Call SIGNAL_THREAD_CHECK.

	* floatfns.c (float_error): Call SIGNAL_THREAD_CHECK.

	* dispnew.c (window_change_signal): Call SIGNAL_THREAD_CHECK.

	* sysdep.c (select_alarm): Call SIGNAL_THREAD_CHECK.

	* process.c (send_process_trap, sigchld_handler):
	Call SIGNAL_THREAD_CHECK.

	* data.c (arith_error): Call SIGNAL_THREAD_CHECK.

	* atimer.c (alarm_signal_handler): Call SIGNAL_THREAD_CHECK.

	* xterm.c (xg_scroll_callback): Update XG_LAST_SB_DATA before
	returning when xg_ignore_gtk_scrollbar is true.

2004-12-14  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (read_char): Save and restore echo_string when
	handling input method.

2004-12-13  Richard M. Stallman  <rms@gnu.org>

	* eval.c (syms_of_eval) <quit-flag>: Doc fix.

	* keyboard.c (Vthrow_on_input): New variable.
	(syms_of_keyboard): Defvar and initialize it.
	(kbd_buffer_store_event_hold): Handle Vthrow_on_input.

	* lisp.h (QUIT): Check for Vthrow_on_input.
	(Vthrow_on_input): Declare it.

2004-12-13  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (set_iterator_to_next): Reset stop_charpos after display
	vector.

2004-12-12  Richard M. Stallman  <rms@gnu.org>

	* indent.c (Fvertical_motion): Call move_it_by_lines even if LINES = 0.

	* minibuf.c (Fall_completions): Add var `zero' and use it in loop.
	(Ftry_completion): Really use outer `zero'; eliminate inner one.

2004-12-12  Kenichi Handa  <handa@m17n.org>

	* term.c (encode_terminal_code): Fix previous change.

2004-12-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (handle_async_input): Remove pthread mutex handling.
	(input_available_signal): Move pthread thingy to !SYNC_INPUT branch.

	* syntax.c (Fforward_word): Avoid non-idempotent side-effects
	in macro arguments.

	* minibuf.c (Ftry_completion, Fall_completions): Don't use
	XFASTINT blindly.

	* emacs.c (main, Fdump_emacs): Don't touch malloc hooks if SYNC_INPUT.

2004-12-11  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* w32term.c (x_calc_absolute_position): Remove calculation of
	difference between inner and outer window.  Don't subtract difference
	for left and top calculations.

	* xterm.c (x_calc_absolute_position): Don't subtract outer_pixel_diff
	for left and top calculations.  Remove call to x_real_positions.
	[Bug report by Drew Adams in November]
	(x_check_expected_move): Do not set change_gravity to 1 when calling
	x_set_offset.

2004-12-08  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (get_next_display_element): Use `escape-glyph' for
	control chars and escaped octal codes.
	(Qescape_glyph): New variable.
	(syms_of_xdisp): Initialize it.
	(escape_glyph_face): New variable.
	(redisplay_window): Initialize it.

2004-12-07  Paul Eggert  <eggert@cs.ucla.edu>

	* image.c (our_fill_input_buffer, jpeg_load, CHECK_LIB_AVAILABLE)
	(init_image): Use 1 rather than TRUE.  TRUE's not always defined.

2004-12-07  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* emacs.c (Fdump_emacs): Add ! defined (SYSTEM_MALLOC) around
	reset_malloc_hooks.

	* keyboard.c (handle_async_input, input_available_signal):
	Add ! defined (SYSTEM_MALLOC) around thread code.

	* alloc.c: Add comment about the reason for (UN)BLOCK_INPUT_ALLOC.

2004-12-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* eval.c (init_eval_once): Increase max_specpdl_size to 1000.

	* config.in: Regenerate.

2004-12-07  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xmenu.c (Fx_popup_menu): Correct documentation about position.
	(xmenu_show): Do not call XTranslateCoordinates.  Adjust position
	if not given by a mouse click to correspond with x-popup-menu
	documentation.

	* config.in: Regenerate.

	* gtkutil.c: Include signal.h and syssignal.h.
	(xg_get_file_name): Block and unblock __SIGRTMIN if defined.

	* alloc.c: If HAVE_GTK_AND_PTHREAD, include pthread.h,
	new variables main_thread and alloc_mutex,
	define (UN)BLOCK_INPUT_ALLOC to use alloc_mutex to protect
	emacs_blocked_* calls and only do (UN)BLOCK_INPUT in the main thread.
	If not HAVE_GTK_AND_PTHREAD, (UN)BLOCK_INPUT_ALLOC is the same as
	(UN)BLOCK_INPUT.
	(emacs_blocked_free, emacs_blocked_malloc)
	(emacs_blocked_realloc): Use (UN)BLOCK_INPUT_ALLOC.
	(uninterrupt_malloc): Initialize main_thread and alloc_mutex.
	(reset_malloc_hooks): New function.

	* lisp.h: Declare reset_malloc_hooks.

	* emacs.c (Fdump_emacs): Call reset_malloc_hooks.

	* keyboard.c: Conditionally include pthread.h
	(handle_async_input, input_available_signalt): If not in the main
	thread, block signal, send signal to main thread and return.

	* gtkutil.c (xg_get_file_with_chooser): Handle local files only.
	Set current folder in file chooser if default_filename is a directory.

2004-12-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* regex.c (GET_UNSIGNED_NUMBER): Signal an error when reaching the end.
	Remove redundant correctness checks.
	(regex_compile): Fix up error codes for \{..\} expressions.

2004-12-05  Richard M. Stallman  <rms@gnu.org>

	* regex.c (regex_compile): Fix end-of-pattern case for space.

2004-12-03  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.h (cfstring_create_with_utf8_cstring): Add prototype.
	* mac.c (cfstring_create_with_utf8_cstring): Add to prevent
	crashes with invalid characters.
	* macmenu.c (add_menu_item): Use it.
	* image.c (image_load_quartz2d): Likewise.
	* macfns.c (x_set_name, x_set_title): Likewise.
	(Fx_file_dialog): Likewise.  Use constant CFRefs instead of
	creating them each time for labels.

2004-12-02  Richard M. Stallman  <rms@gnu.org>

	* config.in (RE_TRANSLATE_P): If make_number is not a macro,
	don't use it here.

	* eval.c (Fcalled_interactively_p): Don't check INTERACTIVE.
	(interactive_p): Skip Scalled_interactively_p frames
	like Sinteractive_p frames.
	(unwind_to_catch): Clear handling_signal.

	* data.c (Fmake_variable_buffer_local): Doc fix.
	(Fmake_local_variable): Doc fix.

	* insdel.c (insert_from_string_before_markers)
	(insert_from_string): Don't modify buffer on empty insertion.

	* window.c (Fget_lru_window, Fget_largest_window): Doc fixes.

2004-12-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (add_menu_item): Fallback on MacRoman if encoding
	menu text as UTF8 fails.

2004-12-01  Kim F. Storm  <storm@cua.dk>

	* alloc.c: Add commentary for last change.
	(XMALLOC_PUT_SIZE, XMALLOC_GET_SIZE): New macros to handle
	sizeof(size_t) != 4.
	(overrun_check_malloc, overrun_check_realloc, overrun_check_free):
	Use them.  Also clear header and trailer of freed memory.
	(GC_STRING_OVERRUN_COOKIE_SIZE): Rename from GC_STRING_EXTRA.
	(string_overrun_cookie): Rename from string_overrun_pattern.
	(GC_STRING_EXTRA): Define from GC_STRING_OVERRUN_COOKIE_SIZE.

2004-12-01  Andreas Schwab  <schwab@suse.de>

	* lisp.h: Declare string_to_multibyte.

2004-12-01  Kenichi Handa  <handa@m17n.org>

	* w32console.c (w32con_write_glyphs): Decide coding here.
	Adjusted for the change of encode_terminal_code.

	* term.c (encode_terminal_code): Don't make it "static".

2004-11-30  Kenichi Handa  <handa@m17n.org>

	* term.c (encode_terminal_buf, encode_terminal_bufsize): New variables.
	(encode_terminal_code): Argument changed.  Encode all
	characters at once, and return a pointer to the result of encoding.
	(write_glyphs): Decide coding here.  Adjusted for the above change.
	(insert_glyphs): Likewise.
	(term_init): Initialize encode_terminal_bufsize to 0.

	* coding.c (Vcode_conversion_workbuf_name): New variable.
	(syms_of_coding): Initialize and staticpro it.
	(set_conversion_work_buffer): New function.
	(run_pre_post_conversion_on_str): Use it.
	(run_pre_write_conversin_on_c_str): New function.

	* coding.h (run_pre_write_conversin_on_c_str): Extern it.

2004-11-30  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c: Don't undef SIGIO
	* s/darwin.h (NO_SOCK_SIGIO): Define NO_SOCK_SIGIO on carbon
	* Makefile.in (mac.o): Depend on blockinput.h and atimer.h.
	(macfns.o): Don't depend on ccl.h.
	* macfns.c (mac_frame_parm_handlers): Set handlers for
	Qleft_fringe and Qright_fringe.
	* macterm.c (mac_fill_rectangle_to_pixmap)
	(mac_draw_rectangle_to_pixmap, mac_copy_area_to_pixmap)
	(mac_copy_area_with_mask_to_pixmap, x_draw_image_foreground_1):
	Put in #if 0.
	(mac_scroll_area) [TARGET_API_MAC_CARBON]: Use ScrollWindowRect.
	(x_flush) [TARGET_API_MAC_CARBON]: Don't traverse frames.
	(XFlush) [TARGET_API_MAC_CARBON]: Define to an empty replacement.
	(x_draw_glyph_string_background, x_draw_glyph_string_foreground)
	[!MAC_OS8]: Added ifdef'd out code for os8.  Don't use
	XDrawImageString.  Always draw background and foreground separately.
	(x_draw_image_foreground): Use clipping instead of computing the
	intersection rectangle.
	(x_draw_image_glyph_string): Don't draw an image with mask to a
	pixmap.
	(x_redisplay_interface): Set flush_display_optional member to 0.
	(XTread_socket): Correctly reset the TEConverter
	object.

2004-11-30  Kim F. Storm  <storm@cua.dk>

	* lisp.h: New defines to enable buffer overrun checking.
	(GC_CHECK_STRING_OVERRUN, GC_CHECK_STRING_FREE_LIST)
	(XMALLOC_OVERRUN_CHECK, GC_CHECK_CONS_LIST): Add.

	* alloc.c: Add more checks for buffer overruns.
	(XMALLOC_OVERRUN_CHECK_SIZE, xmalloc_overrun_check_header)
	xmalloc_overrun_check_trailer, overrun_check_malloc)
	overrun_check_realloc, overrun_check_free): Add.
	(GC_STRING_EXTRA, string_overrun_pattern): Add.
	(check_sblock, allocate_string_data, compact_small_strings):
	Set and check string_overrun_pattern if GC_CHECK_STRING_OVERRUN.
	(check_cons_list): Condition on GC_CHECK_CONS_LIST.
	(check_string_free_list): Add.
	(allocate_string, sweep_strings): Call check_string_free_list.

	* emacs.c (malloc_initialize_hook): Don't free malloc_state_ptr if
	XMALLOC_OVERRUN_CHECK to avoid crash during load.

2004-11-29  Kim F. Storm  <storm@cua.dk>

	* fns.c (concat): Use SAFE_ALLOCA.

2004-11-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* sysdep.c (emacs_write): Don't use QUIT.

2004-11-29  Kenichi Handa  <handa@m17n.org>

	* buffer.c (init_buffer): Set current_buffer->directory to a
	multibyte string made by string_to_multibyte.

	* emacs.c (init_cmdargs): Set unibyte strings in Vcommand_line_args.

2004-11-27  Andreas Schwab  <schwab@suse.de>

	* alloc.c (mark_stack): Call GC_MARK_SECONDARY_STACK if defined.

	* s/gnu-linux.h: Enable no-op gcpros on ia64.
	(GC_MARK_SECONDARY_STACK) [__ia64__]: Define.

	* filelock.c (lock_file_1): Call get_boot_time early.
	Increase buffer size.

2004-11-27  Eli Zaretskii  <eliz@gnu.org>

	* lisp.h (DECL_ALIGN): Define non-trivially only if NO_DECL_ALIGN
	is not defined.

2004-11-27  Kim F. Storm  <storm@cua.dk>

	* search.c (syms_of_search) <search-spaces-regexp>: Move 'doc:'
	marker out of doc string.

2004-11-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* s/darwin.h (POSIX_SIGNALS): Undo the removal of 2002-08-25,
	which was not mentioned in the log.

2004-11-26  Kim F. Storm  <storm@cua.dk>

	* fringe.c (update_window_fringes): Prefer truncation bitmaps over
	angle bitmaps at top/bottom line.

	* xdisp.c: Undo recent changes for restoring saved_face_id.  Instead,
	set it when it->method is set to next_element_from_display_vector.
	(setup_for_ellipsis): Add LEN argument.  Callers changed.
	Set it->saved_face_id.
	(get_next_display_element): Use loop instead of recursion.
	Set it->saved_face_id.  Combine duplicate code for ctr chars.
	(next_element_from_display_vector): Do not set it->saved_face_id.
	(next_element_from_ellipsis): Use setup_for_ellipsis.

2004-11-26  Eli Zaretskii  <eliz@gnu.org>

	* eval.c (Fdefvar): Declare pdl from last change as `volatile' to
	prevent compiler warnings.

2004-11-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (command_loop_1): Print a message describing the key
	the user just pressed when this key has no binding.

	* sysdep.c (sys_signal): Don't use SA_RESTART if SYNC_INPUT is set.
	(emacs_open, emacs_read, emacs_write): Check QUIT when interrupted.

	* lread.c (readchar): Check QUIT when `getc' is interrupted.

2004-11-24  Richard M. Stallman  <rms@gnu.org>

	* coding.c (run_pre_post_conversion_on_str): Bind Qinhibit_read_only.

	* buffer.c (syms_of_buffer) <indicate-buffer-boundaries>: Doc fix.

2004-11-24  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (move_it_in_display_line_to, display_line):
	Restore saved_face_id also when truncate-lines or hscrolled.

2004-11-23  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_name): Rename use-old-gtk-file-dialog to
	x-use-old-gtk-file-dialog.

	* xfns.c: Define x_use_old_gtk_file_dialog.
	(syms_of_xfns): Rename use-old-gtk-file-dialog to x-...  Move it
	outside ifdef USE_GTK.

2004-11-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* coding.h (ENCODE_FILE, DECODE_FILE, ENCODE_SYSTEM, DECODE_SYSTEM):
	Don't use XFASTINT blindly.

	* config.in (RE_TRANSLATE_P): Don't use XFASTINT blindly.

	* indent.c (skip_invisible): Avoid non-idempotent side-effects
	in macro arguments.

	* keymap.c (Flookup_key): Check INTEGERP before XINT.

	* lread.c (oblookup): Don't use XFASTINT blindly.

	* window.c (Fset_window_scroll_bars): Don't use XINT if it isn't int.
	(decode_next_window_args, window_loop): Don't use XFASTINT blindly.

2004-11-23  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (MATRIX_ROW_ENDS_IN_MIDDLE_OF_CHAR_P)
	(MATRIX_ROW_STARTS_IN_MIDDLE_OF_CHAR_P): Not if dpvec_index is zero.

	* xfaces.c (lookup_named_face): Add signal_p arg.  Return -1 if
	signal_p is zero and face name is unknown.
	(Fx_list_fonts): Don't signal error in lookup_named_face.
	(Fface_font): Signal error in lookup_named_face.
	(ascii_face_of_lisp_face): Likewise.

	* dispextern.h (lookup_named_face): Fix prototype.

	* xdisp.c (handle_single_display_prop): Don't signal error in
	lookup_named_face for unknown fringe face name.
	(highlight_trailing_whitespace): Don't signal error in
	lookup_named_face if trailing-whitespace face unknown.
	(calc_line_height_property): Don't signal error in
	lookup_named_face if specified face name is unknown.

	* fringe.c (update_window_fringes): Show top row indicator if
	window has header-line.  Don't show arrow at bob and eob
	if the boundary indicators are not used.
	(Fset_fringe_bitmap_face): Signal error in lookup_named_face.

	* window.c (set_window_buffer): Clear display_error_modiff.

2004-11-22  Kim F. Storm  <storm@cua.dk>

	* fringe.c (update_window_fringes): Provide sensible fall-back
	value for non-nil indicate-buffer-boundaries setting.

2004-11-22  Markus Rost  <rost@ias.edu>

	* minibuf.c (Fminibuffer_complete_and_exit): Fix previous change.

2004-11-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* eval.c (Fdefvar): Warn when var is let-bound but globally void.

2004-11-21  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (erase_phys_cursor): Clear hollow cursor inside TEXT_AREA.

	* xterm.c (x_clip_to_row): Add area arg.  Callers changed.
	(x_draw_hollow_cursor, x_draw_bar_cursor): Clip to TEXT_AREA.

	* w32term.c (w32_clip_to_row): Add area arg.  Callers changed.
	(x_draw_hollow_cursor, x_draw_bar_cursor): Clip to TEXT_AREA.

	* macterm.c (x_clip_to_row): Add area arg.  Callers changed.
	(x_draw_hollow_cursor, x_draw_bar_cursor): Clip to TEXT_AREA.

	* xdisp.c (move_it_in_display_line_to, display_line):
	Restore saved_face_id if overflow-newline-into-fringe is enabled and
	line is continued before or in middle of element from display vector.

	* indent.c (Fvertical_motion): Fix last change.  Use another
	method to detect if iterator moved too far ahead after reseat.

	* xdisp.c (IT_EXPAND_MATRIX_WIDTH): New macro.  Do not
	expand matrix width for overflow in zero-width area.
	(append_glyph, append_composite_glyph, produce_image_glyph)
	(append_stretch_glyph): Use it to avoid loop in redisplay.
	(note_mode_line_or_margin_highlight): Don't let help-echo from
	string override help-echo from image map.

2004-11-20  Luc Teirlinck  <teirllm@auburn.edu>

	* fns.c (Fyes_or_no_p): Call Fread_from_minibuffer with extra argument.
	* callint.c (Fcall_interactively): Ditto.

2004-11-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (Fminibuffer_complete_and_exit):
	Fixup the case of the completed value, for case-indep completion.

2004-11-20  Richard M. Stallman  <rms@gnu.org>

	* lisp.h (Fread_from_minibuffer): Add arg in decl.

	* minibuf.c (read_minibuf): New arg KEEP_ALL.  Callers changed.
	(Fread_from_minibuffer): New arg KEEP_ALL.  Callers changed.

	* search.c (Vsearch_spaces_regexp):
	Rename from Vsearch_whitespace_regexp.  All uses changed.

2004-11-20  Thien-Thi Nguyen  <ttn@gnu.org>

	* eval.c (init_eval_once): Increase `max_specpdl_size' to 650.

2004-11-19  Richard M. Stallman  <rms@gnu.org>

	* search.c (Vsearch_whitespace_regexp): New variable.
	(syms_of_search): Defvar it.
	(compile_pattern_1): Call re_set_whitespace_regexp with it.
	(search_buffer): No regexp is trivial if Vsearch_whitespace_regexp
	is non-nil.
	(struct regexp_cache): New element whitespace_regexp.
	(syms_of_search): Initialize whitespace_regexp elements.
	(compile_pattern): Compare whitespace_regexp elements.
	(compile_pattern_1): Set whitespace_regexp elements.

	* regex.c (regex_compile): Substitute whitespace_regexp
	for spaces, if it is nonzero.
	(whitespace_regexp): New variable.
	(re_set_whitespace_regexp): New function.

2004-11-19  Kim F. Storm  <storm@cua.dk>

	* indent.c (Fvertical_motion): Fix last change.

2004-11-18  Kim F. Storm  <storm@cua.dk>

	* indent.c (Fvertical_motion): Undo 2004-11-16 change.
	Instead, move back again if reseating moves too far ahead.

2004-11-17  Luc Teirlinck  <teirllm@auburn.edu>

	* xdisp.c (message3): Call clear_message.

2004-11-17  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (erase_phys_cursor): Adjust cursor row visible height.

2004-11-16  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_name): Typo in HAVE_GTK_FILE_SELECTION_NEW.

	* xmenu.c (x_menu_in_use): Remove.
	(x_menu_set_in_use): Also set popup_activated_flag.

	* xfns.c (Fx_file_dialog): Call popup_activated instead of
	x_menu_in_use.  Call x_menu_set_in_use in Motif version also.

	* xterm.h (x_menu_in_use): Remove.

2004-11-16  Richard M. Stallman  <rms@gnu.org>

	* keymap.c (Fmap_keymap): New arg SORT-FIRST.
	Use map-keymap-internal to implement that.

	* indent.c (Fvertical_motion): In batch mode, use vmotion directly.

2004-11-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (get_glyph_string_clip_rect, init_glyph_string): Check it's
	a window before using XWINDOW.

	* window.c (make_window, Fselect_window, make_dummy_parent)
	(save_window_save):
	* frame.c (make_frame):
	* fns.c (concat): Avoid side-effects inside XSETFASTINT's arguments.

	* lisp.h (NILP): Use EQ rather than XFASTINT.

2004-11-16  Kim F. Storm  <storm@cua.dk>

	* fringe.c (Fdefine_fringe_bitmap): Always set 'h'.  Simplify.

	* indent.c (Fvertical_motion): Fix last change.  Only reseat when
	moving backwards.

2004-11-16  Luc Teirlinck  <teirllm@auburn.edu>

	* dispextern.h: Extern reseat_at_previous_visible_line_start.

2004-11-16  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (display_mode_element): Fix previous change (calculate
	end position of substring to display correctly).

2004-11-16  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (Fposn_at_point): Remove extra */ after doc string.
	Reported by Andrew M. Scott.

2004-11-15  Kim F. Storm  <storm@cua.dk>

	* fns.c (Fsafe_plist_get): New defun.
	(syms_of_fns): Defsubr it.

	* lisp.h (Fsafe_plist_get): Add EXFUN.

	* xdisp.c (store_mode_line_string, produce_stretch_glyph):
	Use Fsafe_plist_get.
	(note_mode_line_or_margin_highlight, note_mouse_highlight):
	Fix image map element parsing.  Use Fsafe_plist_get.

2004-11-15  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (get_next_display_element): Fix previous change.

2004-11-14  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* window.c (shrink_windows): Handle special case of one window left
	when trying to shrink the final reminder.  Grow windows if
	total_removed is less than total_shrink.

	* xmenu.c (pop_down_menu): Remove global variable current_menu,
	extract pointer from arg with XSAVE_VALUE.
	(create_and_show_popup_menu, create_and_show_dialog, xmenu_show):
	Construct arg to record_unwind_protect with make_save_value.

2004-11-13  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (reseat_at_previous_visible_line_start): No longer static.
	(get_next_display_element): Fix previous change to apply only to \n.

	* indent.c (Fvertical_motion): Scan to PT from start of line to
	make iterator consistent.

	* minibuf.c (syms_of_minibuf) <completion-ignore-case>: Doc fix.

2004-11-14  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (pop_down_file_dialog): Add BLOCK_INPUT.

	* xfns.c (Fx_file_dialog): Call x_menu_in_use and x_menu_set_in_use.
	Record unwind with clean_up_file_dialog.

	* xterm.h (x_menu_in_use, x_menu_set_in_use, x_menu_wait_for_event):
	Declare.

	* xmenu.c (x_menu_in_use, x_menu_set_in_use): New functions.

2004-11-13  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_file_sel_ok, xg_file_sel_cancel)
	(xg_file_sel_destroy): Remove.
	(xg_file_response_cb, pop_down_file_dialog)
	(xg_get_file_name_from_chooser, xg_get_file_name_from_selector):
	New functions.
	(xg_get_file_with_chooser, xg_get_file_with_selection):
	Take new arg func, set it to xg_get_file_name_from_chooser/selector.
	Move common code to xg_get_file_name.  Return widget created.
	(xg_get_file_name): Set name, transient for, modal and destroy
	with parent here.  Connect response signal to xg_file_response_cb,
	connect delete-event to gtk_true.  Record pop_down_file_dialog
	for unwind.  Do event loop and call x_menu_wait_for_event in loop.
	(xg_create_widget): Make dialogs modal.

	* xmenu.c (unuse_menu_items, pop_down_menu): Arg is of type
	Lisp_Object.
	(popup_get_selection): Move unwind protect ...
	(create_and_show_popup_menu, create_and_show_dialog): ... to here.
	Move destroy of widget to pop_down_menu.
	(popup_widget_loop): Move unwind protect ...
	(create_and_show_popup_menu, create_and_show_dialog): ... to here.
	Move destroy of widget to pop_down_menu.
	(pop_down_menu): BLOCK_INPUT and destroy widget/window.
	(xmenu_show): Record unwind pop_down_menu.  Move XMenuDestroy,
	x_mouse_leave and grabbed = 0 to pop_down_menu.

2004-11-13  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (make_cursor_line_fully_visible_p): New variable.
	(syms_of_xdisp): DEFVAR_BOOL it.
	(make_cursor_line_fully_visible, try_cursor_movement)
	(try_window_id): Use it.

2004-11-12  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (struct glyph_row): New member extra_line_spacing.
	(struct it): New member max_extra_line_spacing.
	(MR_PARTIALLY_VISIBLE, MR_PARTIALLY_VISIBLE_AT_TOP)
	(MR_PARTIALLY_VISIBLE_AT_BOTTOM): New helper macros.
	(MATRIX_ROW_PARTIALLY_VISIBLE_P): Fix to return false if invisible
	part of last line is only extra line spacing (so the text on the
	line is fully visible).  Use helper macros.
	Add W arg (to use them).  All callers changed.
	(MATRIX_ROW_PARTIALLY_VISIBLE_AT_TOP_P)
	(MATRIX_ROW_PARTIALLY_VISIBLE_AT_BOTTOM_P): Use helper macros.

	* window.c (window_scroll_pixel_based, Frecenter):
	Use move_it_vertically_backward directly.
	(Frecenter): Fix calculation of new start pos for negative arg.
	Before, the new start pos was sometimes chosen too far back, so
	the last line became only partially visible, and thus would be
	either only semi-visible or automatically scrolled to the middle
	of the window by redisplay.

	* xdisp.c (init_iterator): Clear it.max_extra_line_spacing.
	(move_it_vertically_backward): Don't recure to move further back.
	(move_it_vertically): Remove superfluous condition.
	(move_it_by_lines): Clear last_height when moved 0 lines.
	(resize_mini_window): Use it.max_extra_line_spacing.
	(display_tool_bar_line): Clear row->extra_line_spacing.
	(try_scrolling): Use move_it_vertically_backward directly.
	(redisplay_window): Likewise.
	(compute_line_metrics): Set row->extra_line_spacing.
	(display_line, display_string): Likewise.
	(x_produce_glyphs): Update it->max_extra_line_spacing.

	* xmenu.c (pop_down_menu): Return nil.

2004-11-12  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xmenu.c (x_menu_wait_for_event): New function.
	(popup_get_selection, popup_widget_loop): Call x_menu_wait_for_event
	to handle timers.
	(popup_widget_loop): Add argument do_timers.
	(create_and_show_popup_menu, create_and_show_dialog): Pass 1 for
	do_timers to popup_widget_loop.
	(xmenu_show): Call XMenuActivateSetWaitFunction so that
	x_menu_wait_for_event is called by XMenuActivate.
	(create_and_show_popup_menu): Pass 1 for do_timers to
	popup_get_selection.
	(pop_down_menu): New function.
	(popup_get_selection, popup_widget_loop): Unwind protect to
	pop_down_menu.
	(popup_widget_loop): Add argument widget.
	(create_and_show_popup_menu, create_and_show_dialog): Pass new
	argument widget to popup_widget_loop.

2004-11-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (Fkeymap_prompt): Accept symbol keymaps.

2004-11-09  Kim F. Storm  <storm@cua.dk>

	* xselect.c: Include <sys/types.h> and <unistd.h> (for getpid).
	Fix various comments referring to XEvents instead of input events.
	(x_queue_event): Fix format strings.
	(x_stop_queuing_selection_requests): Likewise.

	* xdisp.c (produce_image_glyph): Remove unused variable 'face_ascent'.
	(pint2hrstr): Add extra braces to silence compiler.

	* print.c (print_object): Fix format string.

	* lread.c (read1): Fix next_char matching.

	* lisp.h (Fdelete): Add EXFUN.
	(replace_range_2): Add prototype.

	* keyboard.c (read_avail_input): Remove unused variable 'discard'.

	* intervals.h (NULL_INTERVAL_P): Add separate version when
	ENABLE_CHECKING is not defined to silence compiler.
	(compare_string_intervals): Add prototype.

	* fringe.c (destroy_fringe_bitmap): Fix return type.
	(Ffringe_bitmaps_at_pos): Remove unused var 'old_buffer'.

	* emacs.c (Fdump_emacs): Fix format string.

	* doc.c: Include <ctype.h>.
	(Fsubstitute_command_keys): Remove unused variable 'firstkey'.

	* data.c (store_symval_forwarding): Remove unused variables.

	* callint.c (Fcall_interactively): Remove unused variable 'funcar'.

2004-11-09  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* Makefile.in (stamp-oldxmenu): If HAVE_GTK, don't add dependencies
	to ${OLDXMENU}.

2004-11-09  Kim F. Storm  <storm@cua.dk>

	* process.c (Fmake_network_process): Remove kludge for interrupted
	connects on BSD.  If connect is interrupted, just close socket and
	start over rather than sleeping and retry with same socket.

2004-11-09  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* .cvsignore: Add buildobj.lst.

	* doc.c: New variable Vbuild_files.
	(Fsnarf_documentation): If Vbuild_files is nil, populate it with
	file names from buildobj.lst.  Only attach docstrings from files
	that are in Vbuild_files.
	(syms_of_doc): Defvar Vbuild_files.

	* Makefile.in (SOME_MACHINE_OBJECTS): Add fringe.o, image.o
	and w32*.o.
	(temacs${EXEEXT}): Generate buildobj.lst when temacs is linked.
	(mostlyclean): Rm buildobj.lst

	* makefile.w32-in ($(TEMACS)): Generate buildobj.lst when temacs
	is linked.

2004-11-09  Kim F. Storm  <storm@cua.dk>

	* fringe.c (update_window_fringes): Update fringe bitmaps if
	cur and row ends_at_zv_p differs.  If bitmaps of a row is updated,
	also update previous row to get rid of misc. artifacts.

2004-11-08  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (fast_find_position): Fix start pos if header line present.
	(note_mouse_highlight): Clear mouse face if we move out of text area.

2004-11-08  Eli Zaretskii  <eliz@gnu.org>

	* editfns.c: Move #include "systime.h" before <sys/resource.h>.
	Don't include <sys/time.h> explicitly.
	Include <stdio.h> unconditionally, not just on MacOS.

2004-11-08  Kenichi Handa  <handa@m17n.org>

	* fontset.c (fontset_pattern_regexp): Cancel my previous change;
	don't pay attention to '\' before '*'.
	(fontset_pattern_regexp): Change the meaning of the second arg.
	(Fnew_fontset): Call fs_query_fontset, not Fquery_fontset.
	(check_fontset_name): Try NAME as literal at first, and if it
	failes, try NAME as pattern.

2004-11-07  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* emacs.c (Fdump_emacs): Only output warning on GNU/Linux.

2004-11-07  Andreas Schwab  <schwab@suse.de>

	* lisp.h (Fmsdos_downcase_filename): Declare.
	* dired.c (Fmsdos_downcase_filename): Don't declare here.
	* fileio.c: Likewise.

2004-11-07  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* dosfns.c (Fdos_memget, Fdos_memput): Use integer variable offs in
	comparisons with integers instead of Lisp_Object address.
	(Fmsdos_set_keyboard): Declare argument allkeys.

	* msdos.c (IT_set_frame_parameters): Use EQ, not ==, for Lisp_Object:s.

	* dired.c (Fmsdos_downcase_filename): Declare extern on MSDOS to avoid
	int/Lisp_Object mixup.

	* fileio.c: Ditto.

2004-11-06  Steven Tamm  <steventamm@mac.com>

	* editfns.c: Need to include sys/time.h before resource.h on darwin.

2004-11-06  Richard M. Stallman  <rms@gnu.org>

	* callint.c (Fcall_interactively): Avoid reusing EVENT for other data.

	* xfaces.c (merge_named_face): GCPRO the face_name in the
	named_merge_point struct that we make.
	(merge_face_heights): Eliminate GCPRO arg.  All callers changed.

	* keyboard.c (command_loop_1): Change Vtransient_mark_mode
	before deciding whether to inactivate mark.

2004-11-06  Lars Brinkhoff  <lars@nocrew.org>

	* config.in: Regenerate (add HAVE_GETRUSAGE).
	* editfns.c (Fget_internal_run_time): New function.
	(syms_of_data): Defsubr it.
	* fns.c (sxhash): As far as possible, merge calculation of
	hash code for symbols and strings.

2004-11-06  Eli Zaretskii  <eliz@gnu.org>

	* frame.c (syms_of_frame): Fix the example in the doc string.

2004-11-06  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* eval.c (Feval): Remove check for INPUT_BLOCKED_P.

	* xmenu.c (popup_get_selection, create_and_show_popup_menu)
	(create_and_show_dialog): Revert change from 2004-10-31.

2004-11-05  Luc Teirlinck  <teirllm@auburn.edu>

	* macros.c (syms_of_macros) <defining-kbd-macro>: Doc fix.

2004-11-05  Kim F. Storm  <storm@cua.dk>

	* print.c (print_object): Print Lisp_Misc_Save_Value objects.

	* fileio.c (Ffile_modes): Doc fix.
	(auto_save_1): Check for Ffile_modes nil value.

2004-11-05  Kim F. Storm  <storm@cua.dk>

	* xselect.c (struct selection_event_queue, selection_queue)
	(x_queue_selection_requests, x_queue_event)
	(x_start_queuing_selection_requests)
	(x_stop_queuing_selection_requests): Add new queue for selection
	input events to replace previous XEvent queue in xterm.c.
	(queue_selection_requests_unwind): Adapt to new queue.
	(x_reply_selection_request): Adapt to new queue.
	Unexpect wait_object in case of x errors (memory leak).
	(x_handle_selection_request, x_handle_selection_clear): Make static.
	(x_handle_selection_event): New function.  May queue selection events.
	(wait_for_property_change_unwind): Use save_value instead of cons.
	Clear property_change_reply_object.
	(wait_for_property_change): Abort if already waiting.
	Use save_value instead of cons for unwind data.
	(x_handle_property_notify): Skip events already arrived, but don't
	free them, as "arrived" field is checked by wait_for_property_change,
	and it will be freed by unwind or explicit unexpect_property_change.
	(x_get_foreign_selection): Add to new queue.
	(receive_incremental_selection): Don't unexpect wait_object when done
	as it has already been freed by previous wait_for_property_change.

	* xterm.h (x_start_queuing_selection_requests)
	(x_stop_queuing_selection_requests, x_handle_selection_request)
	(x_handle_selection_clear): Remove prototypes.
	(x_handle_selection_event): Add prototype.

	* xterm.c (handle_one_xevent): Don't queue X selection events
	here, it may be too late if we start queuing after we have already
	stored some selection events into the kbd buffer.
	(struct selection_event_queue, queue, x_queue_selection_requests)
	(x_queue_event, x_unqueue_events, x_start_queuing_selection_requests)
	(x_stop_queuing_selection_requests): Remove/move to xselect.c.
	(x_catch_errors_unwind): Block input around final XSync.

	* keyboard.h (kbd_buffer_unget_event): Add prototype.

	* keyboard.c (kbd_buffer_store_event_hold): Remove obsolete code.
	(kbd_buffer_unget_event): New function.
	(kbd_buffer_get_event, swallow_events): Combine SELECTION events
	and use x_handle_selection_event.
	(mark_kboards): Don't mark x and y of SELECTION_CLEAR_EVENT.

2004-11-05  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xselect.c (TRACE3): New debug macro.
	(x_reply_selection_request): Use it.
	(receive_incremental_selection): In call to TRACE0, the name of
	a symbol is in xname.

2004-11-05  Kim F. Storm  <storm@cua.dk>

	* fontset.c (fontset_pattern_regexp): Use unsigned char.

2004-11-04  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* fileio.c (Fnext_read_file_uses_dialog_p): New function.

	* gtkutil.h (use_old_gtk_file_dialog): Declare.

	* gtkutil.c: Make use_old_gtk_file_dialog non-static.
	(xg_initialize): Move DEFVAR_BOOL for use_old_gtk_file_dialog ...
	* xfns.c (syms_of_xfns): ... to here.

	* gtkutil.c (xg_get_file_with_chooser): Expand DEFAULT_FILENAME if
	it doesn't start with /.

2004-11-04  Kenichi Handa  <handa@m17n.org>

	* fontset.c (fontset_pattern_regexp): If '*' is preceded by '\',
	treat it as a literal character.

2004-11-03  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (ppt): New function.

2004-11-02  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (x_window_to_scroll_bar): Only call
	xg_get_scroll_id_for_window if toolkit scroll bars are used.

	* gtkutil.c (xg_get_file_with_chooser): Use GTK_STOCK_OK instead
	of save.

2004-11-02  Andreas Schwab  <schwab@suse.de>

	* window.c (Fscroll_right): Fix last change.

2004-11-02  Kim F. Storm  <storm@cua.dk>

	* Makefile.in (callproc.o): Depend on blockinput.h atimer.h systime.h.

2004-11-02  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* callproc.c (Fcall_process): Block input around vfork.

2004-11-02  Kim F. Storm  <storm@cua.dk>

	* eval.c (Fcalled_interactively_p): Rename from Fcall_interactive_p.
	(syms_of_eval): Defsubr it.

2004-11-02  Richard M. Stallman  <rms@gnu.org>

	* insdel.c (replace_range_2): New function.

	* casefiddle.c (casify_region): Handle changes in byte-length
	using replace_range_2.

	* emacs.c (USAGE3): Delete --horizontal-scroll-bars, -hb.

	* xdisp.c (back_to_previous_visible_line_start):
	Subtract 1 from pos when checking previous newline for invisibility.

	* window.c (window_scroll_pixel_based): Update preserve_y
	for header line if any.
	(Fscroll_left, Fscroll_right): Don't call interactive_p;
	use a new second argument instead.

	* eval.c (Fcall_interactive_p): New function.
	(interactive_p): Don't test INTERACTIVE here.
	(Finteractive_p): Doc fix.

	* eval.c (Feval): Abort if INPUT_BLOCKED_P.

2004-11-02  KOBAYASHI Yasuhiro  <kobayays@otsukakj.co.jp>

	* w32fns.c (w32_font_match): Use fast_string_match_ignore_case for
	comparing font names.

2004-11-02  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* fileio.c (Fread_file_name): Pass Qt as fifth parameter to
	Fx_file_dialog if only directories should be read.

	* lisp.h: Fx_file_dialog takes 5 parameters.

	* xfns.c (Fx_file_dialog): Both Motif and GTK version:
	Add parameter only_dir_p.
	In Motif version, don't put DEFAULT_FILENAME in filter part of the
	dialog, just text field part.  Do not add DEFAULT_FILENAME
	to list of files if it isn't there.
	In GTK version, pass only_dir_p parameter to xg_get_file_name.

	* macfns.c (Fx_file_dialog): Add parameter only_dir_p.
	Check only_dir_p instead of comparing prompt to "Dired".  When using
	a save dialog, add option kNavDontConfirmReplacement, change title
	to "Enter name", change text for save button to "Ok".

	* w32fns.c (Fx_file_dialog): Add parameter only_dir_p.
	Check only_dir_p instead of comparing prompt to "Dired".

	* gtkutil.c (xg_get_file_with_chooser)
	(xg_get_file_with_selection): New functions, only defined ifdef
	HAVE_GTK_FILE_CHOOSER_DIALOG_NEW and HAVE_GTK_FILE_SELECTION_NEW
	respectively.
	(xg_get_file_name): Add parameter only_dir_p.
	Call xg_get_file_with_chooser or xg_get_file_with_selection
	depending on HAVE_GTK_FILE* and the value of use_old_gtk_file_dialog.
	(xg_initialize): New DEFVAR_BOOL use_old_gtk_file_dialog.

	* gtkutil.h (xg_get_file_name): Add parameter only_dir_p.

	* config.in: Rebuild (added HAVE_GTK_FILE_*).

2004-11-01  Kim F. Storm  <storm@cua.dk>

	* process.c (connect_wait_mask, num_pending_connects):
	Only declare and use them if NON_BLOCKING_CONNECT is defined.
	(init_process): Initialize them if NON_BLOCKING_CONNECT defined.
	(IF_NON_BLOCKING_CONNECT): New helper macro.
	(wait_reading_process_output): Only declare and use local vars
	Connecting and check_connect when NON_BLOCKING_CONNECT is defined.

2004-11-01  Andy Petrusenco  <Igrek@star-sw.com>  (tiny change)

	* w32term.c (x_scroll_run): Delete region objects after use.

2004-10-31  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xmenu.c: Add prototypes for forward function declarations.
	(popup_get_selection): Remove parameter do_timers, remove call to
	timer_check.
	(create_and_show_popup_menu, create_and_show_dialog):
	Remove parameter do_timers from call to popup_get_selection.

	* xdisp.c (update_tool_bar): Pass a copy of f->tool_bar_items to
	tool_bar_items and assign the result to f->tool_bar_items if
	not equal.  Move BLOCK/UNBLOCK_INPUT from around call to
	tool_bar_items to assignment of result.

	* atimer.c (alarm_signal_handler): Do not call set_alarm if
	pending_atmers is non-zero.

2004-10-31  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (margin_glyphs_to_reserve): Don't use ncols_scale_factor.

2004-10-28  Will  <will@glozer.net>

	* macterm.c: Allow user to assign key modifiers to the Mac Option
	key via a 'mac-option-modifier' variable.

2004-10-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xselect.c (Vx_lost_selection_functions, Vx_sent_selection_functions):
	Rename from Vx_lost_selection_hooks and Vx_sent_selection_hooks.
	(x_handle_selection_request, x_handle_selection_clear)
	(x_clear_frame_selections, syms_of_xselect): Adjust accordingly.

2004-10-28  Richard M. Stallman  <rms@gnu.org>

	* w32fns.c (Fx_server_vendor, Fx_server_version): Doc fixes.

	* xfns.c (Fx_server_vendor, Fx_server_version): Doc fixes.

2004-10-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (scan_sexps_forward): Give precedence to a 2-char
	comment-starter over a 1-char one.

2004-10-27  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (get_next_display_element): In mode lines,
	treat newline and tab like other control characters.

	* editfns.c (Fmessage): Doc fix.

	* indent.c (vmotion): When moving up, check the newline before.
	Make prevline an int, not a Lisp_Object.

2004-10-27  Kim F. Storm  <storm@cua.dk>

	* editfns.c (Fformat): Allocate discarded table with SAFE_ALLOCA.
	Only allocate info and discarded tables once.

	* lisp.h (USE_SAFE_ALLOCA): Add and init sa_must_free integer.
	(SAFE_ALLOCA, SAFE_ALLOCA_LISP): Increment it when malloc is used.
	(SAFE_FREE): Test it to determine if we need to unwind to free.
	Remove size arg.  All users changed.
	(SAFE_FREE_LISP) Remove.  All users changed to use SAFE_FREE.

2004-10-26  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c: Put empty line between comment and function body.
	(xg_destroy_widgets): Rename from remove_from_container.
	Just destroy all widgets in list.  Argument wcont removed.
	(xg_update_menubar, xg_update_submenu): Call xg_destroy_widgets
	instead of remove_from_container.
	(xg_display_close, xg_create_tool_bar, update_frame_tool_bar)
	(free_frame_tool_bar): Add comment.

	* xfns.c (xic_create_xfontset): Check that FRAME_XIC_BASE_FONTNAME
	is not NULL before strcmp.

2004-10-26  Kim F. Storm  <storm@cua.dk>

	* callint.c (Fcall_interactively): Add 'U' code to get the
	up-event discarded by a previous 'k' or 'K' argument.

2004-10-26  David Kastrup  <dak@gnu.org>

	* buffer.c (syms_of_buffer): Fix a few typos.

2004-10-26  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xsmfns.c: Put empty line between comment and function body.
	Use two spaces before comment end.

2004-10-25  Kenichi Handa  <handa@m17n.org>

	* fontset.c (fontset_pattern_regexp): Optimize for the case that
	PATTERN is full XLFD.

2004-10-24  Kenichi Handa  <handa@m17n.org>

	* regex.h (enum reg_errcode_t): New value REG_ERANGEX.

	* regex.c (re_error_msgid): Add an entry for REG_ERANGEX.
	(regex_compile): Return REG_ERANGEX if appropriate.

2004-10-22  Kenichi Handa  <handa@m17n.org>

	* editfns.c (Ftranslate_region_internal): New function.
	(syms_of_editfns): Defsubr it.

2004-10-22  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (xic_create_xfontset): Initialize missing_list to NULL.

2004-10-21  K,Ba(Broly L,Bu(Brentey  <lorentey@elte.hu>

	* xterm.h (x_output): New member `xic_base_fontname'.
	(FRAME_XIC_BASE_FONTNAME): New macro.
	(xic_free_xfontset): Declare.

	* xfns.c (xic_create_xfontset): Share fontsets between frames
	based on base_fontname.
	(xic_free_xfontset): New function.
	(free_frame_xic): Use it.
	(xic_set_xfontset): Ditto.

	* xterm.c (xim_destroy_callback): Ditto.


2004-10-20  B. Anyos  <banyos@freemail.hu>  (tiny change)

	* w32term.c (x_draw_glyph_string): Use overline_color for overlines.

2004-10-20  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.h (XSync): If USE_GTK, define XSync as process_all and then
	XSync.

	* emacs.c (my_heap_start, heap_bss_diff, MAX_HEAP_BSS_DIFF):
	New variables and constant.
	(main): Calculate heap_bss_diff.  If we are dumping and the
	heap_bss_diff is greater than MAX_HEAP_BSS_DIFF, set PER_LINUX32
	and exec ourself again.
	(Fdump_emacs): If heap_bss_diff is greater than MAX_HEAP_BSS_DIFF
	print a warning.

	* lastfile.c: Make my_endbss and my_endbss_static available on all
	platforms.

	* Makefile.in (RUN_TEMACS): Remove @SETARCH@.
	* config.in (HAVE_PERSONALITY_LINUX32): Regenerate.

2004-10-19  Luc Teirlinck  <teirllm@auburn.edu>

	* data.c (Flocal_variable_if_set_p): Doc fix.

2004-10-19  Jason Rumney  <jasonr@gnu.org>

	* w32.c (init_environment): Set emacs_dir correctly when running
	emacs from the build directory.

2004-10-19  Richard M. Stallman  <rms@gnu.org>

	* editfns.c (Fdelete_and_extract_region):
	If region is empty, return null string.

2004-10-19  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.h (xg_update_scrollbar_pos): Remove arguments real_left
	and canon_width.
	(xg_frame_cleared): Remove.

	* gtkutil.c (xg_frame_cleared, xg_fixed_handle_expose)
	(xg_find_top_left_in_fixed): Remove.
	(xg_create_scroll_bar): Put an event box widget between
	the scroll bar widget and the edit widget.
	(xg_show_scroll_bar): Show the parent widget (the event box).
	(xg_remove_scroll_bar): Destroy parent (the event box) also.
	(xg_update_scrollbar_pos): Remove arguments real_left and canon_width.
	Move the parent (the event box) widget inside the fixed widget.
	Move window clear to xterm.c.

	* gtkutil.h (xg_frame_cleared): Remove.

	* xterm.c (x_clear_frame): Remove call to xg_frame_cleared
	(x_scroll_bar_create, XTset_vertical_scroll_bar):
	Remove arguments left and width to xg_update_scrollbar_pos.
	(XTset_vertical_scroll_bar): Do x_clear_area for USE_GTK also.

2004-10-19  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (display_mode_element): Fix display of wide chars.

2004-10-18  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_update_scrollbar_pos): Change XClearWindow to
	gdk_window_clear and move gdk_window_process_all_updates after
	clear so events are sent to the X server in correct order.

2004-10-18  Kenichi Handa  <handa@m17n.org>

	* fontset.c (fs_load_font): Use fast_string_match_ignore_case for
	comparing font names.
	(fs_query_fontset): Use fast_string_match for comparing fontset names.
	(list_fontsets): Likewise.

	* search.c (fast_string_match_ignore_case): New function.

	* lisp.h (fast_string_match_ignore_case): Extern it.

2004-10-17  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (overlay_arrow_at_row): Return overlay string rather
	than bitmap if there is not left fringe.
	(get_overlay_arrow_glyph_row): Also used on windows system.
	(display_line): Display overlay string if no left fringe.

2004-10-16  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (w32_font_match): Encode font name being matched.

2004-10-16  Richard M. Stallman  <rms@gnu.org>

	* window.c (Fspecial_display_p): Doc fix.

2004-10-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* doc.c (Fsubstitute_command_keys): Fix remap-handling.
	Don't ignore menus, because where-is-internal already does it for us.

2004-10-15  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (redisplay_window): Only update fringes and vertical
	border on window frames.

2004-10-14  Andreas Schwab  <schwab@suse.de>

	* m/ia64.h (DATA_SEG_BITS): Don't define.

2004-10-14  Kim F. Storm  <storm@cua.dk>

	* xterm.h: Include Xutil.h after keysym.h to work around bug
	in some X versions.

2004-10-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fns.c (map_char_table): Add missing gcpros.

2004-10-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (get_keymap): An autoload form is not a keymap.

	* textprop.c (syms_of_textprop): Make `syntax-table' nonsticky.

2004-10-13  Kim F. Storm  <storm@cua.dk>

	* callproc.c (Fcall_process): Simplify handling of display arg.
	Resume `display_on_the_fly' once a coding system is determined.

	* xdisp.c (redisplay_preserve_echo_area): Fix last change.

2004-10-12  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (redisplay_preserve_echo_area): Flush display in case
	caller, such as call-process, is not going to poll for input.
	(calc_line_height_property): Handle case where it->object is nil.

	* xterm.c (x_redisplay_interface): Fix flush_display_optional.

2004-10-12  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (get_next_display_element):
	If unibyte_display_via_language_environment is zero, display 8-bit
	chars in octal in unibyte buffer.

2004-10-12  Kim F. Storm  <storm@cua.dk>

	* doc.c (Fsubstitute_command_keys): Ignore remappings unless there
	are no ordinary bindings.

2004-10-11  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (syms_of_xfns): Defsubr x-file-dialog for GTK also.

2004-10-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (x_raise_frame): Add BLOCK_INPUT around SelectWindow.
	(x_lower_frame): Add BLOCK_INPUT around SendBehind.
	(make_mac_frame): Add BLOCK_INPUT around the making of a
	terminal frame.
	(mac_initialize): Add BLOCK_INPUT around carbon initialization.
	* macgui.h (mktime): Use emacs_mktime.
	* macfns.c (Fx_file_dialog): Add BLOCK_INPUT around more code.
	Make a cancel file-open dialog be like C-g.
	* mac.c (mktime): Use emacs_mktime.
	(Fdo_applescript): Add BLOCK_INPUT around do_applescript.
	(Fmac_paste_function): Add better error handling for carbon cut/paste.

2004-10-10  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (timer_resume_idle): New function to resume idle
	timer without resetting timers on the idle list.
	(read_char): Use timer_resume_idle.  Remove local var last_idle_start.
	(timer_start_idle, timer_stop_idle): Declare static.
	(read_key_sequence): Use timer_resume_idle instead of timer_start_idle.

	* keyboard.h (timer_start_idle, timer_stop_idle): Remove prototypes.

2004-10-08  Steven Tamm  <steventamm@mac.com>

	* config.in (HAVE_MALLOC_MALLOC_H): Regenerate.
	* macterm.c (mac_check_for_quit_char): Remove warning for using
	NULL where 0 should be used.
	* unexmacosx.c: Use malloc/malloc.h on Tiger instead of
	objc/malloc.h
	* mac.c: Include time.h for Tiger compatibility.

2004-10-07  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (redisplay_window): Fix flicker on vertical line between
	windows.  Update vertical line after drawing window fringes, but
	only if actually drawing any bitmaps--or there is no fringe.

	* xterm.c (x_update_window_end): Likewise.
	* macterm.c (x_update_window_end): Likewise.
	* w32term.c (x_update_window_end): Likewise.

	* fringe.c (draw_window_fringes): Return value now indicates if
	any fringe bitmaps were redrawn (or there are no fringes).

	* dispextern.h (draw_window_fringes): Update prototype.

2004-10-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (mac_get_window_bounds): Add extern.
	(x_real_positions): Use mac_get_window_bounds.

	* macmenu.c (update_submenu_strings): Apply 2004-09-07 change for
	xmenu.c (YAILOM).

	* macterm.c [!MAC_OSX]: Include Windows.h.
	(front_emacs_window): Rename from mac_front_window.  All uses
	changed.  Return the frontmost non-tooltip emacs window.
	(mac_get_window_bounds): New function.
	(x_calc_absolute_position): Use the difference of width and height
	between the inner and outer window.
	(x_set_offset): Specify window position by the coordinae of the
	outer window.  Adjust the position if the title bar is completely
	outside the screen.
	(app_is_suspended, app_sleep_time): Remove unused variables.
	(do_app_resume, do_app_suspend): Remove their contents because
	window-activate/deactivate events will do the job.
	(do_zoom_window): Remove unused variables.  Make compliant to the
	standard way of zooming.  Set f->left_pos and f->top_pos.
	(XTread_socket): Don't use argument `expected'.  Don't use
	FrontWindow to determine the clicked window.  Exclude unprocessed
	mouseUp cases in the early stage.  Add parentheses to fix operator
	precedence.
	(XTread_socket) [TARGET_API_MAC_CARBON]: Don't specify drag area.

2004-10-05  Jan Dj,Ad(Brv.  <jan.h.d@swipnet.se>

	* config.in: Regenerate.

	* Makefile.in (RUN_TEMACS): Check HAVE_RANDOM_HEAPSTART instead of
	HAVE_EXECSHIELD.

2004-10-05  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (x_find_modifier_meanings): Ignore any Super or Hyper for
	a row if Alt or Meta has been found for that row.  Also stop scanning
	for Keysyms for that row.

2004-10-04  Kim F. Storm  <storm@cua.dk>

	* fringe.c (Ffringe_bitmaps_at_pos): Change return value from cons
	to list.  Include overlay arrow bitmap in return value.

	* xterm.c (XTset_vertical_scroll_bar): Improve handling of scroll
	bars with fractional column width.  If scroll bar separates two
	windows, move it towards the window it belongs to.  Only update
	the padding area below the scroll bar widget when necessary,
	i.e. when scroll bar widget is created, moved, or resized.

	* xdisp.c (define_frame_cursor1): Do not change frame cursor
	while tracking/dragging mouse.
	(x_draw_vertical_border): Do not draw line if frame has scroll bars.

	* window.c (coordinates_in_window): Relax check for cursor
	on vertial border between mode lines.
	(Fset_window_fringes): Do not allow negative widths.
	(Fset_window_scroll_bars): Likewise.

	* .gdbinit (pp): Shorthand for p ARG + pr.
	(ff): New command: flush frame updates (X only).

2004-10-03  Michael Albinus  <michael.albinus@gmx.de>

	* fileio.c (auto_save_1) Call Ffile_modes for remote files.

2004-09-30  Kenichi Handa  <handa@m17n.org>

	* process.c (send_process): Free composition data.

	* fileio.c (Finsert_file_contents): Free composition data.

	* coding.c (code_convert_region): Don't skip ASCIIs if there are
	compositions to encode.
	(encode_coding_string): Likewise.  Free composition data.

2004-09-30  Florian Weimer  <fw@deneb.enyo.de>

	* coding.c (code_convert_region): Free composition data.

2004-09-29  Kim F. Storm  <storm@cua.dk>

	* fringe.c: Remove limit on number of bitmaps.
	(fringe_bitmaps, fringe_faces): Change to pointers.
	(max_fringe_bitmaps): New var.
	(Fdefine_fringe_bitmap): Expand fringe_bitmaps and fringe_faces.
	(init_fringe): Allocate fringe_bitmaps and fringe_faces.

	* dispextern.h (FRINGE_ID_BITS): Increase to 16 bits (64K bitmaps).
	(struct glyph_row): Reorder fringe_bitmap related fields.
	(struct it): Likewise.

	* w32term.c (fringe_bmp): Change to pointer.
	(max_fringe_bmp): New var.
	(w32_define_fringe_bitmap): Expand fringe_bmp.
	(w32_draw_fringe_bitmap): Check max_fringe_bmp.
	(w32_destroy_fringe_bitmap): Likewise.

2004-09-29  Kim F. Storm  <storm@cua.dk>

	* fringe.c: Simplify last change.
	(lookup_fringe_bitmap): New function.
	(valid_fringe_bitmap_p, resolve_fringe_bitmap): Remove.
	(Fdestroy_fringe_bitmap): Use lookup_fringe_bitmap.
	Keep standard bitmaps in Vfringe_bitmaps.
	(Fdefine_fringe_bitmap): Use lookup_fringe_bitmap.
	(Fset_fringe_bitmap_face): Likewise.

	* dispextern.h (lookup_fringe_bitmap): Add prototype.
	(valid_fringe_bitmap_p): Remove prototype.

	* xdisp.c (handle_single_display_prop): Use lookup_fringe_bitmap.

2004-09-29  Kim F. Storm  <storm@cua.dk>

	* fringe.c (destroy_fringe_bitmap, init_fringe_bitmap)
	(w32_init_fringe, w32_reset_fringes): Fix bootstrap (NULL rif).

	* dispextern.h (valid_fringe_bitmap_p): Fix prototype.

	* fringe.c (Vfringe_bitmaps): New variable.
	(syms_of_fringe): DEFVAR_LISP it.
	(valid_fringe_bitmap_p): Rename from valid_fringe_bitmap_id_p.
	Change arg to Lisp_Object and fail if not an integer.
	(get_fringe_bitmap_name, resolve_fringe_bitmap)
	(destroy_fringe_bitmap): New functions.
	(Fdestroy_fringe_bitmap): Change arg to bitmap symbol.
	Use destroy_fringe_bitmap.  Remove symbol from Vfringe_bitmaps and
	clear its fringe property.
	(init_fringe_bitmap): Use destroy_fringe_bitmap instead of
	Fdestroy_fringe_bitmap.
	(Fdefine_fringe_bitmap): Add BITMAP arg specifying new or existing
	bitmap symbol; remove WHICH arg.  Add symbol to Vfringe_bitmaps
	and set fringe property.  Signal error if no free slots.
	(Fset_fringe_bitmap_face): Change arg to bitmap symbol.
	(Ffringe_bitmaps_at_pos): Return bitmap symbols instead of numbers.

	* xdisp.c (handle_single_display_prop): Fringe bitmaps are now
	symbols with a fringe property.

2004-09-27  Kim F. Storm  <storm@cua.dk>

	* buffer.c (syms_of_buffer) <indicate-buffer-boundaries>:
	Doc fix.  Format may now be a symbol or alist, not a cons.

	* fringe.c (update_window_fringes): Handle new formats of
	indicate-buffer-boundaries (symbol or alist).  No longer
	allow a simple cons.
	(Ffringe_bitmaps_at_pos): Use nil value for no bitmap.

2004-09-25  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* config.in: Rebuild.

2004-09-24  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* config.in: Rebuild.

	* Makefile.in: Run setarch i386 ./temacs if exec-shield  is present.

2004-09-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c (x_term_init): Work around a bug in some X servers.

2004-09-18  Richard M. Stallman  <rms@gnu.org>

	* buffer.c (syms_of_buffer) <default-major-mode>: Doc fix.

	* xdisp.c (try_window_reusing_current_matrix):
	Handle the case where we reach the old displayed text,
	out of sync with the old line boundary.

2004-09-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Finsert_file_contents): Fix case of replacement in a
	narrowed buffer.

2004-09-14  Kim F. Storm  <storm@cua.dk>

	* puresize.h (PURESIZE_RATIO): Define based on BITS_PER_EMACS_INT.

	* xfaces.c (Qface_no_inherit): New var.
	(syms_of_xfaces): Intern and staticpro it.
	(Finternal_make_lisp_face, Finternal_set_lisp_face_attribute)
	(Finternal_copy_lisp_face, update_face_from_frame_parameter):
	Don't increment face_change_count when face has non-nil
	face-no-inherit property.

2004-09-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* bytecode.c (BYTE_CODE_QUIT): Add missing AFTER_POTENTIAL_GC.
	(Fbyte_code): Remove dead code after `wrong_type_argument'.

	* alloc.c (Fgarbage_collect): Mark keyboards, gtk data, and specpdl
	before doing the mark_stack_check_gcpros since they're not on the stack.

2004-09-12  Kim F. Storm  <storm@cua.dk>

	* editfns.c (Fformat): Handle format strings with multiple text
	properties.  Reverse text property list from the format string,
	so the positions are in increasing order.

2004-09-10  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xselect.c (x_reply_selection_request): XSync and UNBLOCK before
	x_uncatch_errors so that possible protocol errors are delivered.

2004-09-10  Eli Zaretskii  <eliz@gnu.org>

	* Makefile.in (msdos.o): Depend on buffer.h, commands.h, and
	blockinput.h.
	(dosfns.o): Depend on blockinput.h, window.h, dispextern.h,
	charset.h, and coding.h
	(w16select.o): Depend on buffer.h, charset.h, coding.h, and composite.h.
	(term.o): Depend on window.h and keymap.h.
	(abbrev.o): Depend on syntax.h.
	(callint.o): Depend on keymap.h.
	(casefiddle.o): Depend on charset.h and keymap.h.
	(category.o): Depend on keymap.h.
	(coding.o): Depend on dispextern.h.
	(cmds.o): Depend on keyboard.h and keymap.h.
	(dispnew.o): Depend on indent.h and intervals.h.
	(doc.o): Depend on keymap.h.
	(editfns.o): Depend on frame.h.
	(emacs.o): Depend on dispextern.h.
	(fileio.o): Don't depend on ccl.h.
	(filelock.o): Depend on charset.h and coding.h.
	(frame.o): Depend on w32term.h and macterm.h.
	(insdel.o): Depend on region-cache.h.
	(keyboard.o): Depend on keymap.h, w32term.h, and macterm.h.
	(minibuf.o): Depend on $(INTERVALS_SRC) and keymap.h.
	(search.o): Depend on $(INTERVALS_SRC).
	(syntax.o): Depend on keymap.h, regex.h, and $(INTERVALS_SRC).
	(window.o): Depend on keymap.h, blockinput.h, $(INTERVALS_SRC),
	xterm.h, w32term.h, and macterm.h.
	(xdisp.o): Depend on keyboard.h, $(INTERVALS_SRC), xterm.h,
	w32term.h, and macterm.h.
	(xfaces.o): Depend on keyboard.h, $(INTERVALS_SRC),
	region-cache.h, xterm.h, w32term.h, and macterm.h.
	(bytecode.o): Depend on dispextern.h, frame.h, and xterm.h.
	(data.o): Depend on frame.h.
	(fns.o): Depend on keymap.h, xterm.h, and blockinput.h.
	(print.o): Depend on termchar.h and $(INTERVALS_SRC).
	(lread.o): Depend on $(INTERVALS_SRC), termhooks.h, and coding.h.
	(intervals.o): Depend on keymap.h.

	* msdos.c (msdos_set_cursor_shape, IT_display_cursor):
	Add debugging print-out to termscript.

2004-09-09  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (decode_mode_spec): Use current buffer for most purposes.

2004-09-08  Richard M. Stallman  <rms@gnu.org>

	* window.c (Fset_window_buffer): Doc fix.

	* xdisp.c (Fformat_mode_line): New arg BUFFER says which buffer to use.

2004-09-08  Dan Nicolaescu  <dann@ics.uci.edu>

	* minibuf.c (history_delete_duplicates): New variable.
	(read_minibuf): Use it.
	(syms_of_minibuf): Create the corresponding lisp variable.

2004-09-08  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (set_cursor_from_row): Also look at 'cursor' property in
	overlay just before point.

2004-09-07  Luc Teirlinck  <teirllm@auburn.edu>

	* buffer.h (struct buffer): Add auto_save_file_format field.
	* buffer.c (reset_buffer, init_buffer_once):
	Handle auto_save_file_format field.
	(syms_of_buffer): Add DEFVAR_PER_BUFFER for
	`buffer-auto-save-file-format'.
	* fileio.c: Delete declaration for removed Vauto_save_file_format.
	(build_annotations): Adapt to replacement of
	`auto-save-file-format' with the new buffer-local variable
	`buffer-auto-save-file-format'.
	(syms_of_fileio): Delete DEFVAR_LISP for auto-save-file-format.

2004-09-07  Jason Rumney  <jasonr@gnu.org>

	* w32term.h (AppendMenuW_Proc): Move declaration from w32menu.c.

	* w32fns.c (w32_wnd_proc) [WM_MEASUREITEM, WM_DRAWITEM]:
	Handle Unicode menu titles.

2004-09-07  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (set_cursor_from_row): Fix last change.  Only use 'cursor'
	property from text property or overlay strings at point.

2004-09-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xmenu.c (update_submenu_strings): YAILOM.
	(set_frame_menubar): Make sure last_i is initialized.

2004-09-03  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (_widget_value): Add lname and lkey.
	(digest_single_submenu): Set lname and lkey in widget_value
	instead of name and key.
	(update_submenu_strings): New function.
	(set_frame_menubar): Remove call to inhibit_garbage_collection,
	call update_submenu_strings.

	* w32menu.c (globals_of_w32menu): Check for Unicode API.
	(digest_single_submenu, w32_menu_show): Encode menu strings as
	UTF-8 if Unicode API is available.
	(utf8to16): New function.
	(add_menu_item): Use it when calling Unicode API.

2004-09-03  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (set_cursor_from_row): Look for non-nil `cursor' property
	in overlay or text-property strings; set cursor on corresponding
	glyph rather than at end of the string.

2004-09-02  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (x_real_positions): Save the current window port and
	set a new one before obtaining the global coordinate.
	Use FRAME_MAC_WINDOW.
	(x_set_name, x_set_title): Encode title to UTF8.
	Use SetWindowTitleWithCFString.
	(Fx_server_version): Get correct OS version.

	* macmenu.c (add_menu_item): Remove unused variable `i'.
	Don't let separator items destroy refence constants of other menu items.

	* macterm.c (x_update_end): Move SetPortWindowPort to inside
	BLOCK_INPUT.
	(x_set_offset): Use FRAME_MAC_WINDOW.

	* xdisp.c (note_mouse_highlight): Set the mouse pointer shape to
	nontext_cursor if it is on a scroll bar.

	* s/darwin.h (LIBS_CARBON): New define to specify libraries for
	Carbon support.
	(LD_SWITCH_SYSTEM_TEMACS): Don't link with unused libstdc++.
	Use LIBS_CARBON.

2004-09-02  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (x_set_name_internal): New function.  Check if we shall call
	xfree before ENCODE_UTF_8.
	(x_set_name, x_set_title): Call x_set_name_internal.

2004-08-31  NAKAMURA Toshikazu  <nr-tkz@nifty.com>  (tiny change)

	* w32fns.c (w32_load_font): If a BDF font is already loaded, do not
	reload it.

2004-08-30  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* macmenu.c (_widget_value): Add lname and lkey.
	(single_submenu): Set lname and lkey in widget_value
	instead of name and key.
	(update_submenu_strings): New function.
	(set_frame_menubar): Remove call to inhibit_garbage_collection,
	call update_submenu_strings.

	* xmenu.c (digest_single_submenu): Set lname and lkey in widget_value
	instead of name and key.
	(update_submenu_strings): New function.
	(set_frame_menubar): Remove call to inhibit_garbage_collection,
	call update_submenu_strings.

	* gtkutil.h (_widget_value): Added lname and lkey.

2004-08-30  Steven Tamm  <steventamm@mac.com>

	* macmenu.c (mac_menu_show): Remove shadowing of menu variable
	by using different names for inner loop variables.

2004-08-27  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xmenu.c (set_frame_menubar): Reintroduce inhibit_garbage_collection
	from 1.233 so that strings from ENCODE_UTF_8 isn't GC:ed before used.

	* gtkutil.c (xg_create_frame_widgets): Compensate for tool bar when
	tool bar items is 0.

2004-08-26  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (ENCODE_MENU_STRING): Added to handle multibyte
	strings in menu items.
	(single_submenu): Use ENCODE_MENU_STRING
	(mac_menu_show): Use ENCODE_MENU_STRING.  Reset grabbed because
	button release isn't passed to event loop
	(add_menu_item): Use SetMenuItemWithCFString

2004-08-26  Steven Tamm  <steventamm@mac.com>

	* fileio.c (Fread_file_name): Call x_file_dialog on carbon on
	tool-bar/menu click.
	* macfns.c (Fx_file_dialog): Implement using NavServices.

2004-08-24  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (x_catch_errors_unwind): Do not XSync if display has closed.

	* xfns.c (x_window_to_frame, x_any_window_to_frame)
	(x_non_menubar_window_to_frame, x_menubar_window_to_frame)
	(x_top_window_to_frame): Return 0 if wdesc is None.

2004-08-22  Richard M. Stallman  <rms@gnu.org>

	* process.c (process_send_signal) [SIGNALS_VIA_CHARACTERS,
	HAVE_TERMIOS]: If there's no char for this signal, drop through
	and use system calls.

	* bytecode.c (Fbyte_code) <unwind-protect>: Cannot GC.

2004-08-20  Kim F. Storm  <storm@cua.dk>

	* process.c (wait_reading_process_output): Rename from
	wait_reading_process_input.  All uses changed.
	(wait_reading_process_output_1): Rename from
	wait_reading_process_input_1.  All uses changed.

	* dispnew.c (Fsleep_for): Remove obsolete code.

2004-08-20  Kenichi Handa  <handa@m17n.org>

	* syntax.c (skip_chars): Fix for unibyte case.

2004-08-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (char_quoted): Mixup byte/char pos.
	(back_comment): Fixup globals in all cases.

2004-08-19  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (x_set_name, x_set_title): Encode title to UTF8 before
	passing it to gtk_window_set_title.

2004-08-19  Kim F. Storm  <storm@cua.dk>

	* process.c (wait_reading_process_input): Clean up.
	Add wait_for_cell, wait_proc, and just_wait_proc args
	to avoid overloading `read_kbd' and `do_display' args.
	Change read_kbd arg to int.  All callers changed.

	* process.c (process_send_signal): Use CDISABLE.

	* sysdep.c (child_setup_tty, init_sys_modes): Use CDISABLE.

2004-08-18  Kim F. Storm  <storm@cua.dk>

	* process.c (Faccept_process_output): Add arg JUST-THIS-ONE;
	forward to wait_reading_process_input via DO_DISPLAY arg.
	(wait_reading_process_input): If DO_DISPLAY < 0 for a process
	object, only process output from that process; also inhibit
	running timers if DO_DISPLAY==-2.

2004-08-17  Kim F. Storm  <storm@cua.dk>

	* process.c (process_send_signal): Fix last change--use
	_POSIX_VDISABLE instead of CVDISABLE when available.

2004-08-16  Richard M. Stallman  <rms@gnu.org>

	* sysdep.c (child_setup_tty) [SIGNALS_VIA_CHARACTERS]:
	Set VQUIT and VINTR chars to the standard ones if they are unset.
	[AIX]: Don't do that here.  And don't force VINTR to standard
	when SIGNALS_VIA_CHARACTERS.

	* process.c (process_send_signal)
	[SIGNALS_VIA_CHARACTERS, HAVE_TERMIOS]:	Clean up.
	Do nothing if the character is CVDISABLE.

	* xfaces.c (merge_face_ref): Specifying `unspecified' is a no-op.

	* intervals.c (move_if_not_intangible):
	Force POSITION to be between BEGV and ZV.

2004-08-14  John Paul Wallington  <jpw@gnu.org>

	* buffer.c (Frestore_buffer_modified_p): Doc fix.

	* fileio.c (Fread_file_name): Doc fix.

	* minibuf.c (syms_of_minibuf) <completion-ignore-case>: Doc fix.

2004-08-09  Luc Teirlinck  <teirllm@auburn.edu>

	* keymap.c (Fmake_keymap, Fmap_keymap, Fwhere_is_internal): Doc fixes.

2004-08-08  Luc Teirlinck  <teirllm@auburn.edu>

	* keyboard.c: Declare Qdisabled_command_function instead of
	Qdisabled_command_hook.
	(Fcommand_execute): Use Qdisabled_command_function instead of
	Qdisabled_command_hook.
	(syms_of_keyboard): Ditto.

2004-08-07  Luc Teirlinck  <teirllm@auburn.edu>

	* keymap.c (Flocal_key_binding, Fglobal_key_binding)
	(syms_of_keymap) <key-translation-map>: Doc fixes.

2004-08-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (window_list_1): YAILOM.

	* fileio.c (make_temp_name): Handle multibyte prefixes.

2004-08-06  Luc Teirlinck  <teirllm@auburn.edu>

	* keyboard.c (syms_of_keyboard) <overriding-terminal-local-map>:
	Doc fix.

2004-08-03  Kenichi Handa  <handa@m17n.org>

	* coding.c (decode_coding_string): Adjust coding->consumed, and
	etc. with shrinked_bytes.

2004-08-03  Kim F. Storm  <storm@cua.dk>

	* indent.c (compute_motion): Fix check for full width window
	in non-window case.  Do not count left truncation glyph on
	window systems.

2004-08-02  Luc Teirlinck  <teirllm@auburn.edu>

	* data.c (Finteractive_form): Doc fix.

2004-08-02  Kim F. Storm  <storm@cua.dk>

	* indent.c (compute_motion): Use actual window width if WIDTH is -1,
	properly accounting for continuation glyph on non-window systems.
	(Fcompute_motion): Use actual window width if WIDTH is nil, and
	actual window width/height if TOPOS is nil, properly accounting for
	continuation glyphs on non-window systems, and optional header lines.
	(vmotion): Let compute_motion calculate actual window width.

	* window.c (window_scroll_line_based): Let compute_motion
	calculate actual window width.

2004-08-02  Kim F. Storm  <storm@cua.dk>

	* process.c (read_process_output): Use whole read buffer.
	Don't trigger adaptive read buffering on errors.

2004-07-31  Luc Teirlinck  <teirllm@auburn.edu>

	* keymap.c (Fset_keymap_parent, Fdefine_prefix_command): Doc fixes.

	* keyboard.c (syms_of_keyboard) <disable-point-adjustment>: Doc fix.

	* callint.c (Fcall_interactively): Doc fix.

2004-07-30  Richard M. Stallman  <rms@gnu.org>

	* abbrev.c (Fexpand_abbrev): Undo previous change.

2004-07-30  Kim F. Storm  <storm@cua.dk>

	* editfns.c (Fformat): Allocate extra (dummy) element in info.

2004-07-28  Luc Teirlinck  <teirllm@auburn.edu>

	* eval.c (Fdefvar, Fdefconst): Doc fixes.

2004-07-27  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (move_it_in_display_line_to): Check BUFFER_POS_REACHED_P after
	we have ensured that the glyph fits on the current line (or returned
	MOVE_LINE_CONTINUED otherwise).

2004-07-26  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (move_it_in_display_line_to): If overflow-newline-into-fringe
	is enabled, return MOVE_LINE_CONTINUED rather than MOVE_POS_MATCH_OR_ZV
	if target position is at end of display line but char is not a newline.

2004-07-25  Richard M. Stallman  <rms@gnu.org>

	* window.c (coordinates_in_window): Return ON_SCROLL_BAR
	instead of ON_VERTICAL_BORDER, when on scroll bar.
	(Fcoordinates_in_window_p): Handle ON_SCROLL_BAR--return nil.

	* dispextern.h (enum window_part): Add ON_SCROLL_BAR.

	* window.c (Fcoordinates_in_window_p):
	Take account of FRAME_INTERNAL_BORDER_WIDTH.

	* alloc.c (check_cons_list): New function (contents commented out).

2004-07-24  Luc Teirlinck  <teirllm@auburn.edu>

	* xfaces.c (Fcolor_supported_p): Doc fix.

	* frame.c (Fselect_frame, Fset_frame_selected_window)
	(Fframe_visible_p, Fraise_frame): Doc fixes.

2004-07-24  Richard M. Stallman  <rms@gnu.org>

	* keyboard.h (not_single_kboard_state): Declare.

	* fileio.c (Fwrite_region): Doc fix.

	* window.c (Fwindow_at): Take account of FRAME_INTERNAL_BORDER_WIDTH.

	* abbrev.c (Fexpand_abbrev): Run Qpre_abbrev_expand_hook
	only when a real abbrev is present.

	* xfns.c (x_icon_verify): New function.
	(Fx_create_frame): Use it.

2004-07-22  Barry Fishman  <barry_fishman@att.net>  (tiny change)

	* s/gnu-linux.h: Use GC_MARK_STACK if __amd64__ is defined.

2004-07-21  Kim F. Storm  <storm@cua.dk>

	* window.h (struct glyph_matrix): New members nrows_scale_factor
	and ncols_scale_factor.

	* window.c (make_window): Initialize nrows_scale_factor and
	ncols_scale_factor members.

	* dispnew.c (margin_glyphs_to_reserve): Apply ncols_scale_factor.
	(allocate_matrices_for_frame_redisplay): Fix left/right margin mix-up.
	(required_matrix_height): Apply nrows_scale_factor.
	(required_matrix_width): Apply ncols_scale_factor.

	* xdisp.c (display_line): Increment nrows_scale_factor and set
	fonts_changed_p if past last allocated row.
	(append_glyph, append_composite_glyph, produce_image_glyph)
	(append_stretch_glyph): Increment ncols_scale_factor and set
	fonts_changed_p if current area is full.

2004-07-21  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* widget.c (EmacsFrameDestroy): Don't abort if normal_gc is 0.

2004-07-19  Luc Teirlinck  <teirllm@auburn.edu>

	* window.c (Fpos_visible_in_window_p, Fset_window_hscroll)
	(Fwindow_inside_pixel_edges, Fwindow_end, Fset_window_point)
	(Fset_window_start, Fscroll_up, Fscroll_down)
	(Fother_window_for_scrolling, Fscroll_other_window)
	(Fsave_window_excursion, Fset_window_vscroll)
	(syms_of_window) <window-size-fixed>: Doc fixes.

2004-07-19  KOBAYASHI Yasuhiro  <kobayays@otsukakj.co.jp>

	* w32fns.c (Fx_file_dialog): Use ENCODE_FILE instead of
	ENCODE_SYSTEM for filenames.

2004-07-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (sys_select): Block input around call to
	ReceiveNextEvent to prevent breakage.  Correctly handle
	blocking on event queue only by calling ReceiveNextEvent
	instead of select (since GUI events aren't on an fd).
	(sys_read): Remove function
	* sysdep.c: Remove redefine of read to sys_read if HAVE_CARBON

2004-07-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (sys_select): Redo sys_select to use alarm-based
	polling instead of 1 sec timeouts (like solaris).

	* macterm.c (x_make_frame_visible): Comment in polling on
	frame creation.

	* keyboard.c: Undef SIGIO on Carbon

	* atimer.c (alarm_signal_handler): Call alarm handlers after
	scheduling.

	* eval.c (Feval): Remove quit_char test

	* process.c (wait_reading_process_input): Remove clearing
	stdin for select call on process input.

2004-07-18  Luc Teirlinck  <teirllm@auburn.edu>

	* xdisp.c (syms_of_xdisp) <window-scroll-functions>: Correct
	capitalization error in docstring.

2004-07-17  Juanma Barranquero  <lektu@terra.es>

	* keyboard.c (not_single_kboard_state): Do nothing unless
	MULTI_KBOARD is defined.

2004-07-17  Richard M. Stallman  <rms@gnu.org>

	* window.c (coordinates_in_window): Inside the window but outside
	its box to the L or R, return ON_VERTICAL_BORDER.
	(window_list_1): Rotate the list to start with WINDOW.

	* print.c (print_preprocess): Test for print_depth at limit
	before entering in being_printed.

	* keyboard.c (not_single_kboard_state): New function.
	(stuff_buffered_input): Now no-op only if no SIGTSTP.

	* frame.c (Fdelete_frame): If we're in single_bboard_state on
	this kboard, and we delete its last frame, go to any_kboard_state.

	* buffer.c (syms_of_buffer) <transient-mark-mode>: Doc fix.

2004-07-15  KOBAYASHI Yasuhiro  <kobayays@otsukakj.co.jp>

	* w32fns.c (Fx_file_dialog): Encode strings in system coding
	system before passing them to OS functions for display.

2004-07-15  David Kastrup  <dak@gnu.org>

	* search.c (syms_of_search): Staticpro `saved_last_thing_searched'.
	Apparently fixes an abort condition.

2004-07-14  Luc Teirlinck  <teirllm@auburn.edu>

	* fileio.c (Fvisited_file_modtime): Return a list of two integers,
	instead of a cons.

2004-07-14  K,Ba(Broly L,Bu(Brentey  <lorentey@elte.hu>

	* keyboard.c (echo_dash): Do nothing if there already is a dash
	at the end of the echo string.

2004-07-12  Kim F. Storm  <storm@cua.dk>

	* alloc.c (mark_object): Only look at Lisp_Misc_Save_Value
	if GC_MARK_STACK.

2004-07-10  Luc Teirlinck  <teirllm@auburn.edu>

	* buffer.c (Fswitch_to_buffer, Fpop_to_buffer): Doc fixes.

	* window.c (Fwindow_buffer, Fother_window,  Fget_lru_window)
	(Fget_largest_window, Fget_buffer_window, Fdelete_windows_on)
	(Freplace_buffer_in_windows, Fset_window_buffer)
	(Fselect-window, Fdisplay-buffer, Fsplit_window): Doc fixes.
	(syms_of_window): Expand docstring of `display-buffer-function'.

2004-07-09  Luc Teirlinck  <teirllm@auburn.edu>

	* editfns.c (Ffloat_time, Fformat_time_string, Fdecode_time)
	(Fcurrent_time_string, Fcurrent_time_zone): Mention in docstrings
	that time values of the type (HIGH . LOW) are considered obsolete.

2004-07-06  Luc Teirlinck  <teirllm@auburn.edu>

	* keyboard.c (syms_of_keyboard): Fix `keyboard-translate-table'
	docstring.

	* fns.c (Fclear_string): Declare `len' before call to CHECK_STRING.

2004-07-06  John Paul Wallington  <jpw@gnu.org>

	* eval.c (Fdefmacro): Signal an error if NAME is not a symbol.

	* fns.c (Fclear_string): Signal an error if STRING is not a string.

2004-07-05  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* macterm.c (mac_initialize_display_info): Use CGGetActiveDisplayList
	instead of CGMainDisplayID (only in OSX 10.2 and later).

2004-07-04  John Paul Wallington  <jpw@gnu.org>

	* fileio.c (read_file_name_completion_ignore_case): New variable.
	(syms_of_fileio): Declare and initialise it.
	(Fread_file_name): Bind `completion-ignore-case' to respect it.

2004-07-03  Eli Zaretskii  <eliz@gnu.org>

	* msdos.c (dos_rawgetc): Use make_number to produce Lisp objects
	for event.x and event.y.

2004-07-01  Kenichi Handa  <handa@m17n.org>

	* w32select.c (Fw32_set_clipboard_data): Update `nbytes' correctly
	after getting a new string by pre-write-conversion.

2004-06-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c (x_detect_focus_change): Remove unused var `nr_events'.
	(x_calc_absolute_position): Remove unused var `child'.

	* xfaces.c (x_supports_face_attributes_p)
	(Fdisplay_supports_face_attributes_p): YAILOM.
	(tty_supports_face_attributes_p): Remove unused var `i'.

	* syntax.c (skip_chars): Remove unused labels fwd_unibyte_ok and
	back_unibyte_ok.

	* search.c (match_limit, Fmatch_data, Fset_match_data): YAILOM.

	* fontset.c (Fset_fontset_font): Remove unused vars `family' and `registry'.

	* Makefile.in (${etc}DOC): Fix file name of make-docfile.

2004-06-30  Andreas Schwab  <schwab@suse.de>

	* image.c (CHECK_LIB_AVAILABLE): Add third parameter LIBRARIES.
	(Finit_image_library): Pass LIBRARIES through to
	CHECK_LIB_AVAILABLE.  Declare parameters.  Doc fix.
	(lookup_image_type): Pass Qnil as second argument to
	Finit_image_library.

	* lisp.h (Finit_image_library): Declare.

2004-06-29  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (do_window_activate, do_window_deactivate): Remove.
	(XTread_socket): Send mouse button events to the toolbox
	dispatcher even when the mouse is grabbed.  Don't process window
	activate events for non-Emacs windows.	Replace function calls to
	do_window_activate and do_window_deactivate with their contents.
	Reset mouse grabbing status when a window is deactivated.

2004-06-29  Steven Tamm  <steventamm@mac.com>

	* macterm.c (mac_get_emulated_btn)
	(mac_event_to_emacs_modifiers): Fix emulated mouse button
	support to correctly mask out modifiers.

2004-06-29  David Kastrup  <dak@gnu.org>

	* search.c (Fset_match_data): Allow buffer before end of list
	which can happen if set-match-data is using a pre-consed list.

2004-06-28  Steven Tamm  <steventamm@mac.com>

	* macterm.c (XTread_socket): Correctly set the frame position
	after the window is moved.

2004-06-28  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_image_for_pixmap): Call g_object_unref on
	gpix and gmask just before return to avoid memory leak.
	(xg_get_image_for_pixmap): Add workaround for monochrome displays
	so insensitive and activated icons look ok.

2004-06-27  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (file_dialog_callback): Disable edit control if set
	to directories only on CDN_INITDONE message.
	(Fx_file_dialog): Default to directories only when prompt starts
	with "Dired".

2004-06-25  Kim F. Storm  <storm@cua.dk>

	* alloc.c (allocate_misc): Update total_free_markers.
	(free_misc): New function.
	(safe_alloca_unwind, free_marker): Use it.

	* lisp.h (free_misc): Add prototype.

	* fns.c (Fmapconcat, Fmapcar): Remove superfluous GCPROs.

2004-06-24  Richard M. Stallman  <rms@gnu.org>

	* emacs.c (Vsignal_USR1_hook, Vsignal_USR2_hook): Definitions deleted.
	(syms_of_emacs): Lisp variables deleted.

2004-06-23  David Kastrup  <dak@gnu.org>

	* search.c (Freplace_match): Adjust the match-data more thoroughly
	when replacing strings in the buffer.
	(Fmatch_data): When INTEGERS is non-nil and the last match was in
	a buffer, add the buffer as last element to the match data.
	(Fset_match_data): If an additional element of the match-data is a
	buffer, restore it to last_thing_searched.
	(save_search_regs): Save last_thing_searched as part of the match data.
	(restore_match_data): Restore it again.

2004-06-23  Luc Teirlinck  <teirllm@auburn.edu>

	* keymap.c (Ftext_char_description): Doc fix.
	* doc.c (Fsnarf_documentation): Doc fix.

2004-06-22  Kim F. Storm  <storm@cua.dk>

